<div align="center">
  <a href="https://varlet.gitee.io/varlet-ui-vue2/">
    <img src="https://varlet.gitee.io/varlet-ui-vue2/logo.svg" width="150">
  </a>
  <h1>VARLET-VUE2</h1>
  <p>基于 Vue2 的 Material design 风格移动端组件库</p>
   <p>
    <a href="https://varlet-vue2.vercel.app">文档(Vercel)</a> | 
    <a href="https://varlet.gitee.io/varlet-ui-vue2">文档(Gitee)</a> |
    <a href="https://github.com/varletjs/varlet/blob/dev/README.md">ENGLISH README</a>
  </p>
  <p>
    <img src="https://img.shields.io/npm/v/@varlet-vue2/ui?style=flat-square" alt="version">
    <img src="https://img.shields.io/github/stars/varletjs/varlet-vue2" alt="ci">
    <img src="https://img.shields.io/badge/vue-v2.6.14-%23407fbc" alt="vue">
    <img src="https://img.shields.io/npm/l/@varlet-vue2/ui.svg" alt="licence">
    <img src="https://img.shields.io/codecov/c/github/varletjs/varlet-vue2" alt="coverage">
    <img src="https://img.badgesize.io/https://unpkg.com/@varlet-vue2/ui/umd/varlet.js?compression=gzip&label=gzip" alt="gzip" />
    <img src="https://github.com/varletjs/varlet-vue2/workflows/CI/badge.svg" alt="ci">
  </p>
</div>

---

### 介绍

`Varlet-vue2` 是 `Varlet` 的 vue2 版本, 是一个 Material 风格移动端组件库，由社区建立起来的组件库团队进行维护。

### 特性
- 🚀 提供50个高质量通用组件 
- 🚀 组件十分轻量
- 💪 由国人开发，完善的中英文文档和后勤保障
- 🛠️ 支持按需引入
- 🛠️ 支持主题定制
- 🌍 支持国际化
- 💡 支持 webstorm，vscode 组件属性高亮
- 💪 支持 SSR
- 💡 支持 Typescript 
- 💪 确保90%以上单元测试覆盖率，提供稳定性保证
- 🛠️ 支持暗黑模式

### 安装

### CDN
`varlet.js` 包含组件库的所有样式和逻辑，引入即可。

```html
<div id="app"></div>
<script src="https://cdn.jsdelivr.net/npm/vue@2.6.14"></script>
<script src="https://cdn.jsdelivr.net/npm/@varlet-vue2/ui/umd/varlet.js"></script>
<script>
  Vue.use(Varlet)

  new Vue({
    template: '<var-button>按钮</var-button>'
  }).$mount('#app')
</script>
```

### Webpack / Vite
```shell
# 通过 npm 或 yarn 或 pnpm 安装
# npm
npm i @varlet-vue2/ui -S

# yarn
yarn add @varlet-vue2/ui

# pnpm
pnpm add @varlet-vue2/ui
```

```js
import App from './App.vue'
import Varlet from '@varlet-vue2/ui'
import Vue from 'vue'
import '@varlet-vue2/ui/es/style.js'

Vue.use(Varlet)

new Vue({
  render: (h) => h(App)
}).$mount('#app')
```

### 贡献者

<a href="https://github.com/varletjs/varlet-vue2/graphs/contributors">
  <img src="https://contrib.rocks/image?repo=varletjs/varlet-vue2" />
</a> 

### 仓库状态

本仓库不再进行特性更新，只做 bug 修复，推荐使用 [Varlet Vue3 版本](https://github.com/varletjs/varlet)
