//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import Ripple from '../ripple';
import VarPopup from '../popup';
import VarIcon from '../icon';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { dt } from '../utils/shared';
import { pack } from '../locale';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('var-popup', {
    staticClass: "var-action-sheet__popup-radius",
    attrs: {
      "position": "bottom",
      "overlay": _vm.overlay,
      "overlay-class": _vm.overlayClass,
      "overlay-style": _vm.overlayStyle,
      "lock-scroll": _vm.lockScroll,
      "close-on-click-overlay": _vm.closeOnClickOverlay,
      "teleport": _vm.teleport,
      "show": _vm.popupShow
    },
    on: {
      "open": function ($event) {
        return _vm.$emit('open');
      },
      "close": function ($event) {
        return _vm.$emit('close');
      },
      "closed": function ($event) {
        return _vm.$emit('closed');
      },
      "opened": function ($event) {
        return _vm.$emit('opened');
      },
      "route-change": function ($event) {
        return _vm.$emit('route-change');
      },
      "update:show": function (value) {
        return _vm.$emit('update:show', value);
      }
    }
  }, [_c('div', _vm._b({
    staticClass: "var-action-sheet var--box"
  }, 'div', _vm.$attrs, false), [_vm._t("title", function () {
    return [_c('div', {
      staticClass: "var-action-sheet__title"
    }, [_vm._v(_vm._s(_vm.dt(_vm.title, _vm.pack.actionSheetTitle)))])];
  }), _vm._v(" "), _vm._t("actions", function () {
    return _vm._l(_vm.actions, function (action) {
      return _c('div', {
        directives: [{
          name: "ripple",
          rawName: "v-ripple",
          value: {
            disabled: action.disabled
          },
          expression: "{ disabled: action.disabled }"
        }],
        key: action.name,
        staticClass: "var-action-sheet__action-item",
        class: [action.className, action.disabled ? 'var-action-sheet--disabled' : null],
        style: {
          color: action.color
        },
        on: {
          "click": function ($event) {
            return _vm.handleSelect(action);
          }
        }
      }, [action.icon ? _c('var-icon', {
        staticClass: "var-action-sheet__action-icon",
        attrs: {
          "var-action-sheet-cover": "",
          "name": action.icon,
          "size": action.iconSize
        }
      }) : _vm._e(), _vm._v(" "), _c('div', {
        staticClass: "var-action-sheet__action-name"
      }, [_vm._v(_vm._s(action.name))])], 1);
    });
  })], 2)]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarActionSheet',
  directives: {
    Ripple
  },
  components: {
    VarPopup,
    VarIcon
  },
  inheritAttrs: false,
  props,
  data: () => ({
    popupShow: false
  }),
  computed: {
    pack() {
      return pack.value;
    }

  },
  watch: {
    show: {
      handler(newValue) {
        this.popupShow = newValue;
      },

      immediate: true
    }
  },
  methods: {
    dt,

    handleSelect(action) {
      if (action.disabled) {
        return;
      }

      this.$emit('select', action);
      this.closeOnClickAction && this.$emit('update:show', false);
    }

  }
});