function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import VarActionSheet from './ActionSheet.js'
import Vue from 'vue';
import { inBrowser, isNumber, isString } from '../utils/shared';
import { mountComponent } from '../utils/components';
var singletonInstance;

function ActionSheet(options) {
  if (!inBrowser()) {
    return Promise.resolve();
  }

  return new Promise(resolve => {
    ActionSheet.close();
    var actionSheetOptions = isString(options) || isNumber(options) ? {
      message: String(options)
    } : options;
    var {
      instance,
      unmount
    } = mountComponent(VarActionSheet, 'body', {
      propsData: _extends({}, actionSheetOptions)
    });
    instance.show = true;
    singletonInstance = instance;
    instance.$on('select', action => {
      actionSheetOptions.onSelect == null ? void 0 : actionSheetOptions.onSelect(action);
      resolve(action);
    });
    instance.$on('open', () => {
      actionSheetOptions.onOpen == null ? void 0 : actionSheetOptions.onOpen();
    });
    instance.$on('opened', () => {
      actionSheetOptions.onOpened == null ? void 0 : actionSheetOptions.onOpened();
    });
    instance.$on('close', () => {
      actionSheetOptions.onClose == null ? void 0 : actionSheetOptions.onClose();
      resolve('close');
    });
    instance.$on('closed', () => {
      actionSheetOptions.onClosed == null ? void 0 : actionSheetOptions.onClosed();
      unmount();
      singletonInstance === actionSheetOptions && (singletonInstance = null);
    });
    instance.$on('route-change', () => {
      unmount();
      singletonInstance === actionSheetOptions && (singletonInstance = null);
    });
    instance.$on('update:show', value => {
      instance.show = value;
    });
    instance.show = true;
  });
}

ActionSheet.Component = VarActionSheet;

VarActionSheet.install = function (app) {
  app.component(VarActionSheet.name, VarActionSheet);
};

ActionSheet.close = () => {
  if (singletonInstance != null) {
    var prevSingletonOptions = singletonInstance;
    singletonInstance = null;
    Vue.nextTick().then(() => {
      prevSingletonOptions.show = false;
    });
  }
};

ActionSheet.install = function (app) {
  app.component(VarActionSheet.name, VarActionSheet);
};

export var _ActionSheetComponent = VarActionSheet;
export default ActionSheet;