//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import VarButton from '../button';
import VarIcon from '../icon';
import { props } from './props';
import { isString, easeInOutCubic, throttle, isObject } from '../utils/shared';
import { getScrollTop, getScrollLeft, scrollTo, getParentScroller, toPxNum, toSizeUnit } from '../utils/elements';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "backTopEl",
    staticClass: "var-back-top",
    class: [_vm.show ? 'var-back-top--active' : null],
    style: {
      right: _vm.toSizeUnit(_vm.right),
      bottom: _vm.toSizeUnit(_vm.bottom)
    },
    on: {
      "click": function ($event) {
        $event.stopPropagation();
        return _vm.click.apply(null, arguments);
      }
    }
  }, [_vm._t("default", function () {
    return [_c('var-button', {
      attrs: {
        "type": "primary",
        "round": "",
        "var-back-top-cover": ""
      }
    }, [_c('var-icon', {
      attrs: {
        "name": "chevron-up"
      }
    })], 1)];
  })], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarBackTop',
  components: {
    VarButton,
    VarIcon
  },
  props,
  data: () => ({
    show: false,
    localTarget: undefined,
    throttleScroll: null
  }),

  mounted() {
    this.throttleScroll = throttle(this.scroll, 200);
    this.localTarget = this.target ? this.getTarget() : getParentScroller(this.$refs.backTopEl);
    this.localTarget.addEventListener('scroll', this.throttleScroll);
  },

  destroyed() {
    this.localTarget.removeEventListener('scroll', this.throttleScroll);
  },

  methods: {
    toSizeUnit,

    click(e) {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onClick) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, e);
      var left = getScrollLeft(this.localTarget);
      scrollTo(this.localTarget, {
        left,
        duration: this.duration,
        animation: easeInOutCubic
      });
    },

    scroll() {
      this.show = getScrollTop(this.localTarget) >= toPxNum(this.visibilityHeight);
    },

    getTarget() {
      if (isObject(this.target)) {
        return this.target;
      }

      if (isString(this.target)) {
        var el = document.querySelector(this.target);

        if (!el) {
          throw Error('[Varlet] BackTop: target element cannot found');
        }

        return el;
      }

      throw Error('[Varlet] BackTop: type of prop "target" should be a selector or an element object');
    }

  }
});