//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import Ripple from '../ripple';
import VarLoading from '../loading';
import { defineComponent } from '../utils/create';
import { props } from './props';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('button', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: _vm.disabled || !_vm.ripple
      },
      expression: "{ disabled: disabled || !ripple }"
    }],
    staticClass: "var-button var--box",
    class: ["var-button--" + _vm.size, _vm.block ? 'var--flex var-button--block' : 'var--inline-flex', _vm.disabled ? 'var-button--disabled' : null, _vm.text ? "var-button--text-" + _vm.type : "var-button--" + _vm.type, _vm.text ? 'var-button--text' : 'var-elevation--2', _vm.text && _vm.disabled ? 'var-button--text-disabled' : null, _vm.round ? 'var-button--round' : null, _vm.outline ? 'var-button--outline' : null],
    style: {
      color: _vm.textColor,
      background: _vm.color
    },
    attrs: {
      "disabled": _vm.disabled
    },
    on: {
      "click": _vm.handleClick,
      "touchstart": _vm.handleTouchstart
    }
  }, [_vm.loading || _vm.pending ? _c('var-loading', {
    staticClass: "var-button__loading",
    attrs: {
      "var-button-cover": "",
      "type": _vm.loadingType,
      "size": _vm.loadingSize,
      "radius": _vm.loadingRadius
    }
  }) : _vm._e(), _vm._v(" "), _c('div', {
    staticClass: "var-button__content",
    class: [_vm.loading || _vm.pending ? 'var-button--hidden' : null]
  }, [_vm._t("default")], 2)], 1);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarButton',
  components: {
    VarLoading
  },
  directives: {
    Ripple
  },
  props,
  data: () => ({
    pending: false
  }),
  methods: {
    attemptAutoLoading(result) {
      if (this.autoLoading) {
        this.pending = true;
        Promise.resolve(result).finally(() => {
          this.pending = false;
        });
      }
    },

    handleClick(e) {
      var {
        loading,
        disabled,
        pending
      } = this;
      var {
        onClick
      } = this.getListeners();

      if (!onClick || loading || disabled || pending) {
        return;
      }

      this.attemptAutoLoading(onClick(e));
    },

    handleTouchstart(e) {
      var {
        loading,
        disabled,
        pending
      } = this;
      var {
        onTouchstart
      } = this.getListeners();

      if (!onTouchstart || loading || disabled || pending) {
        return;
      }

      this.attemptAutoLoading(onTouchstart(e));
    }

  }
});