import { props as loadingProps } from '../loading/props';
import { pickProps } from '../utils/components';

function typeValidator(type) {
  return ['default', 'primary', 'info', 'success', 'warning', 'danger'].includes(type);
}

function sizeValidator(size) {
  return ['normal', 'mini', 'small', 'large'].includes(size);
}

export var props = {
  type: {
    type: String,
    default: 'default',
    validator: typeValidator
  },
  size: {
    type: String,
    default: 'normal',
    validator: sizeValidator
  },
  loading: {
    type: Boolean,
    default: false
  },
  round: {
    type: Boolean,
    default: false
  },
  block: {
    type: Boolean,
    default: false
  },
  text: {
    type: Boolean,
    default: false
  },
  outline: {
    type: Boolean,
    default: false
  },
  disabled: {
    type: Boolean,
    default: false
  },
  ripple: {
    type: Boolean,
    default: true
  },
  color: {
    type: String
  },
  textColor: {
    type: String
  },
  autoLoading: {
    type: Boolean,
    default: false
  },
  loadingRadius: {
    type: [Number, String],
    default: 12
  },
  loadingType: pickProps(loadingProps, 'type'),
  loadingSize: pickProps(loadingProps, 'size')
};