//
//
//
//
//
//
//
//
//
import VarFormDetails from '../form-details';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { uniq } from '../utils/shared';
import { ValidationMixin } from '../utils/mixins/validation';
import { createParentMixin, createChildrenMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-checkbox-group__wrap"
  }, [_c('div', {
    staticClass: "var-checkbox-group",
    class: ["var-checkbox-group--" + _vm.direction]
  }, [_vm._t("default")], 2), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarCheckboxGroup',
  components: {
    VarFormDetails
  },
  mixins: [ValidationMixin, createParentMixin('checkboxGroup', {
    childrenKey: 'checkboxes'
  }), createChildrenMixin('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  props,
  computed: {
    checkedCount() {
      return this.value.length;
    },

    checkboxGroupErrorMessage() {
      return this.errorMessage;
    }

  },
  watch: {
    value: {
      handler() {
        this.syncCheckboxes();
      },

      deep: true
    },

    checkboxes() {
      this.syncCheckboxes();
    }

  },
  methods: {
    // expose
    checkAll() {
      var _this$getListeners$on, _this$getListeners;

      var checkedValues = this.checkboxes.map(_ref => {
        var {
          checkedValue
        } = _ref;
        return checkedValue;
      });
      this.resetWithAnimation();
      var changedModelValue = uniq(checkedValues);
      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, changedModelValue);
      return changedModelValue;
    },

    // expose
    inverseAll() {
      var _this$checkboxes, _this$getListeners$on2, _this$getListeners2;

      var checkedValues = (_this$checkboxes = this.checkboxes) == null ? void 0 : _this$checkboxes.filter(_ref2 => {
        var {
          checked
        } = _ref2;
        return !checked;
      }).map(_ref3 => {
        var {
          checkedValue
        } = _ref3;
        return checkedValue;
      });
      this.resetWithAnimation();
      var changedModelValue = uniq(checkedValues);
      (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, changedModelValue);
      return changedModelValue;
    },

    // expose
    reset() {
      var _this$getListeners$on3, _this$getListeners3;

      (_this$getListeners$on3 = (_this$getListeners3 = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on3.call(_this$getListeners3, []);
      this.resetValidation();
    },

    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    resetWithAnimation() {
      this.checkboxes.forEach(checkbox => {
        checkbox.withAnimation = false;
      });
    },

    validateWithTrigger(trigger) {
      this.$nextTick(() => {
        var {
          validateTrigger,
          rules,
          value
        } = this;

        this._validateWithTrigger(validateTrigger, trigger, rules, value);
      });
    },

    change(changedValue) {
      var _this$getListeners$on4, _this$getListeners4, _this$getListeners$on5, _this$getListeners5;

      (_this$getListeners$on4 = (_this$getListeners4 = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on4.call(_this$getListeners4, changedValue);
      (_this$getListeners$on5 = (_this$getListeners5 = this.getListeners()).onChange) == null ? void 0 : _this$getListeners$on5.call(_this$getListeners5, changedValue);
      this.validateWithTrigger('onChange');
    },

    onChecked(changedValue) {
      var {
        value
      } = this;

      if (!value.includes(changedValue)) {
        this.change([...value, changedValue]);
      }
    },

    onUnchecked(changedValue) {
      var _this$value;

      if (!this.value.includes(changedValue)) {
        return;
      }

      this.change((_this$value = this.value) == null ? void 0 : _this$value.filter(value => value !== changedValue));
    },

    syncCheckboxes() {
      var _this$checkboxes2;

      (_this$checkboxes2 = this.checkboxes) == null ? void 0 : _this$checkboxes2.forEach(_ref4 => {
        var {
          sync
        } = _ref4;
        sync(this.value);
      });
    }

  }
});