//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import { isPlainObject } from '../utils/shared';
import { props } from './props';
import { toSizeUnit } from '../utils/elements';
import { createChildrenMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-col var--box",
    class: [_vm.span ? "var-col--span-" + _vm.span : null, _vm.offset ? "var-col--offset-" + _vm.offset : null].concat(_vm.getSize('xs', _vm.xs), _vm.getSize('sm', _vm.sm), _vm.getSize('md', _vm.md), _vm.getSize('lg', _vm.lg), _vm.getSize('xl', _vm.xl)),
    style: {
      paddingLeft: _vm.toSizeUnit(_vm.padding.left),
      paddingRight: _vm.toSizeUnit(_vm.padding.right)
    },
    on: {
      "click": _vm.handleClick
    }
  }, [_vm._t("default")], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarCol',
  mixins: [createChildrenMixin('row', {
    childrenKey: 'cols'
  })],
  props,
  data: () => ({
    padding: {
      left: 0,
      right: 0
    },
    toSizeUnit
  }),
  watch: {
    span: {
      handler() {
        this.row.computePadding();
      },

      immediate: true
    }
  },
  methods: {
    handleClick(e) {
      var {
        getListeners
      } = this;
      var {
        onClick
      } = getListeners();

      if (!onClick) {
        return;
      }

      onClick(e);
    },

    setPadding(pad) {
      this.padding = pad;
    },

    getSize(mode, size) {
      var classes = [];

      if (!size) {
        return classes;
      }

      if (isPlainObject(size)) {
        var {
          span,
          offset
        } = size;
        span && classes.push("var-col--span-" + mode + "-" + span);
        offset && classes.push("var-col--offset-" + mode + "-" + offset);
      } else {
        classes.push("var-col--span-" + mode + "-" + size);
      }

      return classes;
    }

  }
});