//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import { requestAnimationFrame } from '../utils/elements';
import { isArray } from '../utils/shared';
import { props } from './props';
import VarIcon from '../icon';
import { createChildrenMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    class: {
      'var-collapse-item': true,
      'var-collapse-item__active': _vm.offset && _vm.isShow,
      'var-collapse-item__disable': _vm.disabled
    }
  }, [_c('div', {
    staticClass: "var-collapse-item-header",
    on: {
      "click": function ($event) {
        return _vm.toggle();
      }
    }
  }, [_c('div', {
    staticClass: "var-collapse-item-header__title"
  }, [_vm._t("title", function () {
    return [_vm._v(_vm._s(_vm.title))];
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-collapse-item-header__icon"
  }, [_vm._t("icon", function () {
    return [_c('var-icon', {
      class: {
        'var-collapse-item-header__icon': true,
        'var-collapse-item-header__open': _vm.isShow && _vm.icon === 'chevron-down',
        'var-collapse-item-header__disable': _vm.disabled
      },
      attrs: {
        "name": _vm.icon,
        "transition": 250
      }
    })];
  })], 2)]), _vm._v(" "), _c('div', {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.show,
      expression: "show"
    }],
    ref: "contentEl",
    staticClass: "var-collapse-item-content",
    on: {
      "transitionend": _vm.transitionend
    }
  }, [_c('div', {
    staticClass: "var-collapse-item__wrap"
  }, [_vm._t("default")], 2)])]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarCollapseItem',
  mixins: [createChildrenMixin('collapse', {
    parentKey: 'collapse',
    childrenKey: 'collapseItems'
  })],
  components: {
    VarIcon
  },
  props,
  data: () => ({
    show: false,
    isShow: false
  }),
  computed: {
    offset() {
      return this.collapse.offset;
    }

  },
  watch: {
    isShow(newValue) {
      if (newValue) this.openPanel();else this.closePanel();
    }

  },
  methods: {
    init(accordion, show) {
      if (this.collapse.active === undefined || accordion && isArray(this.collapse.active) || show === this.isShow) return;
      this.isShow = show;
      this.toggle(true);
    },

    toggle(initOrAccordion) {
      if (this.disabled) return;

      if (!initOrAccordion) {
        this.collapse.updateItem(this.name || this.collapse.index, !this.isShow);
      }
    },

    openPanel() {
      if (!this.$refs.contentEl) return;
      this.$refs.contentEl.style.height = '';
      this.show = true;
      this.$nextTick(() => {
        var {
          offsetHeight
        } = this.$refs.contentEl;
        this.$refs.contentEl.style.height = 0 + 'px';
        requestAnimationFrame(() => {
          this.$refs.contentEl.style.height = offsetHeight + 'px';
        });
      });
    },

    closePanel() {
      if (!this.$refs.contentEl) return;
      this.$refs.contentEl.style.height = 0 + 'px';
    },

    transitionend() {
      if (!this.isShow) {
        this.show = false;
        this.$refs.contentEl.style.height = '';
      }
    }

  }
});