//
//
//
//
//
//
import { defineComponent, nextTick } from '../utils/create';
import { props } from './props';
import { isArray } from '../utils/shared';
import { createParentMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-collapse"
  }, [_vm._t("default")], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarCollapse',
  mixins: [createParentMixin('collapse', {
    childrenKey: 'collapseItems'
  })],
  props,
  data: () => ({}),
  computed: {
    active() {
      return this.value;
    }

  },
  watch: {
    collapseItems() {
      nextTick().then(this.resize());
    },

    value() {
      nextTick().then(this.resize());
    }

  },
  methods: {
    checkValue() {
      if (!this.accordion && !isArray(this.value)) {
        console.error('[Varlet] Collapse: type of prop "value" should be an Array');
        return false;
      }

      if (this.accordion && isArray(this.value)) {
        console.error('[Varlet] Collapse: type of prop "value" should be a String or Number');
        return false;
      }

      return true;
    },

    getValue(value, isExpand) {
      if (!this.checkValue()) return null;
      if (isExpand) return this.accordion ? value : [...this.value, value];
      return this.accordion ? null : this.value.filter(name => name !== value);
    },

    updateItem(value, isExpand) {
      var _this$getListeners$on, _this$getListeners, _this$getListeners$on2, _this$getListeners2;

      var modelValue = this.getValue(value, isExpand);
      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, modelValue);
      (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners()).onChange) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, modelValue);
    },

    matchName() {
      if (this.accordion) {
        return this.collapseItems.find(_ref => {
          var {
            name
          } = _ref;
          return this.value === name;
        });
      }

      var filterItem = this.collapseItems.filter(_ref2 => {
        var {
          name
        } = _ref2;
        if (name === undefined) return false;
        return this.value.includes(name);
      });
      return filterItem.length ? filterItem : undefined;
    },

    matchIndex() {
      if (this.accordion) {
        return this.collapseItems.find(_ref3 => {
          var {
            index,
            name
          } = _ref3;
          return name === undefined ? this.value === index : false;
        });
      }

      return this.collapseItems.filter(_ref4 => {
        var {
          index,
          name
        } = _ref4;
        return name === undefined ? this.value.includes(index) : false;
      });
    },

    resize() {
      if (!this.checkValue()) return;
      var matchProviders = this.matchName() || this.matchIndex();

      if (this.accordion && !matchProviders || !this.accordion && !matchProviders.length) {
        this.collapseItems.forEach(provider => {
          provider.init(this.accordion, false);
        });
        return;
      }

      this.collapseItems.forEach(provider => {
        var isShow = this.accordion ? matchProviders === provider : matchProviders.includes(provider);
        provider.init(this.accordion, isShow);
      });
    }

  }
});