function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import Vue from 'vue';
import context from '.';
export function resolveLock() {
  var lockCounts = Object.keys(context.locks).length;
  lockCounts <= 0 ? document.body.classList.remove('m--lock') : document.body.classList.add('m--lock');
}
export function addLock(uid) {
  Vue.set(context.locks, uid, 1);
  resolveLock();
}
export function releaseLock(uid) {
  delete context.locks[uid];
  resolveLock();
}
export function createLockMixin(state, use) {
  var propWatcher = use ? {
    [use](newValue) {
      if (!newValue) {
        releaseLock(this._uid);
      } else if (newValue && this[state]) {
        addLock(this._uid);
      }
    }

  } : {};
  return {
    watch: _extends({}, propWatcher, {
      [state](newValue) {
        if (use && !this[use]) {
          return;
        }

        if (newValue) {
          addLock(this._uid);
        } else {
          releaseLock(this._uid);
        }
      }

    }),

    beforeMount() {
      if (use && !this[use]) {
        return;
      }

      if (this[state]) {
        addLock(this._uid);
      }
    },

    beforeDestroy() {
      if (use && !this[use]) {
        return;
      }

      if (this[state]) {
        releaseLock(this._uid);
      }
    },

    activated() {
      if (use && !this[use]) {
        return;
      }

      if (this[state]) {
        addLock(this._uid);
      }
    },

    deactivated() {
      if (use && !this[use]) {
        return;
      }

      if (this[state]) {
        releaseLock(this._uid);
      }
    }

  };
}