//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import dayjs from 'dayjs/esm';
import isSameOrBefore from 'dayjs/esm/plugin/isSameOrBefore';
import isSameOrAfter from 'dayjs/esm/plugin/isSameOrAfter';
import PanelHeader from './panel-header.js'
import VarButton from '../../button';
import { defineComponent } from '../../utils/create';
import { WEEK_HEADER } from '../props';
import { toNumber } from '../../utils/shared';
import { pack } from '../../locale';
dayjs.extend(isSameOrBefore);
dayjs.extend(isSameOrAfter);

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-day-picker__panel"
  }, [_c('div', {
    staticClass: "var-day-picker__content"
  }, [_c('panel-header', {
    ref: "headerEl",
    attrs: {
      "type": "day",
      "date": _vm.preview,
      "disabled": _vm.panelBtnDisabled
    },
    on: {
      "check-panel": _vm.clickMonth,
      "check-date": _vm.checkDate
    }
  }), _vm._v(" "), _c('transition', {
    attrs: {
      "name": "var-date-picker" + (_vm.reverse ? '-reverse' : '') + "-translatex"
    }
  }, [_c('div', {
    key: _vm.panelKey
  }, [_c('ul', {
    staticClass: "var-day-picker__head"
  }, _vm._l(_vm.sortWeekList, function (week) {
    return _c('li', {
      key: week.index
    }, [_vm._v(_vm._s(_vm.getDayAbbr(week.index)))]);
  }), 0), _vm._v(" "), _c('ul', {
    staticClass: "var-day-picker__body"
  }, _vm._l(_vm.days, function (day, index) {
    return _c('li', {
      key: index
    }, [_c('var-button', _vm._b({
      staticClass: "var-day-picker__button",
      class: {
        'var-day-picker__button--usable': day > 0
      },
      attrs: {
        "type": "primary",
        "var-day-picker-cover": "",
        "round": "",
        "ripple": false
      },
      on: {
        "click": function (event) {
          return _vm.chooseDay(day, event);
        }
      }
    }, 'var-button', Object.assign({}, _vm.buttonProps(day)), false), [_vm._v("\n              " + _vm._s(_vm.filterDay(day)) + "\n            ")])], 1);
  }), 0)])])], 1)]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'DayPickerPanel',
  components: {
    VarButton,
    PanelHeader
  },
  props: {
    choose: {
      type: Object,
      required: true
    },
    preview: {
      type: Object,
      required: true
    },
    current: {
      type: String,
      required: true
    },
    clickMonth: {
      type: Function,
      required: true
    },
    componentProps: {
      type: Object,
      required: true
    }
  },
  data: () => ({
    days: [],
    reverse: false,
    panelKey: 0,
    panelBtnDisabled: {
      left: false,
      right: false
    }
  }),
  computed: {
    pack() {
      return pack.value;
    },

    currentYear() {
      return this.current.split('-')[0];
    },

    currentMonth() {
      return this.current.split('-')[1];
    },

    currentDay() {
      return this.current.split('-')[2];
    },

    isCurrent() {
      return this.preview.previewYear === this.currentYear && this.preview.previewMonth.index === this.currentMonth;
    },

    isSame() {
      var _this$choose$chooseMo;

      return this.choose.chooseYear === this.preview.previewYear && ((_this$choose$chooseMo = this.choose.chooseMonth) == null ? void 0 : _this$choose$chooseMo.index) === this.preview.previewMonth.index;
    },

    sortWeekList() {
      var index = WEEK_HEADER.findIndex(week => week.index === this.componentProps.firstDayOfWeek);
      if (index === -1 || index === 0) return WEEK_HEADER;
      return WEEK_HEADER.slice(index).concat(WEEK_HEADER.slice(0, index));
    }

  },

  mounted() {
    this.initDate();
    this.initHeader();
  },

  watch: {
    preview() {
      this.initDate();
      this.initHeader();
    }

  },
  methods: {
    getDayAbbr(key) {
      var _this$pack$datePicker, _this$pack$datePicker2;

      return (_this$pack$datePicker = (_this$pack$datePicker2 = this.pack.datePickerWeekDict) == null ? void 0 : _this$pack$datePicker2[key].abbr) != null ? _this$pack$datePicker : '';
    },

    filterDay(day) {
      return day > 0 ? day : '';
    },

    initDate() {
      var {
        preview: {
          previewMonth,
          previewYear
        }
      } = this;
      var monthNum = dayjs(previewYear + "-" + previewMonth.index).daysInMonth();
      var firstDayToWeek = dayjs(previewYear + "-" + previewMonth.index + "-01").day();
      var index = this.sortWeekList.findIndex(week => week.index === "" + firstDayToWeek);
      this.days = [...Array(index).fill(-1), ...Array.from(Array(monthNum + 1).keys())].filter(value => value);
    },

    initHeader() {
      var {
        preview: {
          previewYear,
          previewMonth
        },
        componentProps: {
          max,
          min
        }
      } = this;

      if (max) {
        var date = previewYear + "-" + (toNumber(previewMonth.index) + 1);
        this.panelBtnDisabled.right = !dayjs(date).isSameOrBefore(dayjs(max), 'month');
      }

      if (min) {
        var _date = previewYear + "-" + (toNumber(previewMonth.index) - 1);

        this.panelBtnDisabled.left = !dayjs(_date).isSameOrAfter(dayjs(min), 'month');
      }
    },

    inRange(day) {
      var {
        preview: {
          previewYear,
          previewMonth
        },
        componentProps: {
          min,
          max
        }
      } = this;
      var isBeforeMax = true;
      var isAfterMin = true;
      var previewDate = previewYear + "-" + previewMonth.index + "-" + day;
      if (max) isBeforeMax = dayjs(previewDate).isSameOrBefore(dayjs(max), 'day');
      if (min) isAfterMin = dayjs(previewDate).isSameOrAfter(dayjs(min), 'day');
      return isBeforeMax && isAfterMin;
    },

    shouldChoose(val) {
      var {
        choose: {
          chooseDays,
          chooseRangeDay
        },
        componentProps: {
          range
        }
      } = this;

      if (range) {
        if (!chooseRangeDay.length) return false;
        var isBeforeMax = dayjs(val).isSameOrBefore(dayjs(chooseRangeDay[1]), 'day');
        var isAfterMin = dayjs(val).isSameOrAfter(dayjs(chooseRangeDay[0]), 'day');
        return isBeforeMax && isAfterMin;
      }

      return chooseDays.includes(val);
    },

    buttonProps(day) {
      if (day < 0) {
        return {
          text: true,
          outline: false,
          textColor: ''
        };
      }

      var {
        choose: {
          chooseDay
        },
        preview: {
          previewYear,
          previewMonth
        },
        componentProps: {
          allowedDates,
          color,
          multiple,
          range
        },
        shouldChoose,
        isSame,
        inRange,
        isCurrent,
        currentDay
      } = this;
      var val = previewYear + "-" + previewMonth.index + "-" + day;

      var dayExist = () => {
        if (range || multiple) return shouldChoose(val);
        return toNumber(chooseDay) === day && isSame;
      };

      var computeDisabled = () => {
        if (!inRange(day)) return true;
        if (!allowedDates) return false;
        return !allowedDates(val);
      };

      var disabled = computeDisabled();

      var computeText = () => {
        if (disabled) return true;
        if (range || multiple) return !shouldChoose(val);
        return !isSame || toNumber(chooseDay) !== day;
      };

      var computeOutline = () => {
        // 不满足基本条件，基本条件为当前年、当前月、当前日并且 showCurrent 为true的情况
        if (!(isCurrent && toNumber(currentDay) === day && this.componentProps.showCurrent)) return false; // 存在着 disabled

        if ((range || multiple || isSame) && disabled) return true; // 在选择范围之外

        if (range || multiple) return !shouldChoose(val); // 同一年但是未被选择的情况

        if (isSame) return chooseDay !== currentDay;
        return true;
      };

      var textColorOrCover = () => {
        if (disabled) return '';
        if (computeOutline()) return color != null ? color : '';
        if (dayExist()) return '';
        return 'var-date-picker-color-cover';
      };

      var isCover = textColorOrCover().startsWith('var-date-picker');
      return {
        disabled,
        text: computeText(),
        outline: computeOutline(),
        textColor: isCover ? '' : textColorOrCover(),
        'var-date-picker-color-cover': isCover,
        class: {
          'var-day-picker__button-disabled': disabled
        }
      };
    },

    checkDate(checkType) {
      this.reverse = checkType === 'prev';
      this.panelKey += checkType === 'prev' ? -1 : 1;
      this.$emit('check-preview', 'month', checkType);
    },

    chooseDay(day, event) {
      var buttonEl = event.currentTarget;
      if (buttonEl.classList.contains('var-day-picker__button-disabled')) return;
      this.$emit('choose-day', day);
    },

    forwardRef(checkType) {
      this.$refs.headerEl.checkDate(checkType);
    }

  }
});