//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../../utils/create';
import dayjs from 'dayjs/esm';
import isSameOrBefore from 'dayjs/esm/plugin/isSameOrBefore';
import isSameOrAfter from 'dayjs/esm/plugin/isSameOrAfter';
import { MONTH_LIST } from '../props';
import PanelHeader from './panel-header.js'
import VarButton from '../../button';
import { toNumber } from '../../utils/shared';
import { pack } from '../../locale';
dayjs.extend(isSameOrBefore);
dayjs.extend(isSameOrAfter);

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-month-picker__panel"
  }, [_c('div', {
    staticClass: "var-month-picker__content"
  }, [_c('panel-header', {
    ref: "headerEl",
    attrs: {
      "type": "month",
      "date": _vm.preview,
      "disabled": _vm.panelBtnDisabled
    },
    on: {
      "check-panel": _vm.clickYear,
      "check-date": _vm.checkDate
    }
  }), _vm._v(" "), _c('transition', {
    attrs: {
      "name": "var-date-picker" + (_vm.reverse ? '-reverse' : '') + "-translatex"
    }
  }, [_c('ul', {
    key: _vm.panelKey
  }, _vm._l(_vm.MONTH_LIST, function (month) {
    return _c('li', {
      key: month.index
    }, [_c('var-button', _vm._b({
      staticClass: "var-month-picker__button",
      attrs: {
        "type": "primary",
        "var-month-picker-cover": "",
        "ripple": false
      },
      on: {
        "click": function (event) {
          return _vm.chooseMonth(month, event);
        }
      }
    }, 'var-button', Object.assign({}, _vm.buttonProps(month.index)), false), [_vm._v("\n            " + _vm._s(_vm.getMonthAbbr(month.index)) + "\n          ")])], 1);
  }), 0)])], 1)]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'MonthPickerPanel',
  components: {
    VarButton,
    PanelHeader
  },
  props: {
    choose: {
      type: Object,
      required: true
    },
    preview: {
      type: Object,
      required: true
    },
    current: {
      type: String,
      required: true
    },
    clickYear: {
      type: Function,
      required: true
    },
    componentProps: {
      type: Object,
      required: true
    }
  },
  data: () => ({
    reverse: false,
    panelKey: 0,
    panelBtnDisabled: {
      left: false,
      right: false
    }
  }),
  computed: {
    pack() {
      return pack.value;
    },

    MONTH_LIST() {
      return MONTH_LIST;
    },

    currentYear() {
      return this.current.split('-')[0];
    },

    currentMonth() {
      return this.current.split('-')[1];
    },

    isSameYear() {
      return this.choose.chooseYear === this.preview.previewYear;
    },

    isCurrentYear() {
      return this.preview.previewYear === this.currentYear;
    }

  },
  watch: {
    'preview.previewYear': {
      handler(year) {
        var {
          componentProps: {
            min,
            max
          }
        } = this;
        if (max) this.panelBtnDisabled.right = !dayjs("" + (toNumber(year) + 1)).isSameOrBefore(dayjs(max), 'year');
        if (min) this.panelBtnDisabled.left = !dayjs("" + (toNumber(year) - 1)).isSameOrAfter(dayjs(min), 'year');
      },

      immediate: true
    }
  },
  methods: {
    getMonthAbbr(key) {
      var _this$pack$datePicker, _this$pack$datePicker2;

      return (_this$pack$datePicker = (_this$pack$datePicker2 = this.pack.datePickerMonthDict) == null ? void 0 : _this$pack$datePicker2[key].abbr) != null ? _this$pack$datePicker : '';
    },

    inRange(key) {
      var {
        preview: {
          previewYear
        },
        componentProps: {
          min,
          max
        }
      } = this;
      var isBeforeMax = true;
      var isAfterMin = true;
      var previewDate = previewYear + "-" + key;
      if (max) isBeforeMax = dayjs(previewDate).isSameOrBefore(dayjs(max), 'month');
      if (min) isAfterMin = dayjs(previewDate).isSameOrAfter(dayjs(min), 'month');
      return isBeforeMax && isAfterMin;
    },

    shouldChoose(val) {
      var {
        choose: {
          chooseMonths,
          chooseDays,
          chooseRangeMonth
        },
        componentProps: {
          type,
          range
        }
      } = this;

      if (range) {
        if (!chooseRangeMonth.length) return false;
        var isBeforeMax = dayjs(val).isSameOrBefore(dayjs(chooseRangeMonth[1]), 'month');
        var isAfterMin = dayjs(val).isSameOrAfter(dayjs(chooseRangeMonth[0]), 'month');
        return isBeforeMax && isAfterMin;
      }

      if (type === 'month') return chooseMonths.includes(val);
      return chooseDays.some(value => value.includes(val));
    },

    buttonProps(key) {
      var {
        choose: {
          chooseMonth
        },
        preview: {
          previewYear
        },
        componentProps: {
          allowedDates,
          color,
          multiple,
          range
        },
        shouldChoose,
        isSameYear,
        inRange,
        isCurrentYear,
        currentMonth
      } = this;
      var val = previewYear + "-" + key;

      var monthExist = () => {
        if (range || multiple) return shouldChoose(val);
        return (chooseMonth == null ? void 0 : chooseMonth.index) === key && isSameYear;
      };

      var computeDisabled = () => {
        if (!inRange(key)) return true;
        if (!allowedDates) return false;
        return !allowedDates(val);
      };

      var disabled = computeDisabled();

      var computeText = () => {
        if (disabled) return true;
        if (range || multiple) return !shouldChoose(val);
        return !isSameYear || (chooseMonth == null ? void 0 : chooseMonth.index) !== key;
      };

      var computeOutline = () => {
        // 不满足基本条件， 基本条件为当前年、当前月并且 showCurrent 为true的情况
        if (!(isCurrentYear && currentMonth === key && this.componentProps.showCurrent)) return false; // 存在着 disabled

        if ((range || multiple || isSameYear) && disabled) return true; // 在选择范围之外

        if (range || multiple) return !shouldChoose(val); // 同一年但是未被选择的情况

        if (isSameYear) return (chooseMonth == null ? void 0 : chooseMonth.index) !== currentMonth;
        return true;
      };

      var textColorOrCover = () => {
        if (disabled) return '';
        if (computeOutline()) return color != null ? color : '';
        if (monthExist()) return '';
        return 'var-date-picker-color-cover';
      };

      var isCover = textColorOrCover().startsWith('var-date-picker');
      return {
        disabled,
        outline: computeOutline(),
        text: computeText(),
        color: !computeText() ? color : '',
        textColor: isCover ? '' : textColorOrCover(),
        'var-date-picker-color-cover': isCover,
        class: {
          'var-month-picker__button-disabled': disabled
        }
      };
    },

    chooseMonth(month, event) {
      var buttonEl = event.currentTarget;
      if (buttonEl.classList.contains('var-month-picker__button-disabled')) return;
      this.$emit('choose-month', month);
    },

    checkDate(checkType) {
      this.reverse = checkType === 'prev';
      this.panelKey += checkType === 'prev' ? -1 : 1;
      this.$emit('check-preview', 'year', checkType);
    },

    forwardRef(checkType) {
      this.$refs.headerEl.checkDate(checkType);
    }

  }
});