function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import VarDialog from './Dialog.js'
import Vue from 'vue';
import { inBrowser, isNumber, isString } from '../utils/shared';
import { mountComponent } from '../utils/components';
var singletonInstance;

function Dialog(options) {
  if (!inBrowser()) {
    return Promise.resolve();
  }

  return new Promise(resolve => {
    Dialog.close();
    var dialogOptions = isString(options) || isNumber(options) ? {
      message: String(options)
    } : options;
    var {
      instance,
      unmount
    } = mountComponent(VarDialog, 'body', {
      propsData: _extends({}, dialogOptions, {
        beforeClose: dialogOptions.onBeforeClose
      })
    });
    instance.show = true;
    singletonInstance = instance;
    instance.$on('open', () => dialogOptions.onOpen == null ? void 0 : dialogOptions.onOpen());
    instance.$on('opened', () => dialogOptions.onOpened == null ? void 0 : dialogOptions.onOpened());
    instance.$on('click-overlay', () => dialogOptions.onClickOverlay == null ? void 0 : dialogOptions.onClickOverlay());
    instance.$on('close', () => {
      dialogOptions.onClose == null ? void 0 : dialogOptions.onClose();
      resolve('close');
    });
    instance.$on('closed', () => {
      dialogOptions.onClosed == null ? void 0 : dialogOptions.onClosed();
      unmount();
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('confirm', () => {
      dialogOptions.onConfirm == null ? void 0 : dialogOptions.onConfirm();
      resolve('confirm');
    });
    instance.$on('cancel', () => {
      dialogOptions.onCancel == null ? void 0 : dialogOptions.onCancel();
      resolve('cancel');
    });
    instance.$on('route-change', () => {
      unmount();
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('update:show', value => {
      instance.show = value;
    });
  });
}

Dialog.close = () => {
  if (singletonInstance != null) {
    var prevSingletonInstance = singletonInstance;
    singletonInstance = null;
    Vue.nextTick(() => {
      prevSingletonInstance.show = false;
    });
  }
};

VarDialog.install = function (app) {
  app.component(VarDialog.name, VarDialog);
};

Dialog.install = function (app) {
  app.component(VarDialog.name, VarDialog);
};

Dialog.Component = VarDialog;
export var _DialogComponent = VarDialog;
export default Dialog;