function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import { toSizeUnit } from '../utils/elements';
import { isBool, toNumber } from '../utils/shared';
import { props } from './props';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-divider var--box",
    class: [_vm.vertical ? 'var-divider--vertical' : null, _vm.withText ? 'var-divider--with-text' : null, _vm.isInset ? 'var-divider--inset' : null, _vm.dashed ? 'var-divider--dashed' : null],
    style: _vm.style
  }, [_vm._t("default", function () {
    return [_vm.description ? _c('span', {
      staticClass: "var-divider__text"
    }, [_vm._v(_vm._s(_vm.description))]) : _vm._e()];
  })], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarDivider',
  props,
  data: () => ({
    withText: false
  }),
  computed: {
    isInset() {
      return isBool(this.inset) ? this.inset : true;
    },

    style() {
      var {
        inset,
        vertical,
        margin
      } = this;
      var baseStyle = {
        margin
      };
      if (isBool(inset) || inset === 0) return _extends({}, baseStyle); // -18px -> -18

      var _inset = toNumber(inset); // -18px -> 18px


      var absInsetWithUnit = Math.abs(_inset) + (inset + '').replace(_inset + '', '');
      return vertical ? _extends({}, baseStyle, {
        height: "calc(80% - " + toSizeUnit(absInsetWithUnit) + ")"
      }) : _extends({}, baseStyle, {
        width: "calc(100% - " + toSizeUnit(absInsetWithUnit) + ")",
        left: _inset > 0 ? toSizeUnit(absInsetWithUnit) : toSizeUnit(0)
      });
    }

  },

  mounted() {
    this.checkHasText();
  },

  updated() {
    this.checkHasText();
  },

  methods: {
    checkHasText() {
      this.withText = Boolean(this.hasSlots('default')) || Boolean(this.description);
    }

  }
});