function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { isURL, toNumber } from '../utils/shared';
import { props } from './props';
import { toSizeUnit } from '../utils/elements';
import { defineComponent, nextTick } from '../utils/create';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c(_vm.isURL(_vm.name) ? 'img' : 'i', {
    tag: "component",
    staticClass: "var-icon",
    class: [_vm.namespace + "--set", _vm.isURL(_vm.name) ? 'var-icon__image' : _vm.namespace + "-" + _vm.nextName, _vm.shrinking ? 'var-icon--shrinking' : null],
    style: {
      color: _vm.color,
      transition: "transform " + _vm.toNumber(_vm.transition) + "ms",
      width: _vm.isURL(_vm.name) ? _vm.toSizeUnit(_vm.size) : null,
      height: _vm.isURL(_vm.name) ? _vm.toSizeUnit(_vm.size) : null,
      fontSize: _vm.toSizeUnit(_vm.size)
    },
    attrs: {
      "src": _vm.isURL(_vm.name) ? _vm.nextName : null
    },
    on: {
      "click": _vm.onClickIcon
    }
  });
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarIcon',
  props,
  data: () => ({
    nextName: '',
    shrinking: false
  }),
  watch: {
    name: {
      handler(newName, oldName) {
        var _this = this;

        return _asyncToGenerator(function* () {
          if (oldName == null || toNumber(_this.transition) === 0) {
            _this.nextName = newName;
            return;
          }

          _this.shrinking = true;
          yield nextTick();
          setTimeout(() => {
            oldName != null && (_this.nextName = newName);
            _this.shrinking = false;
          }, toNumber(_this.transition));
        })();
      },

      immediate: true
    }
  },
  methods: {
    toSizeUnit,
    isURL,
    toNumber,

    onClickIcon() {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onClick) == null ? void 0 : _this$getListeners$on.call(_this$getListeners);
    }

  }
});