//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import VarSwipe from '../swipe';
import VarSwipeItem from '../swipe-item';
import VarIcon from '../icon';
import VarPopup from '../popup';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { toNumber } from '../utils/shared';
var DISTANCE_OFFSET = 12;
var EVENT_DELAY = 200;
var ANIMATION_DURATION = 200;

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('var-popup', {
    staticClass: "var-image-preview__popup",
    attrs: {
      "var-image-preview-cover": "",
      "transition": "var-fade",
      "show": _vm.popupShow,
      "overlay": false,
      "close-on-click-overlay": false,
      "lock-scroll": _vm.lockScroll,
      "teleport": _vm.teleport
    },
    on: {
      "open": function ($event) {
        return _vm.$emit('open');
      },
      "close": function ($event) {
        return _vm.$emit('close');
      },
      "closed": function ($event) {
        return _vm.$emit('closed');
      },
      "opened": function ($event) {
        return _vm.$emit('opened');
      },
      "route-change": function ($event) {
        return _vm.$emit('route-change');
      }
    }
  }, [_c('var-swipe', _vm._b({
    staticClass: "var-image-preview__swipe",
    attrs: {
      "var-image-preview-cover": "",
      "touchable": _vm.canSwipe,
      "indicator": _vm.indicator && _vm.images.length > 1,
      "initial-index": _vm.initialIndex,
      "loop": _vm.loop
    },
    on: {
      "change": function (index) {
        return _vm.$emit('change', index);
      }
    },
    scopedSlots: _vm._u([{
      key: "default",
      fn: function () {
        return _vm._l(_vm.images, function (image) {
          return _c('var-swipe-item', {
            key: image,
            staticClass: "var-image-preview__swipe-item",
            attrs: {
              "var-image-preview-cover": ""
            }
          }, [_c('div', {
            staticClass: "var-image-preview__zoom-container",
            style: {
              transform: "scale(" + _vm.scale + ") translate(" + _vm.translateX + "px, " + _vm.translateY + "px)",
              transitionTimingFunction: _vm.transitionTimingFunction,
              transitionDuration: _vm.transitionDuration
            },
            on: {
              "touchstart": _vm.handleTouchstart,
              "touchmove": _vm.handleTouchmove,
              "touchend": _vm.handleTouchend
            }
          }, [_c('img', {
            staticClass: "var-image-preview__image",
            attrs: {
              "src": image,
              "alt": image
            }
          })])]);
        });
      },
      proxy: true
    }, {
      key: "indicator",
      fn: function (ref) {
        var index = ref.index;
        var length = ref.length;
        return [_vm._t("indicator", function () {
          return [_vm.indicator && _vm.images.length > 1 ? _c('div', {
            staticClass: "var-image-preview__indicators"
          }, [_vm._v("\n          " + _vm._s(index + 1) + " / " + _vm._s(length) + "\n        ")]) : _vm._e()];
        }, {
          "index": index,
          "length": length
        })];
      }
    }], null, true)
  }, 'var-swipe', _vm.$attrs, false)), _vm._v(" "), _vm._t("close-icon", function () {
    return [_vm.closeable ? _c('var-icon', {
      staticClass: "var-image-preview__close-icon",
      attrs: {
        "name": "close-circle",
        "var-image-preview-cover": ""
      },
      on: {
        "click": _vm.close
      }
    }) : _vm._e()];
  }), _vm._v(" "), _c('div', {
    staticClass: "var-image-preview__extra"
  }, [_vm._t("extra")], 2)], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarImagePreview',
  components: {
    VarSwipe,
    VarSwipeItem,
    VarPopup,
    VarIcon
  },
  inheritAttrs: false,
  props,
  data: () => ({
    popupShow: false,
    scale: 1,
    translateX: 0,
    translateY: 0,
    transitionTimingFunction: undefined,
    transitionDuration: undefined,
    canSwipe: true,
    startTouch: null,
    prevTouch: null,
    checker: null
  }),
  computed: {
    initialIndex() {
      var {
        images,
        current
      } = this;
      var index = images.findIndex(image => image === current);
      return index >= 0 ? index : 0;
    }

  },
  watch: {
    show: {
      handler(newValue) {
        this.popupShow = newValue;
      },

      immediate: true
    }
  },
  methods: {
    getDistance(touch, target) {
      var {
        clientX: touchX,
        clientY: touchY
      } = touch;
      var {
        clientX: targetX,
        clientY: targetY
      } = target;
      return Math.abs(Math.sqrt(Math.pow(targetX - touchX, 2) + Math.pow(targetY - touchY, 2)));
    },

    createVarTouch(touches, target) {
      return {
        clientX: touches.clientX,
        clientY: touches.clientY,
        timestamp: Date.now(),
        target
      };
    },

    zoomIn() {
      this.scale = toNumber(this.zoom);
      this.canSwipe = false;
      this.prevTouch = null;
      window.setTimeout(() => {
        this.transitionTimingFunction = 'linear';
        this.transitionDuration = '0s';
      }, ANIMATION_DURATION);
    },

    zoomOut() {
      this.scale = 1;
      this.translateX = 0;
      this.translateY = 0;
      this.canSwipe = true;
      this.prevTouch = null;
      this.transitionTimingFunction = undefined;
      this.transitionDuration = undefined;
    },

    isDoubleTouch(currentTouch) {
      if (!this.prevTouch) {
        return false;
      }

      return this.getDistance(this.prevTouch, currentTouch) <= DISTANCE_OFFSET && currentTouch.timestamp - this.prevTouch.timestamp <= EVENT_DELAY && this.prevTouch.target === currentTouch.target;
    },

    isTapTouch(target) {
      if (!target || !this.startTouch || !this.prevTouch) {
        return false;
      }

      return this.getDistance(this.startTouch, this.prevTouch) <= DISTANCE_OFFSET && (target === this.startTouch.target || target.parentNode === this.startTouch.target);
    },

    handleTouchend(event) {
      this.checker = window.setTimeout(() => {
        this.isTapTouch(event.target) && this.close();
        this.startTouch = null;
      }, EVENT_DELAY);
    },

    handleTouchstart(event) {
      this.checker && window.clearTimeout(this.checker);
      var {
        touches
      } = event;
      var currentTouch = this.createVarTouch(touches[0], event.currentTarget);
      this.startTouch = currentTouch;

      if (this.isDoubleTouch(currentTouch)) {
        this.scale > 1 ? this.zoomOut() : this.zoomIn();
        return;
      }

      this.prevTouch = currentTouch;
    },

    getZoom(target) {
      var {
        offsetWidth,
        offsetHeight
      } = target;
      var {
        naturalWidth,
        naturalHeight
      } = target.querySelector('.var-image-preview__image');
      return {
        width: offsetWidth,
        height: offsetHeight,
        imageRadio: naturalHeight / naturalWidth,
        rootRadio: offsetHeight / offsetWidth,
        zoom: toNumber(this.zoom)
      };
    },

    getLimitX(target) {
      var {
        zoom,
        imageRadio,
        rootRadio,
        width,
        height
      } = this.getZoom(target);

      if (!imageRadio) {
        return 0;
      }

      var displayWidth = imageRadio > rootRadio ? height / imageRadio : width;
      return Math.max(0, (zoom * displayWidth - width) / 2) / zoom;
    },

    getLimitY(target) {
      var {
        zoom,
        imageRadio,
        rootRadio,
        width,
        height
      } = this.getZoom(target);

      if (!imageRadio) {
        return 0;
      }

      var displayHeight = imageRadio > rootRadio ? height : width * imageRadio;
      return Math.max(0, (zoom * displayHeight - height) / 2) / zoom;
    },

    getMoveTranslate(current, move, limit) {
      if (current + move >= limit) {
        return limit;
      }

      if (current + move <= -limit) {
        return -limit;
      }

      return current + move;
    },

    handleTouchmove(event) {
      if (!this.prevTouch) {
        return;
      }

      var target = event.currentTarget;
      var {
        touches
      } = event;
      var currentTouch = this.createVarTouch(touches[0], target);

      if (this.scale > 1) {
        var moveX = currentTouch.clientX - this.prevTouch.clientX;
        var moveY = currentTouch.clientY - this.prevTouch.clientY;
        var limitX = this.getLimitX(target);
        var limitY = this.getLimitY(target);
        this.translateX = this.getMoveTranslate(this.translateX, moveX, limitX);
        this.translateY = this.getMoveTranslate(this.translateY, moveY, limitY);
      }

      this.prevTouch = currentTouch;
    },

    close() {
      if (this.scale > 1) {
        this.zoomOut();
        window.setTimeout(() => this.$emit('update:show', false), ANIMATION_DURATION);
        return;
      }

      this.$emit('update:show', false);
    }

  }
});