function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import VarImagePreview from './ImagePreview.js'
import Vue from 'vue';
import { inBrowser, isArray, isString } from '../utils/shared';
import { mountComponent } from '../utils/components';
var singletonInstance;

function ImagePreview(options) {
  if (!inBrowser()) {
    return;
  }

  ImagePreview.close();
  var imagePreviewOptions = isString(options) ? {
    images: [options]
  } : isArray(options) ? {
    images: options
  } : options;
  var {
    instance,
    unmount
  } = mountComponent(VarImagePreview, 'body', {
    propsData: _extends({}, imagePreviewOptions)
  });
  instance.show = true;
  singletonInstance = instance;
  instance.$on('open', () => imagePreviewOptions.onOpen == null ? void 0 : imagePreviewOptions.onOpen());
  instance.$on('opened', () => imagePreviewOptions.onOpened == null ? void 0 : imagePreviewOptions.onOpened());
  instance.$on('close', () => imagePreviewOptions.onClose == null ? void 0 : imagePreviewOptions.onClose());
  instance.$on('closed', () => {
    imagePreviewOptions.onClosed == null ? void 0 : imagePreviewOptions.onClosed();
    unmount();
    singletonInstance === imagePreviewOptions && (singletonInstance = null);
  });
  instance.$on('change', index => {
    imagePreviewOptions.onChange == null ? void 0 : imagePreviewOptions.onChange(index);
  });
  instance.$on('route-change', () => {
    unmount();
    singletonInstance === instance && (singletonInstance = null);
  });
  instance.$on('update:show', value => {
    instance.show = value;
  });
  instance.show = true;
}

ImagePreview.close = () => {
  if (singletonInstance != null) {
    var prevSingletonInstance = singletonInstance;
    singletonInstance = null;
    Vue.nextTick(() => {
      prevSingletonInstance.show = false;
    });
  }
};

VarImagePreview.install = function (app) {
  app.component(VarImagePreview.name, VarImagePreview);
};

ImagePreview.install = function (app) {
  app.component(VarImagePreview.name, VarImagePreview);
};

ImagePreview.Component = VarImagePreview;
export var _ImagePreviewComponent = VarImagePreview;
export default ImagePreview;