//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import Ripple from '../ripple';
import Lazy from '../lazy';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { toSizeUnit } from '../utils/elements';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: !_vm.ripple
      },
      expression: "{ disabled: !ripple }"
    }],
    staticClass: "var-image var--box",
    class: [!_vm.block ? 'var--inline-block' : null],
    style: {
      width: _vm.toSizeUnit(_vm.width),
      height: _vm.toSizeUnit(_vm.height),
      'border-radius': _vm.toSizeUnit(_vm.radius)
    }
  }, [_vm.lazy ? _c('img', {
    directives: [{
      name: "lazy",
      rawName: "v-lazy",
      value: _vm.src,
      expression: "src"
    }],
    staticClass: "var-image__image",
    style: {
      objectFit: _vm.fit
    },
    attrs: {
      "alt": _vm.alt,
      "lazy-error": _vm.error,
      "lazy-loading": _vm.loading
    },
    on: {
      "load": _vm.handleLoad,
      "error": _vm.handleError,
      "click": _vm.handleClick
    }
  }) : _c('img', {
    staticClass: "var-image__image",
    style: {
      objectFit: _vm.fit
    },
    attrs: {
      "alt": _vm.alt,
      "src": _vm.src
    },
    on: {
      "load": _vm.handleLoad,
      "error": _vm.handleError,
      "click": _vm.handleClick
    }
  })]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarImage',
  directives: {
    Lazy,
    Ripple
  },
  props,
  methods: {
    toSizeUnit,

    handleLoad(e) {
      var el = e.currentTarget;
      var {
        lazy
      } = this;
      var {
        onLoad,
        onError
      } = this.getListeners();

      if (lazy) {
        el._lazy.state === 'success' && (onLoad == null ? void 0 : onLoad(e));
        el._lazy.state === 'error' && (onError == null ? void 0 : onError(e));
      } else {
        onLoad == null ? void 0 : onLoad(e);
      }
    },

    handleClick(e) {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onClick) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, e);
    },

    handleError(e) {
      var {
        lazy
      } = this;
      var {
        onError
      } = this.getListeners();
      !lazy && (onError == null ? void 0 : onError(e));
    }

  }
});