function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import VarLoading from '../loading';
import Ripple from '../ripple';
import { defineComponent, nextTick } from '../utils/create';
import { getParentScroller, toPxNum } from '../utils/elements';
import { props } from './props';
import { isNumber, dt } from '../utils/shared';
import { pack } from '../locale';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "listEl",
    staticClass: "var-list var--box"
  }, [_vm._t("default"), _vm._v(" "), _vm.loading ? _vm._t("loading", function () {
    return [_c('div', {
      staticClass: "var-list__loading"
    }, [_c('div', {
      staticClass: "var-list__loading-text"
    }, [_vm._v(_vm._s(_vm.dt(_vm.loadingText, _vm.pack.listLoadingText)))]), _vm._v(" "), _c('var-loading', {
      attrs: {
        "size": "mini",
        "radius": 10
      }
    })], 1)];
  }) : _vm._e(), _vm._v(" "), _vm.finished ? _vm._t("finished", function () {
    return [_c('div', {
      staticClass: "var-list__finished"
    }, [_vm._v(_vm._s(_vm.dt(_vm.finishedText, _vm.pack.listFinishedText)))])];
  }) : _vm._e(), _vm._v(" "), _vm.error ? _vm._t("error", function () {
    return [_c('div', {
      directives: [{
        name: "ripple",
        rawName: "v-ripple"
      }],
      staticClass: "var-list__error",
      on: {
        "click": _vm.load
      }
    }, [_vm._v("\n      " + _vm._s(_vm.dt(_vm.errorText, _vm.pack.listErrorText)) + "\n    ")])];
  }) : _vm._e(), _vm._v(" "), _c('div', {
    ref: "detectorEl",
    staticClass: "var-list__detector"
  })], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarList',
  directives: {
    Ripple
  },
  components: {
    VarLoading
  },
  props,
  data: () => ({
    scroller: ''
  }),
  computed: {
    pack() {
      return pack.value;
    }

  },

  mounted() {
    this.scroller = getParentScroller(this.$refs.listEl);
    this.immediateCheck && this.check();
    this.scroller.addEventListener('scroll', this.check);
  },

  beforeDestroy() {
    this.scroller.removeEventListener('scroll', this.check);
  },

  methods: {
    // expose
    check() {
      var _this = this;

      return _asyncToGenerator(function* () {
        yield nextTick();

        if (!_this.loading && !_this.finished && !_this.error && _this.isReachBottom()) {
          _this.load();
        }
      })();
    },

    isNumber,
    dt,

    load() {
      var _this$getListeners$on, _this$getListeners, _this$getListeners$on2, _this$getListeners2, _this$getListeners$on3, _this$getListeners3;

      (_this$getListeners$on = (_this$getListeners = this.getListeners())['onUpdate:error']) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, false);
      (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners())['onUpdate:loading']) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, true);
      (_this$getListeners$on3 = (_this$getListeners3 = this.getListeners()).onLoad) == null ? void 0 : _this$getListeners$on3.call(_this$getListeners3);
    },

    isReachBottom() {
      var containerBottom = this.scroller === window ? window.innerHeight : this.scroller.getBoundingClientRect().bottom;
      var {
        bottom
      } = this.$refs.detectorEl.getBoundingClientRect(); // The fractional part of the detectorBottom when bottoming out overflows
      // https://github.com/varletjs/varlet/issues/310
      // alert(this.$refs.detectorEl)

      return Math.floor(bottom) - toPxNum(this.offset) <= containerBottom;
    }

  }
});