function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import Vue from 'vue';
import zhCN from './zh-CN';

function useLocale() {
  var packs = {};
  var pack = Vue.observable({
    value: {}
  });

  var add = (lang, pack) => {
    pack.lang = lang;
    packs[lang] = pack;
  };

  var use = lang => {
    if (!packs[lang]) {
      console.warn("The " + lang + " does not exist. You can mount a language package using the add method");
      return {};
    }

    pack.value = packs[lang];
  };

  var merge = (lang, pack) => {
    if (!packs[lang]) {
      console.warn("The " + lang + " does not exist. You can mount a language package using the add method");
      return;
    }

    packs[lang] = _extends({}, packs[lang], pack);
    use(lang);
  };

  return {
    packs,
    pack,
    add,
    use,
    merge
  };
}

var {
  packs,
  pack,
  add,
  use,
  merge
} = useLocale();
add('zh-CN', zhCN);
use('zh-CN');
export { packs, pack, add, use, merge, useLocale };
export var _LocaleComponent = {
  packs,
  pack,
  add,
  use,
  merge,
  useLocale
};
export default {
  packs,
  pack,
  add,
  use,
  merge,
  useLocale
};