function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import VarPicker from './Picker.js'
import Vue from 'vue';
import { isArray } from '../utils/shared';
import { mountComponent } from '../utils/components';
var singletonInstance;

function Picker(options) {
  return new Promise(resolve => {
    Picker.close();
    var pickerOptions = isArray(options) ? {
      columns: options
    } : options;
    var {
      instance,
      unmount
    } = mountComponent(VarPicker, 'body', {
      propsData: _extends({}, pickerOptions, {
        dynamic: true
      })
    });
    instance.show = true;
    singletonInstance = instance;
    instance.$on('open', () => pickerOptions.onOpen == null ? void 0 : pickerOptions.onOpen());
    instance.$on('opened', () => pickerOptions.onOpened == null ? void 0 : pickerOptions.onOpened());
    instance.$on('close', () => {
      pickerOptions.onClose == null ? void 0 : pickerOptions.onClose();
      resolve({
        state: 'close'
      });
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('closed', () => {
      pickerOptions.onClosed == null ? void 0 : pickerOptions.onClosed();
      unmount();
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('change', (texts, indexes) => {
      pickerOptions.onChange == null ? void 0 : pickerOptions.onChange(texts, indexes);
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('confirm', (texts, indexes) => {
      pickerOptions.onConfirm == null ? void 0 : pickerOptions.onConfirm(texts, indexes);
      resolve({
        state: 'confirm',
        texts,
        indexes
      });
      instance.show = false;
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('cancel', (texts, indexes) => {
      pickerOptions.onCancel == null ? void 0 : pickerOptions.onCancel(texts, indexes);
      resolve({
        state: 'cancel',
        texts,
        indexes
      });
      instance.show = false;
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('route-change', () => {
      unmount();
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('update:show', value => {
      instance.show = value;
    });
    instance.show = true;
  });
}

VarPicker.install = function (app) {
  app.component(VarPicker.name, VarPicker);
};

Picker.Component = VarPicker;

Picker.install = function (app) {
  app.component(VarPicker.name, VarPicker);
};

Picker.close = () => {
  if (singletonInstance != null) {
    var prevSingletonInstance = singletonInstance;
    singletonInstance = null;
    Vue.nextTick().then(() => {
      prevSingletonInstance.show = false;
    });
  }
};

export var _PickerComponent = VarPicker;
export default Picker;