function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import VarIcon from '../icon';
import VarFormDetails from '../form-details';
import Ripple from '../ripple';
import { props } from './props';
import { defineComponent } from '../utils/create';
import { ValidationMixin } from '../utils/mixins/validation';
import { createChildrenMixin } from '../utils/mixins/relation';
import { doubleRaf } from '../utils/elements';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-radio__wrap"
  }, [_c('div', _vm._b({
    staticClass: "var-radio",
    on: {
      "click": _vm.handleClick
    }
  }, 'div', _vm.$attrs, false), [_c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: _vm.formReadonly || _vm.readonly || _vm.formDisabled || _vm.disabled || !_vm.ripple
      },
      expression: "{ disabled: formReadonly || readonly || formDisabled || disabled || !ripple }"
    }],
    staticClass: "var-radio__action",
    class: [_vm.checked ? 'var-radio--checked' : 'var-radio--unchecked', _vm.errorMessage || _vm.radioGroupErrorMessage ? 'var-radio--error' : null, _vm.formDisabled || _vm.disabled ? 'var-radio--disabled' : null],
    style: {
      color: _vm.checked ? _vm.checkedColor : _vm.uncheckedColor
    }
  }, [_vm.checked ? _vm._t("checked-icon", function () {
    return [_c('var-icon', {
      staticClass: "var-radio__icon",
      class: [_vm.withAnimation ? 'var-radio--with-animation' : null],
      attrs: {
        "var-radio-cover": "",
        "name": "radio-marked",
        "size": _vm.iconSize
      }
    })];
  }) : _vm._t("unchecked-icon", function () {
    return [_c('var-icon', {
      staticClass: "var-radio__icon",
      class: [_vm.withAnimation ? 'var-radio--with-animation' : null],
      attrs: {
        "var-radio-cover": "",
        "name": "radio-blank",
        "size": _vm.iconSize
      }
    })];
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-radio__text",
    class: [_vm.errorMessage || _vm.radioGroupErrorMessage ? 'var-radio--error' : null, _vm.formDisabled || _vm.disabled ? 'var-radio--disabled' : null]
  }, [_vm._t("default")], 2)]), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarRadio',
  inheritAttrs: false,
  mixins: [ValidationMixin, createChildrenMixin('radioGroup', {
    childrenKey: 'radios'
  }), createChildrenMixin('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  directives: {
    Ripple
  },
  components: {
    VarIcon,
    VarFormDetails
  },
  props,
  data: () => ({
    localValue: false,
    withAnimation: false
  }),
  computed: {
    checked() {
      return this.localValue === this.checkedValue;
    },

    radioGroupErrorMessage() {
      var _this$radioGroup;

      return (_this$radioGroup = this.radioGroup) == null ? void 0 : _this$radioGroup.radioGroupErrorMessage;
    },

    formReadonly() {
      var _this$form;

      return (_this$form = this.form) == null ? void 0 : _this$form.readonly;
    },

    formDisabled() {
      var _this$form2;

      return (_this$form2 = this.form) == null ? void 0 : _this$form2.disabled;
    }

  },
  watch: {
    value: {
      handler(newValue) {
        this.localValue = newValue;
      },

      immediate: true
    }
  },
  methods: {
    // expose
    reset() {
      var {
        onInput
      } = this.getListeners();
      onInput == null ? void 0 : onInput(this.uncheckedValue);
      this.resetValidation();
    },

    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    // expose
    toggle(changedValue) {
      var {
        uncheckedValue,
        checkedValue
      } = this;
      var shouldReverse = ![uncheckedValue, checkedValue].includes(changedValue);

      if (shouldReverse) {
        changedValue = this.checked ? uncheckedValue : checkedValue;
      }

      this.change(changedValue);
    },

    validateWithTrigger(trigger) {
      this.$nextTick(() => {
        var {
          validateTrigger,
          rules,
          value
        } = this;

        this._validateWithTrigger(validateTrigger, trigger, rules, value);
      });
    },

    change(changedValue) {
      var _this$radioGroup2;

      var {
        checkedValue
      } = this;
      var {
        onChange,
        onInput
      } = this.getListeners();

      if (this.radioGroup && this.localValue === checkedValue) {
        return;
      }

      this.localValue = changedValue;
      onInput == null ? void 0 : onInput(this.localValue);
      onChange == null ? void 0 : onChange(this.localValue);
      (_this$radioGroup2 = this.radioGroup) == null ? void 0 : _this$radioGroup2.onToggle(checkedValue);
      this.validateWithTrigger('onChange');
    },

    handleClick(e) {
      var _this = this;

      return _asyncToGenerator(function* () {
        var _this$form3, _this$form4;

        var {
          disabled,
          readonly,
          uncheckedValue,
          checkedValue
        } = _this;

        var {
          onClick
        } = _this.getListeners();

        if ((_this$form3 = _this.form) != null && _this$form3.disabled || disabled) {
          return;
        }

        onClick == null ? void 0 : onClick(e);
        _this.withAnimation = false;

        if ((_this$form4 = _this.form) != null && _this$form4.readonly || readonly) {
          return;
        }

        _this.change(_this.checked ? uncheckedValue : checkedValue);

        yield doubleRaf();
        _this.withAnimation = true;
      })();
    },

    sync(v) {
      var {
        checkedValue,
        uncheckedValue
      } = this;
      this.localValue = v === checkedValue ? checkedValue : uncheckedValue;
    }

  }
});