//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import VarIcon from '../icon';
import VarFormDetails from '../form-details';
import Ripple from '../ripple';
import { defineComponent } from '../utils/create';
import { toSizeUnit } from '../utils/elements';
import { toNumber } from '../utils/shared';
import { props } from './props';
import { ValidationMixin } from '../utils/mixins/validation';
import { createChildrenMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-rate__warp"
  }, [_c('div', {
    staticClass: "var-rate"
  }, _vm._l(_vm.toNumber(_vm.count), function (val) {
    return _c('div', {
      directives: [{
        name: "ripple",
        rawName: "v-ripple",
        value: {
          disabled: _vm.formReadonly || _vm.readonly || _vm.formDisabled || _vm.disabled || !_vm.ripple
        },
        expression: "{ disabled: formReadonly || readonly || formDisabled || disabled || !ripple }"
      }],
      key: val,
      class: _vm.getClass(val),
      style: _vm.getStyle(val),
      on: {
        "click": function ($event) {
          return _vm.handleClick(val, $event);
        }
      }
    }, [_c('var-icon', {
      style: {
        fontSize: _vm.toSizeUnit(_vm.size)
      },
      attrs: {
        "transition": 0,
        "name": _vm.getIconName(val)
      }
    })], 1);
  }), 0), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarRate',
  inheritAttrs: false,
  mixins: [ValidationMixin, createChildrenMixin('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  components: {
    VarIcon,
    VarFormDetails
  },
  directives: {
    Ripple
  },
  props,
  computed: {
    formDisabled() {
      var _this$form;

      return (_this$form = this.form) == null ? void 0 : _this$form.disabled;
    },

    formReadonly() {
      var _this$form2;

      return (_this$form2 = this.form) == null ? void 0 : _this$form2.readonly;
    }

  },
  methods: {
    toNumber,
    toSizeUnit,

    getStyle(val) {
      var {
        count,
        size,
        gap
      } = this;
      return {
        color: this.transformValue(val).color,
        marginRight: val !== toNumber(count) ? toSizeUnit(gap) : 0,
        width: toSizeUnit(size),
        height: toSizeUnit(size),
        borderRadius: '50%'
      };
    },

    getClass(val) {
      var _this$form3;

      var {
        type,
        color
      } = this.transformValue(val);
      return {
        'var-rate__content': true,
        'var-rate--disabled': (_this$form3 = this.form) == null ? void 0 : _this$form3.disabled,
        'var-rate--error': this.errorMessage,
        'var-rate--primary': type !== 'empty' && !color
      };
    },

    getIconName(val) {
      var {
        type
      } = this.transformValue(val);
      var {
        icon,
        halfIcon,
        emptyIcon
      } = this;
      return type === 'full' ? icon : type === 'half' ? halfIcon : emptyIcon;
    },

    changeValue(score, event) {
      if (this.half) {
        var {
          offsetWidth
        } = event.target;
        if (event.offsetX <= Math.floor(offsetWidth / 2)) score -= 0.5;
      }

      var {
        onInput
      } = this.getListeners();
      onInput == null ? void 0 : onInput(score);
    },

    // expose
    validate() {
      return this._validate(this.rules, toNumber(this.value));
    },

    validateWithTrigger(trigger) {
      this.$nextTick(() => {
        var {
          validateTrigger,
          rules,
          value
        } = this;

        this._validateWithTrigger(validateTrigger, trigger, rules, value);
      });
    },

    handleClick(score, event) {
      var _this$form4, _this$form5;

      var {
        readonly,
        disabled
      } = this;
      var {
        onChange
      } = this.getListeners();

      if (readonly || disabled || (_this$form4 = this.form) != null && _this$form4.disabled || (_this$form5 = this.form) != null && _this$form5.readonly) {
        return;
      }

      this.changeValue(score, event);
      onChange == null ? void 0 : onChange(score);
      this.validateWithTrigger('onChange');
    },

    reset() {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, 0);
      this.resetValidation();
    },

    transformValue(index) {
      var _this$form6, _this$form7;

      var {
        value,
        disabled,
        disabledColor,
        color,
        half,
        emptyColor
      } = this;
      var iconColor;
      if (disabled || (_this$form6 = this.form) != null && _this$form6.disabled) iconColor = disabledColor;else if (color) iconColor = color;

      if (index <= toNumber(value)) {
        return {
          type: 'full',
          score: index,
          color: iconColor
        };
      }

      if (half && index <= toNumber(value) + 0.5) {
        return {
          type: 'half',
          score: index,
          color: iconColor
        };
      }

      return {
        type: 'empty',
        score: index,
        color: disabled || (_this$form7 = this.form) != null && _this$form7.disabled ? disabledColor : emptyColor
      };
    }

  }
});