//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { props } from './props';
import { defineComponent } from '../utils/create';
import { toPxNum } from '../utils/elements';
import { createParentMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-row__wrap"
  }, [_c('div', {
    staticClass: "var-row var--box",
    style: {
      justifyContent: _vm.justify,
      alignItems: _vm.align,
      margin: _vm.average ? "0 -" + _vm.average + "px" : undefined
    },
    on: {
      "click": _vm.handleClick
    }
  }, [_vm._t("default")], 2)]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarRow',
  mixins: [createParentMixin('row', {
    childrenKey: 'cols'
  })],
  props,
  computed: {
    average() {
      return toPxNum(this.gutter) / 2;
    }

  },
  watch: {
    gutter() {
      this.computePadding();
    },

    cols() {
      this.computePadding();
    }

  },
  methods: {
    computePadding() {
      var {
        average
      } = this;
      this.cols.forEach(col => {
        col.setPadding({
          left: average.value,
          right: average.value
        });
      });
    },

    handleClick(e) {
      var {
        getListeners
      } = this;
      var {
        onClick
      } = getListeners();

      if (!onClick) {
        return;
      }

      onClick(e);
    }

  }
});