//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import { getLeft } from '../utils/elements';
import { isArray, isNumber, toNumber } from '../utils/shared';
import { props } from './props';
import VarFormDetails from '../form-details';
import { ValidationMixin } from '../utils/mixins/validation';
import { createChildrenMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-slider"
  }, [_c('div', {
    ref: "sliderEl",
    staticClass: "var-slider-block",
    class: [_vm.isDisabled ? 'var-slider__disable' : null, _vm.errorMessage ? 'var-slider__error' : null],
    style: {
      height: _vm.thumbSize === undefined ? _vm.thumbSize : 3 * _vm.toNumber(_vm.thumbSize) + "px",
      margin: _vm.thumbSize === undefined ? _vm.thumbSize : "0 " + _vm.toNumber(_vm.thumbSize) / 2 + "px"
    },
    on: {
      "click": _vm.click
    }
  }, [_c('div', {
    staticClass: "var-slider__track"
  }, [_c('div', {
    staticClass: "var-slider__track-background",
    style: {
      background: _vm.trackColor,
      height: _vm.trackHeight + 'px'
    }
  }), _vm._v(" "), _c('div', {
    staticClass: "var-slider__track-fill",
    style: _vm.getFillStyle
  })]), _vm._v(" "), _vm._l(_vm.thumbList, function (item) {
    return _c('div', {
      key: item.enumValue,
      staticClass: "var-slider__thumb",
      style: {
        left: item.value + "%",
        zIndex: _vm.thumbsProps[item.enumValue].active ? 1 : undefined
      },
      on: {
        "touchstart": function ($event) {
          return _vm.start($event, item.enumValue);
        },
        "touchmove": function ($event) {
          return _vm.move($event, item.enumValue);
        },
        "touchend": function ($event) {
          return _vm.end(item.enumValue);
        },
        "touchcancel": function ($event) {
          return _vm.end(item.enumValue);
        }
      }
    }, [_vm._t("button", function () {
      return [_c('div', {
        staticClass: "var-slider__thumb-block",
        style: {
          background: _vm.thumbColor,
          height: _vm.thumbSize + 'px',
          width: _vm.thumbSize + 'px'
        }
      }), _vm._v(" "), _c('div', {
        staticClass: "var-slider__thumb-ripple",
        class: [_vm.thumbsProps[item.enumValue].active ? 'var-slider__thumb-ripple-active' : null],
        style: Object.assign({}, {
          background: _vm.thumbColor
        }, _vm.getRippleSize(item))
      }), _vm._v(" "), _c('div', {
        staticClass: "var-slider__thumb-label",
        class: [_vm.showLabel(item.enumValue) ? 'var-slider__thumb-label-active' : null],
        style: {
          background: _vm.labelColor,
          color: _vm.labelTextColor,
          height: _vm.thumbSize === undefined ? _vm.thumbSize : 2 * _vm.toNumber(_vm.thumbSize) + "px",
          width: _vm.thumbSize === undefined ? _vm.thumbSize : 2 * _vm.toNumber(_vm.thumbSize) + "px"
        }
      }, [_c('span', [_vm._v(_vm._s(item.value))])])];
    }, {
      "currentValue": item.value
    })], 2);
  })], 2), _vm._v(" "), _c('var-form-details', {
    staticClass: "var-slider__form",
    attrs: {
      "error-message": _vm.errorMessage,
      "var-slider-cover": ""
    }
  })], 1);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarSlider',
  mixins: [ValidationMixin, createChildrenMixin('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  components: {
    VarFormDetails
  },
  props,
  data: () => ({
    maxWidth: 0,
    isScroll: false,
    thumbsProps: {
      first: {
        startPosition: 0,
        currentLeft: 0,
        active: false,
        percentValue: 0
      },
      second: {
        startPosition: 0,
        currentLeft: 0,
        active: false,
        percentValue: 0
      }
    }
  }),
  computed: {
    unitWidth() {
      return this.maxWidth / 100 * toNumber(this.step);
    },

    thumbList() {
      var list = [{
        value: this.value,
        enumValue: 'first'
      }];

      if (this.range && isArray(this.value)) {
        list = [{
          value: this.value[0],
          enumValue: 'first'
        }, {
          value: this.value[1],
          enumValue: 'second'
        }];
      }

      return list;
    },

    getFillStyle() {
      var {
        activeColor,
        range,
        value
      } = this;
      var width = range && isArray(value) ? Math.abs(value[0] - value[1]) : value;
      var left = range && isArray(value) ? Math.min(value[0], value[1]) : 0;
      return {
        width: width + "%",
        left: left + "%",
        background: activeColor
      };
    },

    isDisabled() {
      var _this$form;

      return this.disabled || ((_this$form = this.form) == null ? void 0 : _this$form.disabled);
    },

    isReadonly() {
      var _this$form2;

      return this.readonly || ((_this$form2 = this.form) == null ? void 0 : _this$form2.readonly);
    }

  },

  mounted() {
    if (!this.stepValidator() || !this.valueValidator()) return;
    this.maxWidth = this.$refs.sliderEl.offsetWidth;
  },

  watch: {
    value(newValue) {
      if (!this.stepValidator() || !this.valueValidator() || this.isScroll) return;
      this.setProps(newValue, toNumber(this.step));
    },

    step(newValue) {
      if (!this.stepValidator() || !this.valueValidator() || this.isScroll) return;
      this.setProps(this.value, toNumber(newValue));
    },

    maxWidth() {
      this.setProps();
    }

  },
  methods: {
    toNumber,

    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    validateWithTrigger() {
      this.$nextTick(() => {
        var {
          rules,
          value
        } = this;

        this._validateWithTrigger(['onChange'], 'onChange', rules, value);
      });
    },

    getRippleSize(item) {
      var size;

      if (this.thumbSize !== undefined) {
        size = this.thumbsProps[item.enumValue].active ? 3 * toNumber(this.thumbSize) + "px" : '0px';
      }

      return {
        height: size,
        width: size
      };
    },

    showLabel(type) {
      if (this.labelVisible === 'always') return true;
      if (this.labelVisible === 'never') return false;
      return this.thumbsProps[type].active;
    },

    setPercent(moveDistance, type) {
      var {
        step,
        range,
        value,
        getListeners
      } = this;
      var {
        onChange,
        onInput
      } = getListeners();
      var rangeValue = [];
      var stepNumber = toNumber(step);
      var roundDistance = Math.round(moveDistance / this.unitWidth);
      var curValue = roundDistance * stepNumber;
      var prevValue = this.thumbsProps[type].percentValue;
      this.thumbsProps[type].percentValue = curValue / stepNumber;

      if (range && isArray(value)) {
        rangeValue = type === 'first' ? [curValue, value[1]] : [value[0], curValue];
      }

      if (prevValue !== curValue) {
        var localValue = range ? rangeValue : curValue;
        onChange == null ? void 0 : onChange(localValue);
        onInput == null ? void 0 : onInput(localValue);
        this.validateWithTrigger();
      }
    },

    getType(offset) {
      if (!this.range) return 'first';
      var thumb1Distance = this.thumbsProps.first.percentValue * this.unitWidth;
      var thumb2Distance = this.thumbsProps.second.percentValue * this.unitWidth;
      var offsetToThumb1 = Math.abs(offset - thumb1Distance);
      var offsetToThumb2 = Math.abs(offset - thumb2Distance);
      return offsetToThumb1 <= offsetToThumb2 ? 'first' : 'second';
    },

    start(event, type) {
      var _this$getListeners$on, _this$getListeners;

      if (!this.maxWidth) this.maxWidth = this.$refs.sliderEl.offsetWidth;
      if (this.isDisabled || this.isReadonly) return;
      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onStart) == null ? void 0 : _this$getListeners$on.call(_this$getListeners);
      this.isScroll = true;
      this.thumbsProps[type].startPosition = event.touches[0].clientX;
    },

    move(event, type) {
      if (this.isDisabled || this.isReadonly || !this.isScroll) return;
      var moveDistance = event.touches[0].clientX - this.thumbsProps[type].startPosition + this.thumbsProps[type].currentLeft;
      this.thumbsProps[type].active = true;
      if (moveDistance <= 0) moveDistance = 0;else if (moveDistance >= this.maxWidth) moveDistance = this.maxWidth;
      this.setPercent(moveDistance, type);
    },

    end(type) {
      var _getListeners$onEnd, _getListeners;

      var {
        isDisabled,
        isReadonly,
        range,
        value,
        getListeners
      } = this;
      if (isDisabled || isReadonly) return;
      var rangeValue = [];
      this.thumbsProps[type].currentLeft = this.thumbsProps[type].percentValue * this.unitWidth;
      this.thumbsProps[type].active = false;
      var curValue = this.thumbsProps[type].percentValue;

      if (range && isArray(value)) {
        rangeValue = type === 'first' ? [curValue, value[1]] : [value[0], curValue];
      }

      (_getListeners$onEnd = (_getListeners = getListeners()).onEnd) == null ? void 0 : _getListeners$onEnd.call(_getListeners, range ? rangeValue : curValue);
      this.isScroll = false;
    },

    click(event) {
      if (this.isDisabled || this.isReadonly) return;
      if (event.target.closest('.var-slider__thumb')) return;
      var offset = event.clientX - getLeft(event.currentTarget);
      var type = this.getType(offset);
      this.setPercent(offset, type);
      this.end(type);
    },

    stepValidator() {
      var stepNumber = toNumber(this.step);

      if (isNaN(stepNumber)) {
        console.warn('[Varlet] Slider: type of prop "step" should be Number');
        return false;
      }

      if (stepNumber < 1 || stepNumber > 100) {
        console.warn('[Varlet] Slider: "step" should be >= 0 and <= 100');
        return false;
      }

      if (parseInt("" + this.step, 10) !== stepNumber) {
        console.warn('[Varlet] Slider: "step" should be an Integer');
        return false;
      }

      return true;
    },

    valueValidator() {
      var {
        range,
        value
      } = this;

      if (range && !isArray(value)) {
        console.error('[Varlet] Slider: "value" should be an Array');
        return false;
      }

      if (!range && isArray(value)) {
        console.error('[Varlet] Slider: "value" should be a Number');
        return false;
      }

      if (range && isArray(value) && value.length < 2) {
        console.error('[Varlet] Slider: "value" should have two value');
        return false;
      }

      return true;
    },

    setProps(value, step) {
      if (value === void 0) {
        value = this.value;
      }

      if (step === void 0) {
        step = toNumber(this.step);
      }

      if (this.range && isArray(value)) {
        this.thumbsProps.first.percentValue = value[0] / step;
        this.thumbsProps.first.currentLeft = this.thumbsProps.first.percentValue * this.unitWidth;
        this.thumbsProps.second.percentValue = value[1] / step;
        this.thumbsProps.second.currentLeft = this.thumbsProps.second.percentValue * this.unitWidth;
      } else if (isNumber(value)) {
        this.thumbsProps.first.currentLeft = value / step * this.unitWidth;
      }
    },

    reset() {
      var _this$getListeners$on2, _this$getListeners2;

      var resetValue = this.range ? [0, 0] : 0;
      (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, resetValue);
      this.resetValidation();
    }

  }
});