import { isArray, isNumber, isString } from '../utils/shared';
export var internalSizeValidator = size => ['mini', 'small', 'normal', 'large'].includes(size);
export var sizeValidator = size => {
  return internalSizeValidator(size) || isArray(size) || isNumber(size) || isString(size);
};

var justifyValidator = justify => {
  return ['start', 'end', 'center', 'space-around', 'space-between'].includes(justify);
};

export var props = {
  align: {
    type: String
  },
  size: {
    type: [String, Number, Array],
    default: 'normal',
    validator: sizeValidator
  },
  wrap: {
    type: Boolean,
    default: true
  },
  direction: {
    type: String,
    default: 'row'
  },
  justify: {
    type: String,
    default: 'start',
    validator: justifyValidator
  },
  inline: {
    type: Boolean,
    default: false
  }
};