function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { props } from './props';
import { doubleRaf, getParentScroller, toPxNum } from '../utils/elements';
import { toNumber } from '../utils/shared';
import { defineComponent } from '../utils/create';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "stickyEl",
    staticClass: "var-sticky",
    class: [_vm.enableCSSMode ? 'var-sticky--css-mode' : null],
    style: {
      zIndex: _vm.toNumber(_vm.zIndex),
      top: _vm.enableCSSMode ? _vm.localOffsetTop + "px" : undefined,
      width: _vm.enableFixedMode ? _vm.fixedWidth : undefined,
      height: _vm.enableFixedMode ? _vm.fixedHeight : undefined
    }
  }, [_c('div', {
    ref: "wrapperEl",
    staticClass: "var-sticky__wrapper",
    style: {
      zIndex: _vm.toNumber(_vm.zIndex),
      position: _vm.enableFixedMode ? 'fixed' : undefined,
      width: _vm.enableFixedMode ? _vm.fixedWrapperWidth : undefined,
      height: _vm.enableFixedMode ? _vm.fixedWrapperHeight : undefined,
      left: _vm.enableFixedMode ? _vm.fixedLeft : undefined,
      top: _vm.enableFixedMode ? _vm.fixedTop : undefined
    }
  }, [_vm._t("default")], 2)]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarSticky',
  props,
  data: () => ({
    isFixed: false,
    fixedTop: '0px',
    fixedLeft: '0px',
    fixedWidth: 'auto',
    fixedHeight: 'auto',
    fixedWrapperWidth: 'auto',
    fixedWrapperHeight: 'auto',
    scroller: undefined
  }),
  computed: {
    enableCSSMode() {
      return !this.disabled && this.cssMode;
    },

    enableFixedMode() {
      return !this.disabled && this.isFixed;
    },

    localOffsetTop() {
      return toPxNum(this.offsetTop);
    }

  },

  activated() {
    this.addScrollListener();
  },

  deactivated() {
    this.removeScrollListener();
  },

  mounted() {
    this.addScrollListener();
  },

  beforeDestroy() {
    this.removeScrollListener();
  },

  watch: {
    disabled() {
      this.handleScroll();
    }

  },
  methods: {
    toNumber,

    handleScroll() {
      var {
        onScroll,
        cssMode,
        disabled
      } = this;

      if (disabled) {
        return;
      }

      var scrollerTop = 0;

      if (this.scroller !== window) {
        var {
          top
        } = this.scroller.getBoundingClientRect();
        scrollerTop = top;
      }

      var wrapper = this.$refs.wrapperEl;
      var sticky = this.$refs.stickyEl;
      var {
        top: stickyTop,
        left: stickyLeft
      } = sticky.getBoundingClientRect();
      var currentOffsetTop = stickyTop - scrollerTop;

      if (currentOffsetTop <= this.localOffsetTop) {
        if (!cssMode) {
          this.fixedWidth = sticky.offsetWidth + "px";
          this.fixedHeight = sticky.offsetHeight + "px";
          this.fixedTop = scrollerTop + this.localOffsetTop + "px";
          this.fixedLeft = stickyLeft + "px";
          this.fixedWrapperWidth = wrapper.offsetWidth + "px";
          this.fixedWrapperHeight = wrapper.offsetHeight + "px";
          this.isFixed = true;
        }

        onScroll == null ? void 0 : onScroll(this.localOffsetTop, true);
      } else {
        this.isFixed = false;
        onScroll == null ? void 0 : onScroll(currentOffsetTop, false);
      }
    },

    addScrollListener() {
      var _this = this;

      return _asyncToGenerator(function* () {
        yield doubleRaf();
        _this.scroller = getParentScroller(_this.$refs.stickyEl);
        _this.scroller !== window && _this.scroller.addEventListener('scroll', _this.handleScroll);
        window.addEventListener('scroll', _this.handleScroll);

        _this.handleScroll();
      })();
    },

    removeScrollListener() {
      this.scroller !== window && this.scroller.removeEventListener('scroll', this.handleScroll);
      window.removeEventListener('scroll', this.handleScroll);
    }

  }
});