function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import { doubleRaf, nextTickFrame } from '../utils/elements';
import { props } from './props';
import { isNumber, toNumber } from '../utils/shared';
import { createParentMixin } from '../utils/mixins/relation';
var SWIPE_DELAY = 250;
var SWIPE_DISTANCE = 20;

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "swipeEl",
    staticClass: "var-swipe"
  }, [_c('div', {
    staticClass: "var-swipe__track",
    class: [_vm.vertical ? 'var-swipe--vertical' : null],
    style: {
      width: !_vm.vertical ? _vm.trackSize + "px" : undefined,
      height: _vm.vertical ? _vm.trackSize + "px" : undefined,
      transform: "translate" + (_vm.vertical ? 'Y' : 'X') + "(" + _vm.translate + "px)",
      transitionDuration: _vm.lockDuration ? "0ms" : _vm.toNumber(_vm.duration) + "ms"
    },
    on: {
      "touchstart": _vm.handleTouchstart,
      "touchmove": _vm.handleTouchmove,
      "touchend": _vm.handleTouchend
    }
  }, [_vm._t("default")], 2), _vm._v(" "), _vm._t("indicator", function () {
    return [_vm.indicator && _vm.swipeItems.length ? _c('div', {
      staticClass: "var-swipe__indicators",
      class: [_vm.vertical ? 'var-swipe--indicators-vertical' : null]
    }, _vm._l(_vm.swipeItems.length, function (l, idx) {
      return _c('div', {
        key: l,
        staticClass: "var-swipe__indicator",
        class: [_vm.index === idx ? 'var-swipe--indicator-active' : null, _vm.vertical ? 'var-swipe--indicator-vertical' : null],
        style: {
          background: _vm.indicatorColor
        },
        on: {
          "click": function ($event) {
            return _vm.to(idx);
          }
        }
      });
    }), 0) : _vm._e()];
  }, {
    "index": _vm.index,
    "length": _vm.swipeItems.length
  })], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarSwipe',
  mixins: [createParentMixin('swipe', {
    childrenKey: 'swipeItems'
  })],
  props,
  data: () => ({
    size: 0,
    trackSize: 0,
    translate: 0,
    lockDuration: false,
    index: 0,
    touching: false,
    timer: -1,
    startX: undefined,
    startY: undefined,
    startTime: undefined,
    prevX: undefined,
    prevY: undefined
  }),

  mounted() {
    window.addEventListener('resize', this.resize);
  },

  beforeDestroy() {
    window.removeEventListener('resize', this.resize);
    this.stopAutoplay();
  },

  watch: {
    swipeItems() {
      var _this = this;

      return _asyncToGenerator(function* () {
        // In next, the size of the swipe cannot got when the route is change, need double raf
        yield doubleRaf();

        _this._initialIndex();

        _this.resize();
      })();
    }

  },
  methods: {
    // expose
    resize() {
      this.lockDuration = true;
      this.size = this.vertical ? this.$refs.swipeEl.offsetHeight : this.$refs.swipeEl.offsetWidth;
      this.trackSize = this.size * this.swipeItems.length;
      this.translate = this.index * -this.size;
      this.swipeItems.forEach(swipeItem => {
        swipeItem.setTranslate(0);
      });
      this.startAutoplay();
      window.setTimeout(() => {
        this.lockDuration = false;
      });
    },

    // expose
    next() {
      var _getListeners$onChang, _getListeners;

      if (this.swipeItems.length <= 1) {
        return;
      }

      var {
        loop,
        getListeners
      } = this;
      var currentIndex = this.index;
      this.index = this.boundaryIndex(currentIndex + 1);
      (_getListeners$onChang = (_getListeners = getListeners()).onChange) == null ? void 0 : _getListeners$onChang.call(_getListeners, this.index);
      this.fixPosition(() => {
        if (currentIndex === this.swipeItems.length - 1 && loop) {
          this.findSwipeItem(0).setTranslate(this.trackSize);
          this.translate = this.swipeItems.length * -this.size;
          return;
        }

        if (currentIndex !== this.swipeItems.length - 1) {
          this.translate = this.index * -this.size;
        }
      });
    },

    // expose
    prev() {
      var _getListeners$onChang2, _getListeners2;

      if (this.swipeItems.length <= 1) {
        return;
      }

      var {
        loop,
        getListeners
      } = this;
      var currentIndex = this.index;
      this.index = this.boundaryIndex(currentIndex - 1);
      (_getListeners$onChang2 = (_getListeners2 = getListeners()).onChange) == null ? void 0 : _getListeners$onChang2.call(_getListeners2, this.index);
      this.fixPosition(() => {
        if (currentIndex === 0 && loop) {
          this.findSwipeItem(this.swipeItems.length - 1).setTranslate(-this.trackSize);
          this.translate = this.size;
          return;
        }

        if (currentIndex !== 0) {
          this.translate = this.index * -this.size;
        }
      });
    },

    // expose
    to(idx) {
      if (this.swipeItems.length <= 1 || idx === this.index) {
        return;
      }

      idx = idx < 0 ? 0 : idx;
      idx = idx >= this.swipeItems.length ? this.swipeItems.length : idx;
      var task = idx > this.index ? this.next : this.prev;
      Array.from({
        length: Math.abs(idx - this.index)
      }).forEach(task);
    },

    toNumber,

    findSwipeItem(idx) {
      return this.swipeItems.find(_ref => {
        var {
          index
        } = _ref;
        return index === idx;
      });
    },

    dispatchBorrower() {
      var {
        translate,
        trackSize,
        size,
        loop,
        swipeItems
      } = this;
      var {
        length
      } = swipeItems;

      if (!loop) {
        return;
      } // track越左边界


      if (translate >= 0) {
        this.findSwipeItem(length - 1).setTranslate(-trackSize);
      } // track越右边界


      if (translate <= -(trackSize - size)) {
        this.findSwipeItem(0).setTranslate(trackSize);
      } // track没越界


      if (translate > -(trackSize - size) && translate < 0) {
        this.findSwipeItem(length - 1).setTranslate(0);
        this.findSwipeItem(0).setTranslate(0);
      }
    },

    getSwipeIndex(targetSwipeIndex) {
      var {
        translate,
        size,
        swipeItems,
        loop
      } = this;
      var swipeIndex = isNumber(targetSwipeIndex) ? targetSwipeIndex : Math.floor((translate - size / 2) / -size);

      if (swipeIndex <= -1) {
        return loop ? -1 : 0;
      }

      if (swipeIndex >= swipeItems.length) {
        return loop ? swipeItems.length : swipeItems.length - 1;
      }

      return swipeIndex;
    },

    swipeIndexToIndex(swipeIndex) {
      var {
        loop,
        swipeItems
      } = this;

      if (swipeIndex === -1) {
        return loop ? swipeItems.length - 1 : 0;
      }

      if (swipeIndex === swipeItems.length) {
        return loop ? 0 : swipeItems.length - 1;
      }

      return swipeIndex;
    },

    boundaryIndex(index) {
      var {
        loop,
        swipeItems
      } = this;

      if (index < 0) {
        return loop ? swipeItems.length - 1 : 0;
      }

      if (index > swipeItems.length - 1) {
        return loop ? 0 : swipeItems.length - 1;
      }

      return index;
    },

    fixPosition(fn) {
      var {
        translate,
        size,
        trackSize,
        swipeItems
      } = this;
      var overLeft = translate >= size;
      var overRight = translate <= -trackSize;
      var leftTranslate = 0;
      var rightTranslate = -(trackSize - size);
      this.lockDuration = true; // 检测是否有越界情况 越界修正

      if (overLeft || overRight) {
        this.lockDuration = true;
        this.translate = overRight ? leftTranslate : rightTranslate;
        this.findSwipeItem(0).setTranslate(0);
        this.findSwipeItem(swipeItems.length - 1).setTranslate(0);
      }

      nextTickFrame(() => {
        this.lockDuration = false;
        fn == null ? void 0 : fn();
      });
    },

    _initialIndex() {
      this.index = this.boundaryIndex(toNumber(this.initialIndex));
    },

    startAutoplay() {
      var {
        autoplay,
        swipeItems
      } = this;

      if (!autoplay || swipeItems.length <= 1) {
        return;
      }

      this.stopAutoplay();
      this.timer = window.setTimeout(() => {
        this.next();
        this.startAutoplay();
      }, toNumber(autoplay));
    },

    stopAutoplay() {
      this.timer && window.clearTimeout(this.timer);
    },

    getDirection(x, y) {
      if (x > y && x > 10) {
        return 'horizontal';
      }

      if (y > x && y > 10) {
        return 'vertical';
      }
    },

    handleTouchstart(event) {
      if (this.swipeItems.length <= 1 || !this.touchable) {
        return;
      }

      var {
        clientX,
        clientY
      } = event.touches[0];
      this.startX = clientX;
      this.startY = clientY;
      this.startTime = performance.now();
      this.touching = true;
      this.stopAutoplay();
      this.fixPosition(() => {
        this.lockDuration = true;
      });
    },

    handleTouchmove(event) {
      var {
        touchable,
        vertical
      } = this;

      if (!this.touching || !touchable) {
        return;
      }

      var {
        clientX,
        clientY
      } = event.touches[0];
      var deltaX = Math.abs(clientX - this.startX);
      var deltaY = Math.abs(clientY - this.startY);
      var direction = this.getDirection(deltaX, deltaY);
      var expectDirection = vertical ? 'vertical' : 'horizontal';

      if (direction === expectDirection) {
        event.preventDefault();
        var moveX = this.prevX !== undefined ? clientX - this.prevX : 0;
        var moveY = this.prevY !== undefined ? clientY - this.prevY : 0;
        this.prevX = clientX;
        this.prevY = clientY;
        this.translate += vertical ? moveY : moveX;
        this.dispatchBorrower();
      }
    },

    handleTouchend() {
      var _getListeners$onChang3, _getListeners3;

      if (!this.touching) {
        return;
      }

      var {
        vertical,
        getListeners
      } = this;
      var positive = vertical ? this.prevY < this.startY : this.prevX < this.startX;
      var distance = vertical ? Math.abs(this.startY - this.prevY) : Math.abs(this.startX - this.prevX);
      var quickSwiping = performance.now() - this.startTime <= SWIPE_DELAY && distance >= SWIPE_DISTANCE;
      var swipeIndex = quickSwiping ? positive ? this.getSwipeIndex(this.index + 1) : this.getSwipeIndex(this.index - 1) : this.getSwipeIndex();
      this.touching = false;
      this.lockDuration = false;
      this.prevX = undefined;
      this.prevY = undefined;
      this.translate = swipeIndex * -this.size;
      var prevIndex = this.index;
      this.index = this.swipeIndexToIndex(swipeIndex);
      this.startAutoplay();
      prevIndex !== this.index && ((_getListeners$onChang3 = (_getListeners3 = getListeners()).onChange) == null ? void 0 : _getListeners$onChang3.call(_getListeners3, this.index));
    }

  }
});