//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import { ValidationMixin } from '../utils/mixins/validation';
import { toNumber } from '../utils/shared';
import { props } from './props';
import VarFormDetails from '../form-details';
import VarLoading from '../loading';
import Ripple from '../ripple';
import { createChildrenMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-switch"
  }, [_c('div', {
    staticClass: "var-switch-block",
    class: [_vm.disabled || _vm.formDisabled ? 'var-switch__disable' : null],
    style: _vm.styleComputed.switch,
    on: {
      "click": _vm.switchActive
    }
  }, [_c('div', {
    staticClass: "var-switch__track",
    class: [_vm.value === _vm.activeValue ? 'var-switch__track-active' : null, _vm.errorMessage ? 'var-switch__track-error' : null],
    style: _vm.styleComputed.track
  }), _vm._v(" "), _c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: !_vm.ripple || _vm.disabled || _vm.loading || _vm.formDisabled
      },
      expression: "{\n        disabled: !ripple || disabled || loading || formDisabled,\n      }"
    }],
    staticClass: "var-switch__ripple",
    style: _vm.styleComputed.ripple
  }, [_c('div', {
    staticClass: "var-switch__handle var-elevation--2",
    class: [_vm.value === _vm.activeValue ? 'var-switch__handle-active' : null, _vm.errorMessage ? 'var-switch__handle-error' : null],
    style: _vm.styleComputed.handle
  }, [_vm.loading ? _c('var-loading', {
    attrs: {
      "radius": _vm.toNumber(_vm.size) / 2 - 2
    }
  }) : _vm._e()], 1)])]), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarSwitch',
  mixins: [ValidationMixin, createChildrenMixin('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  components: {
    VarLoading,
    VarFormDetails
  },
  directives: {
    Ripple
  },
  props,
  computed: {
    formReadonly() {
      var _this$form;

      return (_this$form = this.form) == null ? void 0 : _this$form.readonly;
    },

    formDisabled() {
      var _this$form2;

      return (_this$form2 = this.form) == null ? void 0 : _this$form2.disabled;
    },

    styleComputed() {
      var {
        size,
        value,
        color,
        closeColor,
        loadingColor,
        activeValue
      } = this;
      var sizeNum = this.toNumber(size);
      var switchWidth = sizeNum * 2;
      var switchHeight = sizeNum * 1.2;
      return {
        handle: {
          width: size + "px",
          height: size + "px",
          backgroundColor: value === activeValue ? color || '' : closeColor || '',
          color: loadingColor && loadingColor
        },
        ripple: {
          left: value === activeValue ? sizeNum / 2 + "px" : "-" + sizeNum / 2 + "px",
          color: value === activeValue ? color || '' : closeColor || '#999',
          width: sizeNum * 2 + "px",
          height: sizeNum * 2 + "px"
        },
        track: {
          height: switchHeight * 0.6 + "px",
          width: switchWidth - 2 + "px",
          borderRadius: switchWidth / 3 + "px",
          filter: value === activeValue || this != null && this.errorMessage ? 'opacity(.6)' : 'brightness(.6)',
          backgroundColor: value === activeValue ? color || '' : closeColor || ''
        },
        switch: {
          height: switchHeight + "px",
          width: switchWidth + "px"
        }
      };
    }

  },
  methods: {
    // expose
    reset() {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, this.inactiveValue);
      this.resetValidation();
    },

    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    toNumber,

    switchActive(e) {
      var _this$getListeners$on2, _this$getListeners2, _this$form3, _this$form4, _this$getListeners$on3, _this$getListeners3, _this$getListeners$on4, _this$getListeners4;

      var {
        disabled,
        loading,
        readonly,
        value,
        activeValue,
        inactiveValue
      } = this;
      (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners()).onClick) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, e);
      if (disabled || loading || readonly || (_this$form3 = this.form) != null && _this$form3.disabled || (_this$form4 = this.form) != null && _this$form4.readonly) return;
      var newValue = value === activeValue ? inactiveValue : activeValue;
      (_this$getListeners$on3 = (_this$getListeners3 = this.getListeners()).onChange) == null ? void 0 : _this$getListeners$on3.call(_this$getListeners3, newValue);
      (_this$getListeners$on4 = (_this$getListeners4 = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on4.call(_this$getListeners4, newValue);
      this.validateWithTrigger();
    },

    validateWithTrigger() {
      this.$nextTick(() => {
        var {
          rules,
          value
        } = this;

        this._validateWithTrigger(['onChange'], 'onChange', rules, value);
      });
    }

  }
});