//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import Ripple from '../ripple';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { createChildrenMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: _vm.disabled
      },
      expression: "{ disabled }"
    }],
    ref: "tabEl",
    staticClass: "var-tab var--box",
    class: [_vm.computeColorClass(), "var-tab--" + _vm.itemDirection],
    style: {
      color: _vm.computeColorStyle()
    },
    on: {
      "click": _vm.handleClick
    }
  }, [_vm._t("default")], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarTab',
  mixins: [createChildrenMixin('tabs', {
    parentKey: 'tabs',
    childrenKey: 'tabList'
  })],
  directives: {
    Ripple
  },
  props,
  computed: {
    element() {
      return this.$refs.tabEl;
    },

    itemDirection() {
      return this.tabs.itemDirection;
    }

  },
  watch: {
    name() {
      this.tabs.resize();
    },

    disabled() {
      this.tabs.resize();
    }

  },
  methods: {
    computeColorStyle() {
      var {
        disabled,
        name,
        tabs,
        index
      } = this;
      var {
        active,
        activeColor,
        inactiveColor,
        disabledColor
      } = tabs;
      return disabled ? disabledColor : active === name || active === index ? activeColor : inactiveColor;
    },

    computeColorClass() {
      var {
        disabled,
        name,
        index,
        tabs: {
          active
        }
      } = this;
      return disabled ? 'var-tab--disabled' : active === name || active === index ? 'var-tab--active' : 'var-tab--inactive';
    },

    handleClick(event) {
      var _getListeners$onClick, _getListeners;

      var {
        disabled,
        name,
        getListeners,
        index,
        element,
        tabs: {
          onTabClick
        }
      } = this;

      if (disabled) {
        return;
      }

      (_getListeners$onClick = (_getListeners = getListeners()).onClick) == null ? void 0 : _getListeners$onClick.call(_getListeners, name != null ? name : index, event);
      onTabClick({
        name,
        index,
        disabled,
        element
      });
    }

  }
});