//
//
//
//
//
//
//
//
//
//
//
//
//
import VarSwipe from '../swipe';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { createParentMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('var-swipe', {
    ref: "swipe",
    staticClass: "var-tabs-items",
    attrs: {
      "loop": _vm.loop,
      "touchable": _vm.canSwipe,
      "indicator": false
    },
    on: {
      "change": _vm.handleSwipeChange
    }
  }, [_vm._t("default")], 2);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarTabsItems',
  components: {
    VarSwipe
  },
  mixins: [createParentMixin('tabsItems', {
    childrenKey: 'tabItemList'
  })],
  props,
  watch: {
    active(newValue) {
      this.handleActiveChange(newValue);
    },

    tabItemList() {
      this.handleActiveChange(this.active);
    }

  },
  methods: {
    matchName(active) {
      return this.tabItemList.find(_ref => {
        var {
          name
        } = _ref;
        return active === name;
      });
    },

    matchIndex(active) {
      return this.tabItemList.find(_ref2 => {
        var {
          index
        } = _ref2;
        return active === index;
      });
    },

    matchActive(active) {
      return this.matchName(active) || this.matchIndex(active);
    },

    handleActiveChange(newValue) {
      var _this$$refs$swipe;

      var newActiveTabItemProvider = this.matchActive(newValue);

      if (!newActiveTabItemProvider) {
        return;
      }

      this.tabItemList.forEach(_ref3 => {
        var {
          setCurrent
        } = _ref3;
        return setCurrent(false);
      });
      newActiveTabItemProvider.setCurrent(true);
      (_this$$refs$swipe = this.$refs.swipe) == null ? void 0 : _this$$refs$swipe.to(newActiveTabItemProvider.index);
    },

    handleSwipeChange(currentIndex) {
      var _tabItem$name, _this$getListeners$on, _this$getListeners;

      var tabItem = this.tabItemList.find(_ref4 => {
        var {
          index
        } = _ref4;
        return index === currentIndex;
      });
      var active = (_tabItem$name = tabItem.name) != null ? _tabItem$name : tabItem.index;
      (_this$getListeners$on = (_this$getListeners = this.getListeners())['onUpdate:active']) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, active);
    }

  }
});