function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import VarSticky from '../sticky';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { isNumber, linear } from '../utils/shared';
import { toSizeUnit, scrollTo, doubleRaf } from '../utils/elements';
import { createParentMixin } from '../utils/mixins/relation';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c(_vm.sticky ? 'var-sticky' : 'transition', {
    tag: "component",
    attrs: {
      "offset-top": _vm.sticky ? _vm.offsetTop : null
    }
  }, [_c('div', _vm._b({
    staticClass: "var-tabs var--box",
    class: ["var-tabs--item-" + _vm.itemDirection, "var-tabs--layout-" + _vm.layoutDirection + "-padding", _vm.elevation ? "var-elevation--4" : null, _vm.fixedBottom ? 'var-tabs--fixed-bottom' : null],
    style: {
      background: _vm.color
    }
  }, 'div', _vm.$attrs, false), [_c('div', {
    ref: "scrollerEl",
    staticClass: "var-tabs__tab-wrap",
    class: [_vm.scrollable ? "var-tabs--layout-" + _vm.layoutDirection + "-scrollable" : null, "var-tabs--layout-" + _vm.layoutDirection]
  }, [_vm._t("default"), _vm._v(" "), _c('div', {
    staticClass: "var-tabs__indicator",
    class: ["var-tabs--layout-" + _vm.layoutDirection + "-indicator"],
    style: {
      width: _vm.layoutDirection === 'horizontal' ? _vm.indicatorWidth : _vm.toSizeUnit(_vm.indicatorSize),
      height: _vm.layoutDirection === 'horizontal' ? _vm.toSizeUnit(_vm.indicatorSize) : _vm.indicatorHeight,
      transform: _vm.layoutDirection === 'horizontal' ? "translateX(" + _vm.indicatorX + ")" : "translateY(" + _vm.indicatorY + ")",
      background: _vm.indicatorColor || _vm.activeColor
    }
  })], 2)])]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarTabs',
  components: {
    VarSticky
  },
  mixins: [createParentMixin('tabs', {
    childrenKey: 'tabList'
  })],
  inheritAttrs: false,
  props,
  data: () => ({
    indicatorWidth: '0px',
    indicatorHeight: '0px',
    indicatorX: '0px',
    indicatorY: '0px',
    scrollable: false
  }),

  mounted() {
    window.addEventListener('resize', this.resize);
  },

  beforeDestroy() {
    window.removeEventListener('resize', this.resize);
  },

  watch: {
    tabList() {
      var _this = this;

      return _asyncToGenerator(function* () {
        yield doubleRaf();

        _this.resize();
      })();
    },

    active() {
      this.resize();
    }

  },
  methods: {
    // expose
    resize() {
      var tab = this.matchName() || this.matchIndex() || this.matchBoundary();

      if (!tab || tab.disabled) {
        return;
      }

      this.watchScrollable();
      this.moveIndicator(tab);
      this.scrollToCenter(tab);
    },

    toSizeUnit,

    onTabClick(tab) {
      var _tab$name, _getListeners$onUpdat, _getListeners, _getListeners$onClick, _getListeners2, _getListeners$onChang, _getListeners3;

      var currentActive = (_tab$name = tab.name) != null ? _tab$name : tab.index;
      var {
        active,
        getListeners
      } = this;
      (_getListeners$onUpdat = (_getListeners = getListeners())['onUpdate:active']) == null ? void 0 : _getListeners$onUpdat.call(_getListeners, currentActive);
      (_getListeners$onClick = (_getListeners2 = getListeners()).onClick) == null ? void 0 : _getListeners$onClick.call(_getListeners2, currentActive);
      currentActive !== active && ((_getListeners$onChang = (_getListeners3 = getListeners()).onChange) == null ? void 0 : _getListeners$onChang.call(_getListeners3, currentActive));
    },

    matchName() {
      return this.tabList.find(_ref => {
        var {
          name
        } = _ref;
        return this.active === name;
      });
    },

    matchIndex() {
      return this.tabList.find(_ref2 => {
        var {
          index
        } = _ref2;
        return this.active === index;
      });
    },

    matchBoundary() {
      var _getListeners$onUpdat2, _getListeners4, _getListeners$onUpdat3, _getListeners5;

      var {
        active,
        tabList: {
          length
        },
        getListeners
      } = this;

      if (length === 0) {
        return;
      }

      isNumber(active) ? active > length - 1 ? (_getListeners$onUpdat2 = (_getListeners4 = getListeners())['onUpdate:active']) == null ? void 0 : _getListeners$onUpdat2.call(_getListeners4, length - 1) : (_getListeners$onUpdat3 = (_getListeners5 = getListeners())['onUpdate:active']) == null ? void 0 : _getListeners$onUpdat3.call(_getListeners5, 0) : null;
      return this.matchIndex();
    },

    watchScrollable() {
      this.scrollable = this.tabList.length >= 5;
    },

    moveIndicator(_ref3) {
      var {
        element
      } = _ref3;

      if (this.layoutDirection === 'horizontal') {
        this.indicatorWidth = (element == null ? void 0 : element.offsetWidth) + "px";
        this.indicatorX = (element == null ? void 0 : element.offsetLeft) + "px";
      } else {
        this.indicatorHeight = (element == null ? void 0 : element.offsetHeight) + "px";
        this.indicatorY = (element == null ? void 0 : element.offsetTop) + "px";
      }
    },

    scrollToCenter(_ref4) {
      var {
        element
      } = _ref4;

      if (!this.scrollable) {
        return;
      }

      var scroller = this.$refs.scrollerEl;

      if (this.layoutDirection === 'horizontal') {
        var left = element.offsetLeft + element.offsetWidth / 2 - scroller.offsetWidth / 2;
        scrollTo(scroller, {
          left,
          animation: linear
        });
      } else {
        var top = element.offsetTop + element.offsetHeight / 2 - scroller.offsetHeight / 2;
        scrollTo(scroller, {
          top,
          animation: linear
        });
      }
    }

  }
});