import Vue from 'vue';
import { props } from './props';
import { defineComponent } from '../utils/create';
export default defineComponent({
  name: 'VarTeleport',
  props,
  data: () => ({
    el: null,
    instance: null
  }),
  watch: {
    disabled() {
      this.transfer();
    },

    to() {
      this.transfer();
    }

  },
  methods: {
    create() {
      var h = this.$createElement;
      this.instance = new (Vue.extend({
        render: () => h("div", {
          "class": "var-teleport__container"
        }, [this.slots()])
      }))();
      this.instance.$parent = this;
      this.el = this.instance.$mount().$el;
    },

    transfer() {
      var container = this.disabled ? this.$refs.teleport : document.querySelector(this.to);
      var parentNode = this.el.parentNode;

      if (parentNode === container) {
        return;
      }

      parentNode == null ? void 0 : parentNode.removeChild(this.el);
      container.appendChild(this.el);
    }

  },

  updated() {
    this.instance.$forceUpdate();
  },

  mounted() {
    this.create();
    this.transfer();
  },

  deactivated() {
    var _this$el$parentNode;

    (_this$el$parentNode = this.el.parentNode) == null ? void 0 : _this$el$parentNode.removeChild(this.el);
  },

  activated() {
    this.transfer();
  },

  beforeDestroy() {
    var _this$el$parentNode2;

    this.instance.$destroy();
    (_this$el$parentNode2 = this.el.parentNode) == null ? void 0 : _this$el$parentNode2.removeChild(this.el);
  },

  render() {
    var h = arguments[0];
    return h("div", {
      "ref": "teleport",
      "class": "var-teleport"
    });
  }

});