//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import { defineComponent } from '../utils/create';
import dayjs from 'dayjs/esm';
import Clock from './clock.js'
import { props, hoursAmpm, hours24 } from './props';
import { toNumber } from '../utils/shared';
import { getNumberTime, getIsDisableMinute, getIsDisableSecond } from './utils';

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "picker",
    staticClass: "var-time-picker",
    class: [_vm.shadow ? 'var-elevation--2' : null]
  }, [_c('div', {
    staticClass: "var-time-picker-title",
    style: {
      background: _vm.headerColor || _vm.color
    }
  }, [_c('div', {
    staticClass: "var-time-picker-title__time"
  }, [_c('div', {
    staticClass: "var-time-picker-title__btn",
    class: _vm.type === 'hour' ? 'var-time-picker-title__btn--active' : null,
    on: {
      "click": function ($event) {
        return _vm.checkPanel('hour');
      }
    }
  }, [_vm._v("\n        " + _vm._s(_vm.time.hour) + "\n      ")]), _vm._v(" "), _c('span', [_vm._v(":")]), _vm._v(" "), _c('div', {
    staticClass: "var-time-picker-title__btn",
    class: _vm.type === 'minute' ? 'var-time-picker-title__btn--active' : null,
    on: {
      "click": function ($event) {
        return _vm.checkPanel('minute');
      }
    }
  }, [_vm._v("\n        " + _vm._s(_vm.time.minute) + "\n      ")]), _vm._v(" "), _vm.useSeconds ? _c('span', [_vm._v(":")]) : _vm._e(), _vm._v(" "), _vm.useSeconds ? _c('div', {
    staticClass: "var-time-picker-title__btn",
    class: _vm.type === 'second' ? 'var-time-picker-title__btn--active' : null,
    on: {
      "click": function ($event) {
        return _vm.checkPanel('second');
      }
    }
  }, [_vm._v("\n        " + _vm._s(_vm.time.second) + "\n      ")]) : _vm._e()]), _vm._v(" "), _vm.format === 'ampm' ? _c('div', {
    staticClass: "var-time-picker-title__ampm"
  }, [_c('div', {
    staticClass: "var-time-picker-title__btn",
    class: _vm.ampm === 'am' ? 'var-time-picker-title__btn--active' : null,
    on: {
      "click": function ($event) {
        return _vm.checkAmpm('am');
      }
    }
  }, [_vm._v("\n        AM\n      ")]), _vm._v(" "), _c('div', {
    staticClass: "var-time-picker-title__btn",
    class: _vm.ampm === 'pm' ? 'var-time-picker-title__btn--active' : null,
    on: {
      "click": function ($event) {
        return _vm.checkAmpm('pm');
      }
    }
  }, [_vm._v("\n        PM\n      ")])]) : _vm._e()]), _vm._v(" "), _c('div', {
    staticClass: "var-time-picker-body"
  }, [_c('div', {
    ref: "container",
    staticClass: "var-time-picker-clock__container",
    on: {
      "touchstart": _vm.moveHand,
      "touchmove": _vm.moveHand,
      "touchend": _vm.end
    }
  }, [_c('transition', {
    attrs: {
      "name": "var-time-picker-panel-fade"
    }
  }, [_c('clock', {
    key: _vm.type,
    ref: "inner",
    attrs: {
      "type": _vm.type,
      "ampm": _vm.ampm,
      "color": _vm.color,
      "is-inner": _vm.isInner,
      "format": _vm.format,
      "allowed-time": _vm.allowedTime,
      "rad": _vm.getRad,
      "time": _vm.time,
      "prevent-next-update": _vm.isPreventNextUpdate,
      "use-seconds": _vm.useSeconds,
      "max": _vm.max,
      "min": _vm.min
    },
    on: {
      "update": _vm.update,
      "change-prevent-update": _vm.changePreventUpdate
    }
  })], 1)], 1)])]);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarTimePicker',
  components: {
    Clock
  },
  props,
  data: () => ({
    container: null,
    picker: null,
    inner: null,
    isInner: false,
    isPreventNextUpdate: false,
    isActualInner: false,
    isChosenUsableHour: false,
    isChosenUsableMinute: false,
    hourRad: undefined,
    minuteRad: 0,
    secondRad: 0,
    type: 'hour',
    ampm: 'am',
    isDisableHour: false,
    isDisableMinute: false,
    time: {
      hour: '00',
      minute: '00',
      second: '00'
    },
    center: {
      x: 0,
      y: 0
    },
    innerRange: {
      x: [],
      y: []
    }
  }),
  computed: {
    getRad() {
      if (this.type === 'hour') return this.hourRad;
      if (this.type === 'minute') return this.minuteRad;
      return this.secondRad;
    }

  },
  methods: {
    update(newTime) {
      var {
        onInput,
        onChange
      } = this.getListeners();
      onInput == null ? void 0 : onInput(newTime);
      onChange == null ? void 0 : onChange(newTime);
    },

    rad2deg(rad) {
      return rad * 57.29577951308232;
    },

    checkPanel(panelType) {
      this.isChosenUsableHour = false;
      this.isDisableMinute = false;
      this.type = panelType;
    },

    findAvailableHour(ampm) {
      var {
        disableHour
      } = this.inner;
      var index = hoursAmpm.findIndex(hour => toNumber(hour) === toNumber(this.time.hour));
      var hours = ampm === 'am' ? hoursAmpm : hours24;
      var realignmentHours = [...hours.slice(index), ...hours.slice(0, index)];
      return realignmentHours.find((hour, index) => {
        this.isPreventNextUpdate = index !== 0;
        return !disableHour.includes(hour);
      });
    },

    checkAmpm(ampmType) {
      if (this.readonly) return;
      this.ampm = ampmType;
      var newHour = this.findAvailableHour(ampmType);
      if (!newHour) return;
      var second = this.useSeconds ? ":" + this.time.second : '';
      var newTime = newHour.padStart(2, '0') + ":" + this.time.minute + second;
      this.update(newTime);
    },

    getInner(clientX, clientY) {
      var xIsInRange = clientX >= this.innerRange.x[0] && clientX <= this.innerRange.x[1];
      var yIsInRange = clientY >= this.innerRange.y[0] && clientY <= this.innerRange.y[1];
      return xIsInRange && yIsInRange;
    },

    getTime(value) {
      var hourFormat = this.format === '24hr' ? 'HH' : 'hh';
      var {
        hour,
        minute,
        second
      } = getNumberTime(value);
      return {
        hour: dayjs().hour(hour).format(hourFormat),
        minute: dayjs().minute(minute).format('mm'),
        second: dayjs().second(second).format('ss')
      };
    },

    getHourIndex(rad) {
      var value = rad / 30;
      return value >= 0 ? value : value + 12;
    },

    getRangeSize() {
      var {
        width: innerWidth,
        height: innerHeight
      } = this.inner.getSize();
      var rangeXMin = this.center.x - innerWidth / 2 - 8;
      var rangeXMax = this.center.x + innerWidth / 2 + 8;
      var rangeYMin = this.center.y - innerHeight / 2 - 8;
      var rangeYMax = this.center.y + innerHeight / 2 + 8;
      return {
        rangeXMin,
        rangeXMax,
        rangeYMin,
        rangeYMax
      };
    },

    setHourRad(clientX, clientY, roundDeg) {
      var {
        disableHour
      } = this.inner;
      this.isActualInner = this.getInner(clientX, clientY);
      var rad = Math.round(roundDeg / 30) * 30 + 90;
      var index = this.getHourIndex(rad);
      var anotherHour = this.isInner ? hoursAmpm[index] : hours24[index];

      if (!disableHour.includes(anotherHour)) {
        this.isInner = this.format === '24hr' ? this.getInner(clientX, clientY) : false;
      }

      if (this.isInner !== this.isActualInner) return;
      var newHour = this.isInner || this.ampm === 'pm' ? hours24[index] : hoursAmpm[index];
      this.isDisableHour = disableHour.includes(newHour);
      if (this.isDisableHour) return;
      this.hourRad = rad;
      this.isChosenUsableHour = true;
    },

    setMinuteRad(roundDeg) {
      var {
        disableHour
      } = this.inner;
      var rad = Math.round(roundDeg / 6) * 6 + 90;
      var radToMin = rad / 6 >= 0 ? rad / 6 : rad / 6 + 60;
      var values = {
        time: radToMin,
        format: this.format,
        ampm: this.ampm,
        hour: this.time.hour,
        max: this.max,
        min: this.min,
        disableHour,
        allowedTime: this.allowedTime
      };
      this.isDisableMinute = getIsDisableMinute(values);
      if (this.isDisableMinute) return;
      this.minuteRad = rad;
      this.isChosenUsableMinute = true;
    },

    setSecondRad(roundDeg) {
      var {
        disableHour
      } = this.inner;
      var rad = Math.round(roundDeg / 6) * 6 + 90;
      var radToSec = rad / 6 >= 0 ? rad / 6 : rad / 6 + 60;
      var values = {
        time: radToSec,
        format: this.format,
        ampm: this.ampm,
        hour: this.time.hour,
        minute: toNumber(this.time.minute),
        max: this.max,
        min: this.min,
        disableHour,
        allowedTime: this.allowedTime
      };
      if (!getIsDisableSecond(values)) this.secondRad = rad;
    },

    setCenterAndRange() {
      var {
        left,
        top,
        width,
        height
      } = this.container.getBoundingClientRect();
      this.center.x = left + width / 2;
      this.center.y = top + height / 2;

      if (this.type === 'hour' && this.format === '24hr') {
        var {
          rangeXMin,
          rangeXMax,
          rangeYMin,
          rangeYMax
        } = this.getRangeSize();
        this.innerRange.x = [rangeXMin, rangeXMax];
        this.innerRange.y = [rangeYMin, rangeYMax];
      }
    },

    moveHand(event) {
      if (this.readonly) return;
      this.setCenterAndRange();
      var {
        clientX,
        clientY
      } = event.touches[0];
      var x = clientX - this.center.x;
      var y = clientY - this.center.y;
      var roundDeg = Math.round(this.rad2deg(Math.atan2(y, x)));
      if (this.type === 'hour') this.setHourRad(clientX, clientY, roundDeg);else if (this.type === 'minute') this.setMinuteRad(roundDeg);else this.setSecondRad(roundDeg);
    },

    end() {
      if (this.readonly) return;

      if (this.type === 'hour' && this.isChosenUsableHour) {
        this.type = 'minute';
        return;
      }

      if (this.type === 'minute' && this.useSeconds && this.isChosenUsableMinute) {
        this.type = 'second';
      }
    },

    changePreventUpdate() {
      this.isPreventNextUpdate = false;
    }

  },
  watch: {
    value: {
      handler(value) {
        if (value) {
          var {
            hour,
            minute,
            second
          } = getNumberTime(value);
          var formatHour12 = dayjs().hour(hour).format('hh');
          var formatHour24 = dayjs().hour(hour).format('HH');
          var formatMinute = dayjs().minute(minute).format('mm');
          var formatSecond = dayjs().second(second).format('ss');
          this.hourRad = (formatHour12 === '12' ? 0 : toNumber(formatHour12)) * 30;
          this.minuteRad = toNumber(formatMinute) * 6;
          this.secondRad = toNumber(formatSecond) * 6;
          this.time = this.getTime(value);

          if (this.format !== '24hr') {
            this.ampm = ("" + hour).padStart(2, '0') === formatHour24 && hours24.includes(formatHour24) ? 'pm' : 'am';
          }

          this.isInner = this.format === '24hr' && hours24.includes(formatHour24);
        }
      },

      immediate: true
    }
  },

  created() {
    this.$nextTick(() => {
      this.container = this.$refs.container;
      this.inner = this.$refs.inner;
      this.picker = this.$refs.picker;
    });
  }

});