import ActionSheet, * as ActionSheetModule from './action-sheet'
import AppBar, * as AppBarModule from './app-bar'
import BackTop, * as BackTopModule from './back-top'
import Badge, * as BadgeModule from './badge'
import BottomNavigation, * as BottomNavigationModule from './bottom-navigation'
import BottomNavigationItem, * as BottomNavigationItemModule from './bottom-navigation-item'
import Button, * as ButtonModule from './button'
import Card, * as CardModule from './card'
import Cell, * as CellModule from './cell'
import Checkbox, * as CheckboxModule from './checkbox'
import CheckboxGroup, * as CheckboxGroupModule from './checkbox-group'
import Chip, * as ChipModule from './chip'
import Col, * as ColModule from './col'
import Collapse, * as CollapseModule from './collapse'
import CollapseItem, * as CollapseItemModule from './collapse-item'
import Context, * as ContextModule from './context'
import Countdown, * as CountdownModule from './countdown'
import Counter, * as CounterModule from './counter'
import DatePicker, * as DatePickerModule from './date-picker'
import Dialog, * as DialogModule from './dialog'
import Divider, * as DividerModule from './divider'
import Form, * as FormModule from './form'
import FormDetails, * as FormDetailsModule from './form-details'
import Icon, * as IconModule from './icon'
import Image, * as ImageModule from './image'
import ImagePreview, * as ImagePreviewModule from './image-preview'
import IndexAnchor, * as IndexAnchorModule from './index-anchor'
import IndexBar, * as IndexBarModule from './index-bar'
import Input, * as InputModule from './input'
import Lazy, * as LazyModule from './lazy'
import List, * as ListModule from './list'
import Loading, * as LoadingModule from './loading'
import Locale, * as LocaleModule from './locale'
import Menu, * as MenuModule from './menu'
import Option, * as OptionModule from './option'
import Pagination, * as PaginationModule from './pagination'
import Picker, * as PickerModule from './picker'
import Popup, * as PopupModule from './popup'
import Progress, * as ProgressModule from './progress'
import PullRefresh, * as PullRefreshModule from './pull-refresh'
import Radio, * as RadioModule from './radio'
import RadioGroup, * as RadioGroupModule from './radio-group'
import Rate, * as RateModule from './rate'
import Ripple, * as RippleModule from './ripple'
import Row, * as RowModule from './row'
import Select, * as SelectModule from './select'
import Skeleton, * as SkeletonModule from './skeleton'
import Slider, * as SliderModule from './slider'
import Snackbar, * as SnackbarModule from './snackbar'
import Space, * as SpaceModule from './space'
import Step, * as StepModule from './step'
import Steps, * as StepsModule from './steps'
import Sticky, * as StickyModule from './sticky'
import StyleProvider, * as StyleProviderModule from './style-provider'
import Swipe, * as SwipeModule from './swipe'
import SwipeItem, * as SwipeItemModule from './swipe-item'
import Switch, * as SwitchModule from './switch'
import Tab, * as TabModule from './tab'
import TabItem, * as TabItemModule from './tab-item'
import Table, * as TableModule from './table'
import Tabs, * as TabsModule from './tabs'
import TabsItems, * as TabsItemsModule from './tabs-items'
import Teleport, * as TeleportModule from './teleport'
import TimePicker, * as TimePickerModule from './time-picker'
import Uploader, * as UploaderModule from './uploader'

import './action-sheet/style'
import './app-bar/style'
import './back-top/style'
import './badge/style'
import './bottom-navigation/style'
import './bottom-navigation-item/style'
import './button/style'
import './card/style'
import './cell/style'
import './checkbox/style'
import './checkbox-group/style'
import './chip/style'
import './col/style'
import './collapse/style'
import './collapse-item/style'
import './context/style'
import './countdown/style'
import './counter/style'
import './date-picker/style'
import './dialog/style'
import './divider/style'
import './form/style'
import './form-details/style'
import './icon/style'
import './image/style'
import './image-preview/style'
import './index-anchor/style'
import './index-bar/style'
import './input/style'
import './lazy/style'
import './list/style'
import './loading/style'
import './locale/style'
import './menu/style'
import './option/style'
import './pagination/style'
import './picker/style'
import './popup/style'
import './progress/style'
import './pull-refresh/style'
import './radio/style'
import './radio-group/style'
import './rate/style'
import './ripple/style'
import './row/style'
import './select/style'
import './skeleton/style'
import './slider/style'
import './snackbar/style'
import './space/style'
import './step/style'
import './steps/style'
import './sticky/style'
import './style-provider/style'
import './swipe/style'
import './swipe-item/style'
import './switch/style'
import './tab/style'
import './tab-item/style'
import './table/style'
import './tabs/style'
import './tabs-items/style'
import './teleport/style'
import './time-picker/style'
import './uploader/style'


function install(app) {
  ActionSheet.install && app.use(ActionSheet)
  AppBar.install && app.use(AppBar)
  BackTop.install && app.use(BackTop)
  Badge.install && app.use(Badge)
  BottomNavigation.install && app.use(BottomNavigation)
  BottomNavigationItem.install && app.use(BottomNavigationItem)
  Button.install && app.use(Button)
  Card.install && app.use(Card)
  Cell.install && app.use(Cell)
  Checkbox.install && app.use(Checkbox)
  CheckboxGroup.install && app.use(CheckboxGroup)
  Chip.install && app.use(Chip)
  Col.install && app.use(Col)
  Collapse.install && app.use(Collapse)
  CollapseItem.install && app.use(CollapseItem)
  Context.install && app.use(Context)
  Countdown.install && app.use(Countdown)
  Counter.install && app.use(Counter)
  DatePicker.install && app.use(DatePicker)
  Dialog.install && app.use(Dialog)
  Divider.install && app.use(Divider)
  Form.install && app.use(Form)
  FormDetails.install && app.use(FormDetails)
  Icon.install && app.use(Icon)
  Image.install && app.use(Image)
  ImagePreview.install && app.use(ImagePreview)
  IndexAnchor.install && app.use(IndexAnchor)
  IndexBar.install && app.use(IndexBar)
  Input.install && app.use(Input)
  Lazy.install && app.use(Lazy)
  List.install && app.use(List)
  Loading.install && app.use(Loading)
  Locale.install && app.use(Locale)
  Menu.install && app.use(Menu)
  Option.install && app.use(Option)
  Pagination.install && app.use(Pagination)
  Picker.install && app.use(Picker)
  Popup.install && app.use(Popup)
  Progress.install && app.use(Progress)
  PullRefresh.install && app.use(PullRefresh)
  Radio.install && app.use(Radio)
  RadioGroup.install && app.use(RadioGroup)
  Rate.install && app.use(Rate)
  Ripple.install && app.use(Ripple)
  Row.install && app.use(Row)
  Select.install && app.use(Select)
  Skeleton.install && app.use(Skeleton)
  Slider.install && app.use(Slider)
  Snackbar.install && app.use(Snackbar)
  Space.install && app.use(Space)
  Step.install && app.use(Step)
  Steps.install && app.use(Steps)
  Sticky.install && app.use(Sticky)
  StyleProvider.install && app.use(StyleProvider)
  Swipe.install && app.use(Swipe)
  SwipeItem.install && app.use(SwipeItem)
  Switch.install && app.use(Switch)
  Tab.install && app.use(Tab)
  TabItem.install && app.use(TabItem)
  Table.install && app.use(Table)
  Tabs.install && app.use(Tabs)
  TabsItems.install && app.use(TabsItems)
  Teleport.install && app.use(Teleport)
  TimePicker.install && app.use(TimePicker)
  Uploader.install && app.use(Uploader)
}

export {
  install,
  ActionSheet,
  AppBar,
  BackTop,
  Badge,
  BottomNavigation,
  BottomNavigationItem,
  Button,
  Card,
  Cell,
  Checkbox,
  CheckboxGroup,
  Chip,
  Col,
  Collapse,
  CollapseItem,
  Context,
  Countdown,
  Counter,
  DatePicker,
  Dialog,
  Divider,
  Form,
  FormDetails,
  Icon,
  Image,
  ImagePreview,
  IndexAnchor,
  IndexBar,
  Input,
  Lazy,
  List,
  Loading,
  Locale,
  Menu,
  Option,
  Pagination,
  Picker,
  Popup,
  Progress,
  PullRefresh,
  Radio,
  RadioGroup,
  Rate,
  Ripple,
  Row,
  Select,
  Skeleton,
  Slider,
  Snackbar,
  Space,
  Step,
  Steps,
  Sticky,
  StyleProvider,
  Swipe,
  SwipeItem,
  Switch,
  Tab,
  TabItem,
  Table,
  Tabs,
  TabsItems,
  Teleport,
  TimePicker,
  Uploader
}

export default {
  install,
  ActionSheet,
  AppBar,
  BackTop,
  Badge,
  BottomNavigation,
  BottomNavigationItem,
  Button,
  Card,
  Cell,
  Checkbox,
  CheckboxGroup,
  Chip,
  Col,
  Collapse,
  CollapseItem,
  Context,
  Countdown,
  Counter,
  DatePicker,
  Dialog,
  Divider,
  Form,
  FormDetails,
  Icon,
  Image,
  ImagePreview,
  IndexAnchor,
  IndexBar,
  Input,
  Lazy,
  List,
  Loading,
  Locale,
  Menu,
  Option,
  Pagination,
  Picker,
  Popup,
  Progress,
  PullRefresh,
  Radio,
  RadioGroup,
  Rate,
  Ripple,
  Row,
  Select,
  Skeleton,
  Slider,
  Snackbar,
  Space,
  Step,
  Steps,
  Sticky,
  StyleProvider,
  Swipe,
  SwipeItem,
  Switch,
  Tab,
  TabItem,
  Table,
  Tabs,
  TabsItems,
  Teleport,
  TimePicker,
  Uploader
}
