function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
import VarFormDetails from '../form-details';
import VarIcon from '../icon';
import VarPopup from '../popup';
import ImagePreview from '../image-preview';
import Ripple from '../ripple';
import { defineComponent } from '../utils/create';
import { props } from './props';
import { isNumber, isHTMLSupportImage, isHTMLSupportVideo, toNumber, isString } from '../utils/shared';
import { ValidationMixin } from '../utils/mixins/validation';
import { createChildrenMixin } from '../utils/mixins/relation';
var fid = 0;

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-uploader var--box"
  }, [_c('div', {
    staticClass: "var-uploader__file-list"
  }, [_vm._l(_vm.value, function (f) {
    return _c('div', {
      directives: [{
        name: "ripple",
        rawName: "v-ripple",
        value: {
          disabled: _vm.disabled || _vm.formDisabled || _vm.readonly || _vm.formReadonly || !_vm.ripple
        },
        expression: "{ disabled: disabled || formDisabled || readonly || formReadonly || !ripple }"
      }],
      key: f.id,
      staticClass: "var-uploader__file var-elevation--2",
      class: [f.state === 'loading' ? 'var-uploader--loading' : null],
      on: {
        "click": function ($event) {
          return _vm.preview(f);
        }
      }
    }, [_c('div', {
      staticClass: "var-uploader__file-name"
    }, [_vm._v("\n        " + _vm._s(f.name || f.url) + "\n      ")]), _vm._v(" "), _vm.removable ? _c('div', {
      staticClass: "var-uploader__file-close",
      on: {
        "click": function ($event) {
          $event.stopPropagation();
          return _vm.handleRemove(f);
        }
      }
    }, [_c('var-icon', {
      staticClass: "var-uploader__file-close-icon",
      attrs: {
        "var-uploader-cover": "",
        "name": "delete"
      }
    })], 1) : _vm._e(), _vm._v(" "), f.cover ? _c('img', {
      staticClass: "var-uploader__file-cover",
      style: {
        objectFit: f.fit
      },
      attrs: {
        "src": f.cover,
        "alt": f.name
      }
    }) : _vm._e(), _vm._v(" "), _c('div', {
      staticClass: "var-uploader__file-indicator",
      class: [f.state === 'success' ? 'var-uploader--success' : null, f.state === 'error' ? 'var-uploader--error' : null]
    })]);
  }), _vm._v(" "), !_vm.maxlength || _vm.value.length < _vm.maxlength ? _c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: _vm.disabled || _vm.formDisabled || _vm.readonly || _vm.formReadonly || !_vm.ripple || _vm.hasSlots('default')
      },
      expression: "{ disabled: disabled || formDisabled || readonly || formReadonly || !ripple || hasSlots('default') }"
    }],
    staticClass: "var--relative",
    class: [!_vm.hasSlots('default') ? 'var-uploader__action var-elevation--2' : null, _vm.disabled || _vm.formDisabled ? 'var-uploader--disabled' : null]
  }, [_c('input', {
    staticClass: "var-uploader__action-input",
    attrs: {
      "type": "file",
      "multiple": _vm.multiple,
      "accept": _vm.accept,
      "capture": _vm.capture,
      "disabled": _vm.disabled || _vm.formDisabled || _vm.readonly || _vm.formReadonly
    },
    on: {
      "change": _vm.handleChange
    }
  }), _vm._v(" "), _vm._t("default", function () {
    return [_c('var-icon', {
      staticClass: "var-uploader__action-icon",
      attrs: {
        "var-uploader-cover": "",
        "name": "plus"
      }
    })];
  })], 2) : _vm._e()], 2), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage,
      "maxlength-text": _vm.maxlengthText
    }
  }), _vm._v(" "), _c('var-popup', {
    attrs: {
      "class": 'var-uploader__preview',
      "var-uploader-cover": "",
      "position": "center",
      "show": _vm.showPreview
    },
    on: {
      "update:show": function ($event) {
        _vm.showPreview = $event;
      },
      "closed": function ($event) {
        _vm.currentPreview = null;
      }
    }
  }, [_vm.currentPreview && _vm.isHTMLSupportVideo(_vm.currentPreview.url) ? _c('video', {
    staticClass: "var-uploader__preview-video",
    attrs: {
      "playsinline": "true",
      "webkit-playsinline": "true",
      "x5-playsinline": "true",
      "x5-video-player-type": "h5",
      "x5-video-player-fullscreen": "false",
      "controls": "",
      "src": _vm.currentPreview && _vm.currentPreview.url
    }
  }) : _vm._e()])], 1);
};

var staticRenderFns = [];
export default defineComponent({
  render,
  staticRenderFns,
  name: 'VarUploader',
  mixins: [ValidationMixin, createChildrenMixin('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  directives: {
    Ripple
  },
  components: {
    VarIcon,
    VarPopup,
    VarFormDetails
  },
  props,
  data: () => ({
    showPreview: false,
    currentPreview: null,
    callReset: false
  }),
  computed: {
    maxlengthText() {
      var {
        maxlength,
        value: {
          length
        }
      } = this;
      return isNumber(maxlength) ? length + " / " + maxlength : '';
    },

    formDisabled() {
      var _this$form;

      return (_this$form = this.form) == null ? void 0 : _this$form.disabled;
    },

    formReadonly() {
      var _this$form2;

      return (_this$form2 = this.form) == null ? void 0 : _this$form2.readonly;
    }

  },
  watch: {
    value: {
      handler() {
        !this.callReset && this.validateWithTrigger('onChange');
        this.callReset = false;
      },

      deep: true
    }
  },
  methods: {
    // expose
    getSuccess() {
      return this.value.filter(varFile => varFile.state === 'success');
    },

    // expose
    getError() {
      return this.value.filter(varFile => varFile.state === 'error');
    },

    // expose
    getLoading() {
      return this.value.filter(varFile => varFile.state === 'loading');
    },

    // expose
    validate() {
      return this._validate(this.rules, this.value, {
        getSuccess: this.getSuccess,
        getError: this.getError,
        getLoading: this.getLoading
      });
    },

    // expose
    reset() {
      var _this$getListeners$on, _this$getListeners;

      this.callReset = true;
      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, []);
      this.resetValidation();
    },

    isHTMLSupportVideo,

    validateWithTrigger(trigger) {
      this.$nextTick(() => {
        var {
          validateTrigger,
          rules,
          value
        } = this;

        this._validateWithTrigger(validateTrigger, trigger, rules, value, {
          getSuccess: this.getSuccess,
          getError: this.getError,
          getLoading: this.getLoading
        });
      });
    },

    preview(varFile) {
      var {
        disabled,
        readonly,
        previewed
      } = this;

      if (this.formDisabled || this.formReadonly || disabled || readonly || !previewed) {
        return;
      }

      var {
        url
      } = varFile;

      if (isString(url) && isHTMLSupportImage(url)) {
        ImagePreview(url);
        return;
      }

      if (isString(url) && isHTMLSupportVideo(url)) {
        this.currentPreview = varFile;
        this.showPreview = true;
      }
    },

    createVarFile(file) {
      return {
        id: fid++,
        url: '',
        cover: '',
        name: file.name,
        file
      };
    },

    getFiles(event) {
      var el = event.target;
      var {
        files
      } = el;
      return Array.from(files);
    },

    resolver(varFile) {
      return new Promise(resolve => {
        var fileReader = new FileReader();

        fileReader.onload = () => {
          var base64 = fileReader.result;
          varFile.file.type.startsWith('image') && (varFile.cover = base64);
          varFile.url = base64;
          resolve(varFile);
        };

        fileReader.readAsDataURL(varFile.file);
      });
    },

    getResolvers(varFiles) {
      return varFiles.map(this.resolver);
    },

    getBeforeReaders(varFiles) {
      var {
        onBeforeRead
      } = this.getListeners();
      return varFiles.map(varFile => {
        return new Promise(resolve => {
          var valid = onBeforeRead ? onBeforeRead(varFile) : true;
          Promise.resolve(valid).then(valid => resolve({
            valid,
            varFile
          }));
        });
      });
    },

    handleChange(event) {
      var _this = this;

      return _asyncToGenerator(function* () {
        var _getListeners$onInput, _getListeners2;

        var {
          formDisabled,
          formReadonly,
          maxsize,
          maxlength,
          value,
          readonly,
          disabled,
          getListeners
        } = _this;

        if (formDisabled || formReadonly || disabled || readonly) {
          return;
        }

        var getValidSizeVarFile = varFiles => {
          return varFiles.filter(varFile => {
            if (varFile.file.size > toNumber(maxsize)) {
              var _getListeners$onOvers, _getListeners;

              (_getListeners$onOvers = (_getListeners = getListeners()).onOversize) == null ? void 0 : _getListeners$onOvers.call(_getListeners, varFile);
              return false;
            }

            return true;
          });
        };

        var getValidLengthVarFiles = varFiles => {
          var limit = Math.min(varFiles.length, toNumber(maxlength) - value.length);
          return varFiles.slice(0, limit);
        }; // limit


        var files = _this.getFiles(event);

        var varFiles = files.map(_this.createVarFile);
        varFiles = maxsize != null ? getValidSizeVarFile(varFiles) : varFiles;
        varFiles = maxlength != null ? getValidLengthVarFiles(varFiles) : varFiles; // pre resolve

        var resolvedVarFiles = yield Promise.all(_this.getResolvers(varFiles));
        var validationVarFiles = yield Promise.all(_this.getBeforeReaders(resolvedVarFiles));
        var validVarFiles = validationVarFiles.filter(_ref => {
          var {
            valid
          } = _ref;
          return valid;
        }).map(_ref2 => {
          var {
            varFile
          } = _ref2;
          return varFile;
        });
        (_getListeners$onInput = (_getListeners2 = getListeners()).onInput) == null ? void 0 : _getListeners$onInput.call(_getListeners2, [...value, ...validVarFiles]);
        event.target.value = '';
        validVarFiles.forEach(varFile => {
          var _getListeners$onAfter, _getListeners3;

          return (_getListeners$onAfter = (_getListeners3 = getListeners()).onAfterRead) == null ? void 0 : _getListeners$onAfter.call(_getListeners3, varFile);
        });
      })();
    },

    handleRemove(removedVarFile) {
      var _this2 = this;

      return _asyncToGenerator(function* () {
        var {
          formDisabled,
          formReadonly,
          disabled,
          readonly,
          value,
          getListeners
        } = _this2;
        var {
          onBeforeRemove,
          onRemove,
          onInput
        } = getListeners();

        if (formDisabled || formReadonly || disabled || readonly) {
          return;
        }

        if (onBeforeRemove && !(yield onBeforeRemove(removedVarFile))) {
          return;
        }

        var expectedFiles = value.filter(varFile => varFile !== removedVarFile);
        onRemove == null ? void 0 : onRemove(removedVarFile);

        _this2.validateWithTrigger('onRemove');

        onInput == null ? void 0 : onInput(expectedFiles);
      })();
    }

  }
});