import Vue from 'vue';
export function pickProps(props, propsKey) {
  return Array.isArray(propsKey) ? propsKey.reduce((pickedProps, key) => {
    pickedProps[key] = props[key];
    return pickedProps;
  }, {}) : props[propsKey];
}
export function mountComponent(component, container, options) {
  if (container === void 0) {
    container = 'body';
  }

  if (options === void 0) {
    options = {};
  }

  var instance = new (Vue.extend(component))(options);
  var el = instance.$mount().$el;
  var wrapper = document.querySelector(container);
  wrapper.appendChild(el);
  return {
    instance,

    unmount() {
      instance.$destroy();
      wrapper.removeChild(el);
    }

  };
}
export function addRouteListener(vm, cb) {
  vm.$on('hook:mounted', () => {
    window.addEventListener('hashchange', cb);
    window.addEventListener('popstate', cb);
  });
  vm.$on('hook:beforeDestroy', () => {
    window.removeEventListener('hashchange', cb);
    window.removeEventListener('popstate', cb);
  });
}