function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

import { isArray } from '../shared';
export var ValidationMixin = {
  data: () => ({
    errorMessage: ''
  }),
  methods: {
    _validate(rules, value, apis) {
      var _this = this;

      return _asyncToGenerator(function* () {
        if (!isArray(rules) || !rules.length) {
          return true;
        }

        var resArr = yield Promise.all(rules.map(rule => rule(value, apis)));
        var valid = !resArr.some(res => {
          if (res !== true) {
            _this.errorMessage = String(res);
            return true;
          }

          return false;
        });
        valid && (_this.errorMessage = '');
        return valid;
      })();
    },

    _validateWithTrigger(validateTrigger, trigger, rules, value, apis) {
      var _this2 = this;

      return _asyncToGenerator(function* () {
        if (validateTrigger.includes(trigger)) {
          yield _this2._validate(rules, value, apis);
        }
      })();
    },

    // expose
    resetValidation() {
      this.errorMessage = '';
    }

  }
};