"use strict";

exports.__esModule = true;
exports.default = exports._ActionSheetComponent = void 0;

var _ActionSheet = _interopRequireDefault(require("./ActionSheet.js"));

var _vue = _interopRequireDefault(require("vue"));

var _shared = require("../utils/shared");

var _components = require("../utils/components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var singletonInstance;

function ActionSheet(options) {
  if (!(0, _shared.inBrowser)()) {
    return Promise.resolve();
  }

  return new Promise(resolve => {
    ActionSheet.close();
    var actionSheetOptions = (0, _shared.isString)(options) || (0, _shared.isNumber)(options) ? {
      message: String(options)
    } : options;
    var {
      instance,
      unmount
    } = (0, _components.mountComponent)(_ActionSheet.default, 'body', {
      propsData: _extends({}, actionSheetOptions)
    });
    instance.show = true;
    singletonInstance = instance;
    instance.$on('select', action => {
      actionSheetOptions.onSelect == null ? void 0 : actionSheetOptions.onSelect(action);
      resolve(action);
    });
    instance.$on('open', () => {
      actionSheetOptions.onOpen == null ? void 0 : actionSheetOptions.onOpen();
    });
    instance.$on('opened', () => {
      actionSheetOptions.onOpened == null ? void 0 : actionSheetOptions.onOpened();
    });
    instance.$on('close', () => {
      actionSheetOptions.onClose == null ? void 0 : actionSheetOptions.onClose();
      resolve('close');
    });
    instance.$on('closed', () => {
      actionSheetOptions.onClosed == null ? void 0 : actionSheetOptions.onClosed();
      unmount();
      singletonInstance === actionSheetOptions && (singletonInstance = null);
    });
    instance.$on('route-change', () => {
      unmount();
      singletonInstance === actionSheetOptions && (singletonInstance = null);
    });
    instance.$on('update:show', value => {
      instance.show = value;
    });
    instance.show = true;
  });
}

ActionSheet.Component = _ActionSheet.default;

_ActionSheet.default.install = function (app) {
  app.component(_ActionSheet.default.name, _ActionSheet.default);
};

ActionSheet.close = () => {
  if (singletonInstance != null) {
    var prevSingletonOptions = singletonInstance;
    singletonInstance = null;

    _vue.default.nextTick().then(() => {
      prevSingletonOptions.show = false;
    });
  }
};

ActionSheet.install = function (app) {
  app.component(_ActionSheet.default.name, _ActionSheet.default);
};

var _ActionSheetComponent = _ActionSheet.default;
exports._ActionSheetComponent = _ActionSheetComponent;
var _default = ActionSheet;
exports.default = _default;