"use strict";

exports.__esModule = true;
exports.default = void 0;

var _create = require("../utils/create");

var _button = _interopRequireDefault(require("../button"));

var _icon = _interopRequireDefault(require("../icon"));

var _props = require("./props");

var _shared = require("../utils/shared");

var _elements = require("../utils/elements");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "backTopEl",
    staticClass: "var-back-top",
    class: [_vm.show ? 'var-back-top--active' : null],
    style: {
      right: _vm.toSizeUnit(_vm.right),
      bottom: _vm.toSizeUnit(_vm.bottom)
    },
    on: {
      "click": function ($event) {
        $event.stopPropagation();
        return _vm.click.apply(null, arguments);
      }
    }
  }, [_vm._t("default", function () {
    return [_c('var-button', {
      attrs: {
        "type": "primary",
        "round": "",
        "var-back-top-cover": ""
      }
    }, [_c('var-icon', {
      attrs: {
        "name": "chevron-up"
      }
    })], 1)];
  })], 2);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarBackTop',
  components: {
    VarButton: _button.default,
    VarIcon: _icon.default
  },
  props: _props.props,
  data: () => ({
    show: false,
    localTarget: undefined,
    throttleScroll: null
  }),

  mounted() {
    this.throttleScroll = (0, _shared.throttle)(this.scroll, 200);
    this.localTarget = this.target ? this.getTarget() : (0, _elements.getParentScroller)(this.$refs.backTopEl);
    this.localTarget.addEventListener('scroll', this.throttleScroll);
  },

  destroyed() {
    this.localTarget.removeEventListener('scroll', this.throttleScroll);
  },

  methods: {
    toSizeUnit: _elements.toSizeUnit,

    click(e) {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onClick) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, e);
      var left = (0, _elements.getScrollLeft)(this.localTarget);
      (0, _elements.scrollTo)(this.localTarget, {
        left,
        duration: this.duration,
        animation: _shared.easeInOutCubic
      });
    },

    scroll() {
      this.show = (0, _elements.getScrollTop)(this.localTarget) >= (0, _elements.toPxNum)(this.visibilityHeight);
    },

    getTarget() {
      if ((0, _shared.isObject)(this.target)) {
        return this.target;
      }

      if ((0, _shared.isString)(this.target)) {
        var el = document.querySelector(this.target);

        if (!el) {
          throw Error('[Varlet] BackTop: target element cannot found');
        }

        return el;
      }

      throw Error('[Varlet] BackTop: type of prop "target" should be a selector or an element object');
    }

  }
});

exports.default = _default;