"use strict";

exports.__esModule = true;
exports.default = void 0;

var _ripple = _interopRequireDefault(require("../ripple"));

var _badge = _interopRequireDefault(require("../badge"));

var _icon = _interopRequireDefault(require("../icon"));

var _create = require("../utils/create");

var _props = require("./props");

var _relation = require("../utils/mixins/relation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var defaultBadgeProps = {
  type: 'danger',
  dot: true
};

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('button', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple"
    }],
    ref: "bottomNavigationItem",
    staticClass: "var-bottom-navigation-item",
    style: {
      color: _vm.computeColorStyle()
    },
    on: {
      "click": _vm.handleClick
    }
  }, [_vm.icon && !_vm.$slots.icon ? _c('var-icon', {
    staticClass: "var-bottom-navigation-item__icon",
    attrs: {
      "name": _vm.icon,
      "namespace": _vm.namespace
    }
  }) : _vm._e(), _vm._v(" "), _vm._t("icon", null, {
    "active": _vm.isActive
  }), _vm._v(" "), _vm.badge ? _c('var-badge', _vm._b({
    staticClass: "var-bottom-navigation-item__badge"
  }, 'var-badge', _vm.badgeProps, false)) : _vm._e(), _vm._v(" "), _c('span', {
    staticClass: "var-bottom-navigation-item__label"
  }, [!_vm.$slots.default ? [_vm._v("\n      " + _vm._s(_vm.label) + "\n    ")] : _vm._e(), _vm._v(" "), _vm._t("default")], 2)], 2);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarBottomNavigationItem',
  components: {
    VarBadge: _badge.default,
    VarIcon: _icon.default
  },
  directives: {
    Ripple: _ripple.default
  },
  mixins: [(0, _relation.createChildrenMixin)('bottomNavigation', {
    parentKey: 'bottomNavigation',
    childrenKey: 'bottomNavigationItems'
  })],
  inheritAttrs: false,
  props: _props.props,
  data: () => ({
    isActive: false,
    badgeProps: {}
  }),

  mounted() {
    this.isActive = this.name === this.bottomNavigation.active || this.index === this.bottomNavigation.active;

    if (this.isActive) {
      this.$refs.bottomNavigationItem.classList.add('var-bottom-navigation-item--active');
    }
  },

  watch: {
    badge: {
      handler(newValue) {
        this.badgeProps = newValue === true ? defaultBadgeProps : this.badge;
      },

      immediate: true
    }
  },
  methods: {
    computeColorStyle() {
      var {
        activeColor,
        inactiveColor
      } = this.bottomNavigation;
      return this.isActive ? activeColor : inactiveColor;
    },

    setCurrent(value) {
      var _isActive = value === this.index || value === this.name;

      if (_isActive === this.isActive) {
        return;
      }

      this.isActive = _isActive;

      if (this.isActive) {
        this.$refs.bottomNavigationItem.classList.add('var-bottom-navigation-item--active');
      } else {
        this.$refs.bottomNavigationItem.classList.remove('var-bottom-navigation-item--active');
      }
    },

    handleClick() {
      var _getListeners$onClick, _getListeners;

      var {
        name,
        getListeners,
        index
      } = this;
      var active = name != null ? name : index;
      (_getListeners$onClick = (_getListeners = getListeners()).onClick) == null ? void 0 : _getListeners$onClick.call(_getListeners, active);
      this.bottomNavigation.onToggle(active);
    }

  }
});

exports.default = _default;