"use strict";

exports.__esModule = true;
exports.default = void 0;

var _button = _interopRequireDefault(require("../button"));

var _create = require("../utils/create");

var _props = require("./props");

var _shared = require("../utils/shared");

var _relation = require("../utils/mixins/relation");

var _elements = require("../utils/elements");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var RIGHT_HALF_SPACE_CLASS = 'var-bottom-navigation-item--right-half-space';
var LEFT_HALF_SPACE_CLASS = 'var-bottom-navigation-item--left-half-space';
var RIGHT_SPACE_CLASS = 'var-bottom-navigation-item--right-space';
var defaultFabProps = {
  type: 'primary'
};

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "bottomNavigationDom",
    staticClass: "var-bottom-navigation",
    class: [_vm.fixed ? 'var-bottom-navigation--fixed' : null, _vm.border ? 'var-bottom-navigation--border' : null],
    style: "z-index:" + _vm.zIndex
  }, [_vm._t("default"), _vm._v(" "), _vm.$slots.fab ? _c('var-button', _vm._b({
    staticClass: "var-bottom-navigation__fab",
    class: _vm.bottomNavigationItems.length % 2 ? 'var-bottom-navigation--fab-right' : 'var-bottom-navigation--fab-center',
    attrs: {
      "round": ""
    },
    on: {
      "click": _vm.handleFabClick
    }
  }, 'var-button', _vm._fabProps, false), [_vm._t("fab")], 2) : _vm._e()], 2);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarBottomNavigation',
  components: {
    VarButton: _button.default
  },
  mixins: [(0, _relation.createParentMixin)('bottomNavigation', {
    childrenKey: 'bottomNavigationItems'
  })],
  inheritAttrs: false,
  props: _props.props,
  data: () => ({
    _fabProps: {}
  }),
  watch: {
    bottomNavigationItems() {
      var _this = this;

      return _asyncToGenerator(function* () {
        yield (0, _elements.doubleRaf)();

        _this.matchBoundary();

        _this.removeMarginClass();

        if (!_this.$slots.fab) {
          return;
        }

        _this.addMarginClass();
      })();
    },

    fabProps: {
      handler(newValue) {
        this._fabProps = _extends({}, defaultFabProps, newValue);
      },

      immediate: true,
      deep: true
    }
  },
  methods: {
    matchBoundary() {
      if (this.bottomNavigationItems.length === 0 || this.matchName() || this.matchIndex()) {
        return;
      }

      this.handleActiveIndex();
    },

    matchName() {
      return this.bottomNavigationItems.find(_ref => {
        var {
          name
        } = _ref;
        return this.active === name;
      });
    },

    matchIndex() {
      return this.bottomNavigationItems.find(_ref2 => {
        var {
          index
        } = _ref2;
        return this.active === index;
      });
    },

    handleActiveIndex() {
      if (!(0, _shared.isNumber)(this.active)) {
        return;
      }

      var {
        getListeners
      } = this;

      if (this.active < 0) {
        var _getListeners$onUpdat, _getListeners;

        (_getListeners$onUpdat = (_getListeners = getListeners())['onUpdate:active']) == null ? void 0 : _getListeners$onUpdat.call(_getListeners, 0);
        this.itemsSetCurrent(0);
      } else if (this.active > this.bottomNavigationItems.length - 1) {
        var _getListeners$onUpdat2, _getListeners2;

        (_getListeners$onUpdat2 = (_getListeners2 = getListeners())['onUpdate:active']) == null ? void 0 : _getListeners$onUpdat2.call(_getListeners2, this.bottomNavigationItems.length - 1);
        this.itemsSetCurrent(this.bottomNavigationItems.length - 1);
      }
    },

    itemsSetCurrent(value) {
      this.bottomNavigationItems.forEach(item => {
        item.setCurrent(value);
      });
    },

    onToggle(changedValue) {
      if (changedValue === this.active) {
        return;
      }

      var {
        getListeners
      } = this;
      getListeners().onBeforeChange ? this.handleBeforeChange(changedValue) : this.handleChange(changedValue);
    },

    handleBeforeChange(changedValue) {
      var _getListeners$onBefor, _getListeners3;

      var {
        getListeners
      } = this;
      Promise.resolve((_getListeners$onBefor = (_getListeners3 = getListeners()).onBeforeChange) == null ? void 0 : _getListeners$onBefor.call(_getListeners3, changedValue)).then(res => res && this.handleChange(changedValue));
    },

    handleChange(changedValue) {
      var _getListeners$onUpdat3, _getListeners4, _getListeners$onChang, _getListeners5;

      var {
        getListeners
      } = this;
      (_getListeners$onUpdat3 = (_getListeners4 = getListeners())['onUpdate:active']) == null ? void 0 : _getListeners$onUpdat3.call(_getListeners4, changedValue);
      this.itemsSetCurrent(changedValue);
      (_getListeners$onChang = (_getListeners5 = getListeners()).onChange) == null ? void 0 : _getListeners$onChang.call(_getListeners5, changedValue);
    },

    getBottomNavigationItems() {
      return Array.from(this.$refs.bottomNavigationDom.querySelectorAll('.var-bottom-navigation-item'));
    },

    removeMarginClass() {
      this.getBottomNavigationItems().forEach(dom => {
        dom.classList.remove(RIGHT_HALF_SPACE_CLASS, LEFT_HALF_SPACE_CLASS, RIGHT_SPACE_CLASS);
      });
    },

    addMarginClass() {
      var isEven = this.bottomNavigationItems.length % 2 === 0;
      this.getBottomNavigationItems().forEach((bottomNavigationItem, i) => {
        this.handleMarginClass(isEven, bottomNavigationItem, i, this.bottomNavigationItems.length);
      });
    },

    handleMarginClass(isEven, dom, i, length) {
      var isLast = i === length - 1;

      if (!isEven && isLast) {
        dom.classList.add(RIGHT_SPACE_CLASS);
        return;
      }

      var isFabLeft = i === length / 2 - 1;
      var isFabRight = i === length / 2;

      if (isFabLeft) {
        dom.classList.add(RIGHT_HALF_SPACE_CLASS);
      } else if (isFabRight) {
        dom.classList.add(LEFT_HALF_SPACE_CLASS);
      }
    },

    handleFabClick() {
      var _getListeners$onFabCl, _getListeners6;

      var {
        getListeners
      } = this;
      (_getListeners$onFabCl = (_getListeners6 = getListeners()).onFabClick) == null ? void 0 : _getListeners$onFabCl.call(_getListeners6);
    }

  }
});

exports.default = _default;