"use strict";

exports.__esModule = true;
exports.default = void 0;

var _ripple = _interopRequireDefault(require("../ripple"));

var _create = require("../utils/create");

var _props = require("./props");

var _elements = require("../utils/elements");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: !_vm.ripple
      },
      expression: "{ disabled: !ripple }"
    }],
    staticClass: "var-card",
    class: [_vm.elevation ? "var-elevation--" + _vm.elevation : 'var-elevation--2'],
    on: {
      "click": _vm.handleClick
    }
  }, [_vm._t("image", function () {
    return [_vm.src ? _c('img', {
      staticClass: "var-card__image",
      style: {
        objectFit: _vm.fit,
        height: _vm.toSizeUnit(_vm.height)
      },
      attrs: {
        "src": _vm.src,
        "alt": _vm.alt
      }
    }) : _vm._e()];
  }), _vm._v(" "), _vm._t("title", function () {
    return [_vm.title ? _c('div', {
      staticClass: "var-card__title"
    }, [_vm._v(_vm._s(_vm.title))]) : _vm._e()];
  }), _vm._v(" "), _vm._t("subtitle", function () {
    return [_vm.subtitle ? _c('div', {
      staticClass: "var-card__subtitle"
    }, [_vm._v(_vm._s(_vm.subtitle))]) : _vm._e()];
  }), _vm._v(" "), _vm._t("description", function () {
    return [_vm.description ? _c('div', {
      staticClass: "var-card__description"
    }, [_vm._v(_vm._s(_vm.description))]) : _vm._e()];
  }), _vm._v(" "), _vm.hasSlots('extra') ? _c('div', {
    staticClass: "var-card__footer"
  }, [_vm._t("extra")], 2) : _vm._e()], 2);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarCard',
  directives: {
    Ripple: _ripple.default
  },
  props: _props.props,
  data: () => ({
    toSizeUnit: _elements.toSizeUnit
  }),
  methods: {
    handleClick(e) {
      var {
        disabled,
        getListeners
      } = this;
      var {
        onClick
      } = getListeners();

      if (!onClick || disabled) {
        return;
      }

      onClick(e);
    }

  }
});

exports.default = _default;