"use strict";

exports.__esModule = true;
exports.default = void 0;

var _icon = _interopRequireDefault(require("../icon"));

var _formDetails = _interopRequireDefault(require("../form-details"));

var _ripple = _interopRequireDefault(require("../ripple"));

var _create = require("../utils/create");

var _props = require("./props");

var _validation = require("../utils/mixins/validation");

var _relation = require("../utils/mixins/relation");

var _elements = require("../utils/elements");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-checkbox__wrap",
    on: {
      "click": _vm.handleClick
    }
  }, [_c('div', {
    staticClass: "var-checkbox"
  }, [_c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: _vm.formReadonly || _vm.readonly || _vm.formDisabled || _vm.disabled || !_vm.ripple
      },
      expression: "{ disabled: formReadonly || readonly || formDisabled || disabled || !ripple }"
    }],
    staticClass: "var-checkbox__action",
    class: [_vm.checked ? 'var-checkbox--checked' : 'var-checkbox--unchecked', _vm.errorMessage || _vm.checkboxGroupErrorMessage ? 'var-checkbox--error' : null, _vm.formDisabled || _vm.disabled ? 'var-checkbox--disabled' : null],
    style: {
      color: _vm.checked ? _vm.checkedColor : _vm.uncheckedColor
    }
  }, [_vm.checked ? _vm._t("checked-icon", function () {
    return [_c('var-icon', {
      staticClass: "var-checkbox__icon",
      class: [_vm.withAnimation ? 'var-checkbox--with-animation' : null],
      attrs: {
        "name": "checkbox-marked",
        "size": _vm.iconSize,
        "var-checkbox-cover": ""
      }
    })];
  }) : _vm._e(), _vm._v(" "), !_vm.checked ? _vm._t("unchecked-icon", function () {
    return [_c('var-icon', {
      staticClass: "var-checkbox__icon",
      class: [_vm.withAnimation ? 'var-checkbox--with-animation' : null],
      attrs: {
        "name": "checkbox-blank-outline",
        "size": _vm.iconSize,
        "var-checkbox-cover": ""
      }
    })];
  }) : _vm._e()], 2), _vm._v(" "), _c('div', {
    staticClass: "var-checkbox__text",
    class: [_vm.errorMessage || _vm.checkboxGroupErrorMessage ? 'var-checkbox--error' : null, _vm.formDisabled || _vm.disabled ? 'var-checkbox--disabled' : null]
  }, [_vm._t("default")], 2)]), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarCheckbox',
  mixins: [_validation.ValidationMixin, (0, _relation.createChildrenMixin)('checkboxGroup', {
    childrenKey: 'checkboxes'
  }), (0, _relation.createChildrenMixin)('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  directives: {
    Ripple: _ripple.default
  },
  components: {
    VarIcon: _icon.default,
    VarFormDetails: _formDetails.default
  },
  props: _props.props,
  data: () => ({
    localValue: false,
    withAnimation: false
  }),
  computed: {
    checked() {
      return this.localValue === this.checkedValue;
    },

    checkboxGroupErrorMessage() {
      var _this$checkboxGroup;

      return (_this$checkboxGroup = this.checkboxGroup) == null ? void 0 : _this$checkboxGroup.checkboxGroupErrorMessage;
    },

    formReadonly() {
      var _this$form;

      return (_this$form = this.form) == null ? void 0 : _this$form.readonly;
    },

    formDisabled() {
      var _this$form2;

      return (_this$form2 = this.form) == null ? void 0 : _this$form2.disabled;
    }

  },
  watch: {
    value: {
      handler(newValue) {
        this.localValue = newValue;
      },

      immediate: true
    }
  },
  methods: {
    // expose
    reset() {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, this.uncheckedValue);
      this.resetValidation();
    },

    // expose
    toggle(changedValue) {
      var {
        checkedValue,
        uncheckedValue
      } = this;
      var shouldReverse = ![checkedValue, uncheckedValue].includes(changedValue);

      if (shouldReverse) {
        changedValue = this.checked ? uncheckedValue : checkedValue;
      }

      this.change(changedValue);
    },

    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    validateWithTrigger(trigger) {
      this.$nextTick(() => {
        var {
          validateTrigger,
          rules,
          value
        } = this;

        this._validateWithTrigger(validateTrigger, trigger, rules, value);
      });
    },

    change(changedValue) {
      var _getListeners$onInput, _getListeners, _getListeners$onChang, _getListeners2, _this$checkboxGroup2, _this$checkboxGroup3;

      var {
        checkedValue,
        getListeners
      } = this;
      this.localValue = changedValue;
      (_getListeners$onInput = (_getListeners = getListeners()).onInput) == null ? void 0 : _getListeners$onInput.call(_getListeners, this.localValue);
      (_getListeners$onChang = (_getListeners2 = getListeners()).onChange) == null ? void 0 : _getListeners$onChang.call(_getListeners2, this.localValue);
      this.validateWithTrigger('onChange');
      changedValue === checkedValue ? (_this$checkboxGroup2 = this.checkboxGroup) == null ? void 0 : _this$checkboxGroup2.onChecked(checkedValue) : (_this$checkboxGroup3 = this.checkboxGroup) == null ? void 0 : _this$checkboxGroup3.onUnchecked(checkedValue);
    },

    handleClick(e) {
      var _this = this;

      return _asyncToGenerator(function* () {
        var _this$form3, _getListeners$onClick, _getListeners3, _this$form4;

        var {
          disabled,
          readonly,
          checkedValue,
          uncheckedValue,
          getListeners
        } = _this;

        if ((_this$form3 = _this.form) != null && _this$form3.disabled || disabled) {
          return;
        }

        (_getListeners$onClick = (_getListeners3 = getListeners()).onClick) == null ? void 0 : _getListeners$onClick.call(_getListeners3, e);

        if ((_this$form4 = _this.form) != null && _this$form4.readonly || readonly) {
          return;
        }

        _this.withAnimation = false;
        var maximum = _this.checkboxGroup ? _this.checkboxGroup.checkedCount >= Number(_this.checkboxGroup.max) : false;

        if (!_this.checked && maximum) {
          return;
        }

        _this.change(_this.checked ? uncheckedValue : checkedValue);

        yield (0, _elements.doubleRaf)();
        _this.withAnimation = true;
      })();
    },

    sync(values) {
      var {
        checkedValue,
        uncheckedValue
      } = this;
      this.localValue = values.includes(checkedValue) ? checkedValue : uncheckedValue;
    }

  }
});

exports.default = _default;