"use strict";

exports.__esModule = true;
exports.default = void 0;

var _create = require("../utils/create");

var _props = require("./props");

var _elements = require("../utils/elements");

var _shared = require("../utils/shared");

//
//
//
//
//
//
//
//
var SECOND = 1000;
var MINUTE = 60 * SECOND;
var HOUR = 60 * MINUTE;
var DAY = 24 * HOUR;

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-countdown"
  }, [_vm._t("default", function () {
    return [_vm._v("\n    " + _vm._s(_vm.showTime) + "\n  ")];
  }, null, _vm.timeData)], 2);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarCountdown',
  props: _props.props,
  data: () => ({
    endTime: 0,
    isStart: false,
    showTime: '',
    handle: 0,
    pauseTime: 0,
    timeData: {
      days: 0,
      hours: 0,
      minutes: 0,
      seconds: 0,
      milliseconds: 0
    }
  }),
  watch: {
    time: {
      handler() {
        this.reset();
      },

      immediate: true
    }
  },
  methods: {
    formatTime(durationTime) {
      var {
        onChange
      } = this.getListeners();
      var days = Math.floor(durationTime / DAY);
      var hours = Math.floor(durationTime % DAY / HOUR);
      var minutes = Math.floor(durationTime % HOUR / MINUTE);
      var seconds = Math.floor(durationTime % MINUTE / SECOND);
      var milliseconds = Math.floor(durationTime % SECOND);
      var time = {
        days,
        hours,
        minutes,
        seconds,
        milliseconds
      };
      this.timeData = time;
      onChange == null ? void 0 : onChange(time);
      this.showTime = (0, _shared.parseFormat)(this.format, time);
    },

    countdown() {
      var {
        time,
        autoStart,
        getListeners
      } = this;
      var {
        onEnd
      } = getListeners();
      var now = Date.now();
      if (!this.endTime) this.endTime = now + (0, _shared.toNumber)(time);
      var durationTime = this.endTime - now;
      if (durationTime < 0) durationTime = 0;
      this.pauseTime = durationTime;
      this.formatTime(durationTime);

      if (durationTime === 0) {
        onEnd == null ? void 0 : onEnd();
        return;
      }

      if (autoStart || this.isStart) this.handle = (0, _elements.requestAnimationFrame)(this.countdown);
    },

    start() {
      if (this.isStart) {
        return;
      }

      this.isStart = true;
      this.endTime = Date.now() + (this.pauseTime || (0, _shared.toNumber)(this.time));
      this.countdown();
    },

    pause() {
      this.isStart = false;
    },

    reset() {
      this.endTime = 0;
      this.isStart = false;
      (0, _elements.cancelAnimationFrame)(this.handle);
      this.countdown();
    }

  }
});

exports.default = _default;