"use strict";

exports.__esModule = true;
exports.default = void 0;

var _icon = _interopRequireDefault(require("../icon"));

var _formDetails = _interopRequireDefault(require("../form-details"));

var _ripple = _interopRequireDefault(require("../ripple"));

var _create = require("../utils/create");

var _decimal = require("decimal.js");

var _props = require("./props");

var _shared = require("../utils/shared");

var _elements = require("../utils/elements");

var _validation = require("../utils/mixins/validation");

var _relation = require("../utils/mixins/relation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var SPEED = 100;
var DELAY = 600;

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-counter var--box"
  }, [_c('div', _vm._b({
    staticClass: "var-counter__controller var-elevation--2",
    class: [_vm.disabled || _vm.formDisabled ? 'var-counter--disabled' : null, _vm.errorMessage ? 'var-counter--error' : null],
    style: {
      background: _vm.color ? _vm.color : undefined
    }
  }, 'div', _vm.$attrs, false), [_c('var-icon', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: !_vm.ripple || _vm.disabled || _vm.readonly || _vm.disableDecrement || !_vm.decrementButton || _vm.isMin
      },
      expression: "{\n        disabled: !ripple || disabled || readonly || disableDecrement || !decrementButton || isMin,\n      }"
    }],
    staticClass: "var-counter__decrement-button",
    class: [!_vm.decrementButton ? 'var-counter--hidden' : null],
    style: {
      width: _vm.toSizeUnit(_vm.buttonSize),
      height: _vm.toSizeUnit(_vm.buttonSize)
    },
    attrs: {
      "var-counter-cover": "",
      "name": "minus"
    },
    on: {
      "click": _vm.decrement
    },
    nativeOn: {
      "touchstart": function ($event) {
        return _vm.pressDecrement.apply(null, arguments);
      },
      "touchend": function ($event) {
        return _vm.releaseDecrement.apply(null, arguments);
      },
      "touchcancel": function ($event) {
        return _vm.releaseDecrement.apply(null, arguments);
      }
    }
  }), _vm._v(" "), _c('input', {
    directives: [{
      name: "model",
      rawName: "v-model",
      value: _vm.inputValue,
      expression: "inputValue"
    }],
    staticClass: "var-counter__input",
    style: {
      width: _vm.toSizeUnit(_vm.inputWidth),
      fontSize: _vm.toSizeUnit(_vm.inputTextSize)
    },
    attrs: {
      "inputmode": _vm.toNumber(_vm.decimalLength) === 0 ? 'numeric' : 'decimal',
      "readonly": _vm.readonly || _vm.formReadonly,
      "disabled": _vm.disabled || _vm.formDisabled || _vm.disableInput
    },
    domProps: {
      "value": _vm.inputValue
    },
    on: {
      "change": _vm.handleChange,
      "input": function ($event) {
        if ($event.target.composing) {
          return;
        }

        _vm.inputValue = $event.target.value;
      }
    }
  }), _vm._v(" "), _c('var-icon', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple",
      value: {
        disabled: !_vm.ripple || _vm.disabled || _vm.readonly || _vm.disableIncrement || !_vm.incrementButton || _vm.isMax
      },
      expression: "{\n        disabled: !ripple || disabled || readonly || disableIncrement || !incrementButton || isMax,\n      }"
    }],
    staticClass: "var-counter__increment-button",
    class: [!_vm.incrementButton ? 'var-counter--hidden' : null],
    style: {
      width: _vm.toSizeUnit(_vm.buttonSize),
      height: _vm.toSizeUnit(_vm.buttonSize)
    },
    attrs: {
      "var-counter-cover": "",
      "name": "plus"
    },
    on: {
      "click": _vm.increment
    },
    nativeOn: {
      "touchstart": function ($event) {
        return _vm.pressIncrement.apply(null, arguments);
      },
      "touchend": function ($event) {
        return _vm.releaseIncrement.apply(null, arguments);
      },
      "touchcancel": function ($event) {
        return _vm.releaseIncrement.apply(null, arguments);
      }
    }
  })], 1), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarCounter',
  components: {
    VarIcon: _icon.default,
    VarFormDetails: _formDetails.default
  },
  directives: {
    Ripple: _ripple.default
  },
  mixins: [_validation.ValidationMixin, (0, _relation.createChildrenMixin)('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  inheritAttrs: false,
  props: _props.props,
  data: () => ({
    inputValue: '',
    incrementTimer: null,
    decrementTimer: null,
    incrementDelayTimer: null,
    decrementDelayTimer: null
  }),
  computed: {
    isMax() {
      var {
        max,
        value
      } = this;
      return max != null && (0, _shared.toNumber)(value) >= (0, _shared.toNumber)(max);
    },

    isMin() {
      var {
        min,
        value
      } = this;
      return min != null && (0, _shared.toNumber)(value) <= (0, _shared.toNumber)(min);
    },

    formDisabled() {
      var _this$form;

      return (_this$form = this.form) == null ? void 0 : _this$form.disabled;
    },

    formReadonly() {
      var _this$form2;

      return (_this$form2 = this.form) == null ? void 0 : _this$form2.readonly;
    }

  },

  created() {
    this.setNormalizedValue(this.normalizeValue(String(this.value)));
  },

  watch: {
    value(newValue) {
      var _this$getListeners$on, _this$getListeners;

      this.setNormalizedValue(this.normalizeValue(String(newValue)));
      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onChange) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, (0, _shared.toNumber)(newValue));
    }

  },
  methods: {
    // expose
    reset() {
      var _getListeners$onInput, _getListeners;

      var {
        min,
        getListeners
      } = this;
      (_getListeners$onInput = (_getListeners = getListeners()).onInput) == null ? void 0 : _getListeners$onInput.call(_getListeners, min != null ? (0, _shared.toNumber)(min) : 0);
      this.resetValidation();
    },

    toNumber: _shared.toNumber,
    toSizeUnit: _elements.toSizeUnit,

    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    validateWithTrigger(trigger) {
      this.$nextTick(() => {
        var {
          validateTrigger,
          rules,
          value
        } = this;

        this._validateWithTrigger(validateTrigger, trigger, rules, value);
      });
    },

    normalizeValue(value) {
      var {
        decimalLength,
        max,
        min
      } = this;
      var num = (0, _shared.toNumber)(value);

      if (max != null && num > (0, _shared.toNumber)(max)) {
        num = (0, _shared.toNumber)(max);
      }

      if (min != null && num < (0, _shared.toNumber)(min)) {
        num = (0, _shared.toNumber)(min);
      }

      value = String(num);

      if (decimalLength != null) {
        value = num.toFixed((0, _shared.toNumber)(decimalLength));
      }

      return value;
    },

    handleChange(event) {
      var _getListeners$onBefor, _getListeners2;

      var {
        lazyChange,
        getListeners,
        change,
        validateWithTrigger
      } = this;
      var {
        value
      } = event.target;
      var normalizedValue = this.normalizeValue(value);
      lazyChange ? (_getListeners$onBefor = (_getListeners2 = getListeners()).onBeforeChange) == null ? void 0 : _getListeners$onBefor.call(_getListeners2, (0, _shared.toNumber)(normalizedValue), change) : this.setNormalizedValue(normalizedValue);
      validateWithTrigger('onInputChange');
    },

    decrement() {
      var {
        disabled,
        readonly,
        disableDecrement,
        decrementButton,
        lazyChange,
        step,
        value,
        getListeners
      } = this;
      var {
        onDecrement,
        onBeforeChange
      } = getListeners();

      if (this.formDisabled || this.formReadonly || disabled || readonly || disableDecrement || !decrementButton) {
        return;
      }

      if (this.isMin) {
        return;
      }

      var localValue = new _decimal.Decimal((0, _shared.toNumber)(value)).minus(new _decimal.Decimal((0, _shared.toNumber)(step))).toString();
      var normalizedValue = this.normalizeValue(localValue);
      var normalizedValueNum = (0, _shared.toNumber)(normalizedValue);
      onDecrement == null ? void 0 : onDecrement(normalizedValueNum);

      if (lazyChange) {
        onBeforeChange == null ? void 0 : onBeforeChange(normalizedValueNum, this.change);
      } else {
        this.setNormalizedValue(normalizedValue);
        this.validateWithTrigger('onDecrement');
      }
    },

    increment() {
      var {
        disabled,
        readonly,
        disableIncrement,
        incrementButton,
        lazyChange,
        step,
        value,
        getListeners
      } = this;
      var {
        onIncrement,
        onBeforeChange
      } = getListeners();

      if (this.formDisabled || this.formReadonly || disabled || readonly || disableIncrement || !incrementButton) {
        return;
      }

      if (this.isMax) {
        return;
      }

      var localValue = new _decimal.Decimal((0, _shared.toNumber)(value)).plus(new _decimal.Decimal((0, _shared.toNumber)(step))).toString();
      var normalizedValue = this.normalizeValue(localValue);
      var normalizedValueNum = (0, _shared.toNumber)(normalizedValue);
      onIncrement == null ? void 0 : onIncrement(normalizedValueNum);

      if (lazyChange) {
        onBeforeChange == null ? void 0 : onBeforeChange(normalizedValueNum, this.change);
      } else {
        this.setNormalizedValue(normalizedValue);
        this.validateWithTrigger('onIncrement');
      }
    },

    pressDecrement() {
      var {
        press,
        lazyChange
      } = this;

      if (!press || lazyChange) {
        return;
      }

      this.decrementDelayTimer = window.setTimeout(() => {
        this.continuedDecrement();
      }, DELAY);
    },

    pressIncrement() {
      var {
        press,
        lazyChange
      } = this;

      if (!press || lazyChange) {
        return;
      }

      this.incrementDelayTimer = window.setTimeout(() => {
        this.continuedIncrement();
      }, DELAY);
    },

    releaseDecrement() {
      this.decrementTimer && clearTimeout(this.decrementTimer);
      this.decrementDelayTimer && clearTimeout(this.decrementDelayTimer);
    },

    releaseIncrement() {
      this.incrementTimer && clearTimeout(this.incrementTimer);
      this.incrementDelayTimer && clearTimeout(this.incrementDelayTimer);
    },

    continuedIncrement() {
      this.incrementTimer = window.setTimeout(() => {
        this.increment();
        this.continuedIncrement();
      }, SPEED);
    },

    continuedDecrement() {
      this.decrementTimer = window.setTimeout(() => {
        this.decrement();
        this.continuedDecrement();
      }, SPEED);
    },

    setNormalizedValue(normalizedValue) {
      var _this$getListeners$on2, _this$getListeners2;

      this.inputValue = normalizedValue;
      var normalizedValueNum = (0, _shared.toNumber)(normalizedValue);
      (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, normalizedValueNum);
    },

    change(value) {
      this.setNormalizedValue(this.normalizeValue(String(value)));
      this.validateWithTrigger('onLazyChange');
    }

  }
});

exports.default = _default;