"use strict";

exports.__esModule = true;
exports.default = void 0;

var _create = require("../utils/create");

var _dayjs = _interopRequireDefault(require("dayjs"));

var _monthPickerPanel = _interopRequireDefault(require("./src/month-picker-panel.js"));

var _yearPickerPanel = _interopRequireDefault(require("./src/year-picker-panel.js"));

var _dayPickerPanel = _interopRequireDefault(require("./src/day-picker-panel.js"));

var _props = require("./props");

var _shared = require("../utils/shared");

var _elements = require("../utils/elements");

var _locale = require("../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var startX = 0;
var startY = 0;
var checkType = '';
var touchDirection;
var currentDate = (0, _dayjs.default)().format('YYYY-MM-D');
var [currentYear, currentMonth] = currentDate == null ? void 0 : currentDate.split('-');

var monthDes = _props.MONTH_LIST.find(month => month.index === currentMonth);

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-date-picker",
    class: [_vm.shadow ? 'var-elevation--2' : null]
  }, [_c('div', {
    staticClass: "var-date-picker-title",
    style: {
      background: _vm.headerColor || _vm.color
    }
  }, [_c('div', {
    staticClass: "var-date-picker-title__year",
    class: [_vm.isYearPanel ? 'var-date-picker-title__year--active' : null],
    on: {
      "click": function ($event) {
        return _vm.clickEl('year');
      }
    }
  }, [_vm._t("year", function () {
    return [_vm._v("\n        " + _vm._s(_vm.previewYear) + "\n      ")];
  }, {
    "year": _vm.previewYear
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-date-picker-title__date",
    class: [!_vm.isYearPanel ? 'var-date-picker-title__date--active' : null, _vm.range ? 'var-date-picker-title__date--range' : null],
    on: {
      "click": function ($event) {
        return _vm.clickEl('date');
      }
    }
  }, [_c('transition', {
    attrs: {
      "name": _vm.multiple ? '' : "var-date-picker" + (_vm.reverse ? '-reverse' : '') + "-translatey"
    }
  }, [_vm.type === 'month' ? _c('div', {
    key: "" + _vm.chooseYear + (_vm.chooseMonth && _vm.chooseMonth.index)
  }, [_vm.range ? _vm._t("range", function () {
    return [_vm._v("\n            " + _vm._s(_vm.getMonthTitle) + "\n          ")];
  }, {
    "choose": _vm.getChoose.chooseRangeMonth
  }) : _vm.multiple ? _vm._t("multiple", function () {
    return [_vm._v("\n            " + _vm._s(_vm.getMonthTitle) + "\n          ")];
  }, {
    "choose": _vm.getChoose.chooseMonths
  }) : _vm._t("month", function () {
    return [_vm._v("\n            " + _vm._s(_vm.getMonthTitle) + "\n          ")];
  }, {
    "month": _vm.chooseMonth && _vm.chooseMonth.index,
    "year": _vm.chooseYear
  })], 2) : _c('div', {
    key: "" + _vm.chooseYear + (_vm.chooseMonth && _vm.chooseMonth.index) + _vm.chooseDay
  }, [_vm.range ? _vm._t("range", function () {
    return [_vm._v("\n            " + _vm._s(_vm.getDateTitle) + "\n          ")];
  }, {
    "choose": _vm.formatRange
  }) : _vm.multiple ? _vm._t("multiple", function () {
    return [_vm._v("\n            " + _vm._s(_vm.getDateTitle) + "\n          ")];
  }, {
    "choose": _vm.getChoose.chooseDays
  }) : _vm._t("date", function () {
    return [_vm._v("\n            " + _vm._s(_vm.getDateTitle) + "\n          ")];
  }, null, _vm.slotProps)], 2)])], 1)]), _vm._v(" "), _c('div', {
    staticClass: "var-date-picker-body",
    on: {
      "touchstart": _vm.handleTouchstart,
      "touchmove": _vm.handleTouchmove,
      "touchend": _vm.handleTouchend
    }
  }, [_c('transition', {
    attrs: {
      "name": "var-date-picker-panel-fade"
    }
  }, [_vm.getPanelType === 'year' ? _c('year-picker-panel', {
    attrs: {
      "component-props": _vm.componentProps,
      "preview": _vm.previewYear
    },
    on: {
      "choose-year": _vm.getChooseYear
    }
  }) : _vm.getPanelType === 'month' ? _c('month-picker-panel', {
    ref: "monthPanelEl",
    attrs: {
      "current": _vm.currentDate,
      "choose": _vm.getChoose,
      "preview": _vm.getPreview,
      "click-year": function () {
        return _vm.clickEl('year');
      },
      "component-props": _vm.componentProps
    },
    on: {
      "choose-month": _vm.getChooseMonth,
      "check-preview": _vm.checkPreview
    }
  }) : _vm.getPanelType === 'date' ? _c('day-picker-panel', {
    ref: "dayPanelEl",
    attrs: {
      "current": _vm.currentDate,
      "choose": _vm.getChoose,
      "preview": _vm.getPreview,
      "component-props": _vm.componentProps,
      "click-month": function () {
        return _vm.clickEl('month');
      }
    },
    on: {
      "choose-day": _vm.getChooseDay,
      "check-preview": _vm.checkPreview
    }
  }) : _vm._e()], 1)], 1)]);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarDatePicker',
  components: {
    MonthPickerPanel: _monthPickerPanel.default,
    YearPickerPanel: _yearPickerPanel.default,
    DayPickerPanel: _dayPickerPanel.default
  },
  props: _props.props,
  data: () => ({
    isYearPanel: false,
    isMonthPanel: false,
    rangeDone: true,
    chooseMonth: undefined,
    chooseYear: undefined,
    chooseDay: undefined,
    previewMonth: monthDes,
    previewYear: currentYear,
    reverse: false,
    chooseMonths: [],
    chooseDays: [],
    chooseRangeMonth: [],
    chooseRangeDay: []
  }),
  computed: {
    pack() {
      return _locale.pack.value;
    },

    currentDate() {
      return currentDate;
    },

    componentProps() {
      return {
        allowedDates: this.allowedDates,
        type: this.type,
        color: this.color,
        firstDayOfWeek: this.firstDayOfWeek,
        min: this.min,
        max: this.max,
        showCurrent: this.showCurrent,
        multiple: this.multiple,
        range: this.range
      };
    },

    getChoose() {
      return {
        chooseMonth: this.chooseMonth,
        chooseYear: this.chooseYear,
        chooseDay: this.chooseDay,
        chooseMonths: this.chooseMonths,
        chooseDays: this.chooseDays,
        chooseRangeMonth: this.chooseRangeMonth,
        chooseRangeDay: this.chooseRangeDay
      };
    },

    getPreview() {
      return {
        previewMonth: this.previewMonth,
        previewYear: this.previewYear
      };
    },

    getMonthTitle() {
      var {
        multiple,
        range,
        chooseRangeMonth,
        chooseMonth,
        pack,
        chooseMonths
      } = this;

      if (range) {
        return chooseRangeMonth.length ? chooseRangeMonth[0] + " ~ " + chooseRangeMonth[1] : '';
      }

      var monthName = '';

      if (chooseMonth) {
        var _pack$datePickerMonth, _pack$datePickerMonth2;

        monthName = (_pack$datePickerMonth = (_pack$datePickerMonth2 = pack.datePickerMonthDict) == null ? void 0 : _pack$datePickerMonth2[chooseMonth.index].name) != null ? _pack$datePickerMonth : '';
      }

      return multiple ? "" + chooseMonths.length + pack.datePickerSelected : monthName;
    },

    getDateTitle() {
      var _pack$datePickerWeekD, _pack$datePickerWeekD2, _pack$datePickerMonth3, _pack$datePickerMonth4;

      var {
        multiple,
        range,
        chooseRangeDay,
        chooseDays,
        pack,
        chooseYear,
        chooseMonth,
        chooseDay
      } = this;

      if (range) {
        var formatRangeDays = chooseRangeDay.map(date => (0, _dayjs.default)(date).format('YYYY-MM-DD'));
        return formatRangeDays.length ? formatRangeDays[0] + " ~ " + formatRangeDays[1] : '';
      }

      if (multiple) return "" + chooseDays.length + pack.datePickerSelected;
      if (!chooseYear || !chooseMonth || !chooseDay) return '';
      var weekIndex = (0, _dayjs.default)(chooseYear + "-" + chooseMonth.index + "-" + chooseDay).day();

      var week = _props.WEEK_HEADER.find(value => value.index === "" + weekIndex);

      var weekName = (_pack$datePickerWeekD = (_pack$datePickerWeekD2 = pack.datePickerWeekDict) == null ? void 0 : _pack$datePickerWeekD2[week.index].name) != null ? _pack$datePickerWeekD : '';
      var monthName = (_pack$datePickerMonth3 = (_pack$datePickerMonth4 = pack.datePickerMonthDict) == null ? void 0 : _pack$datePickerMonth4[chooseMonth.index].name) != null ? _pack$datePickerMonth3 : '';
      var showDay = chooseDay.padStart(2, '0');
      if (pack.lang === 'zh-CN') return chooseMonth.index + "-" + showDay + " " + weekName.slice(0, 3);
      return weekName.slice(0, 3) + ", " + monthName.slice(0, 3) + " " + chooseDay;
    },

    slotProps() {
      var _chooseMonth$index;

      var {
        chooseYear,
        chooseMonth,
        chooseDay
      } = this;
      var weekIndex = (0, _dayjs.default)(chooseYear + "-" + (chooseMonth == null ? void 0 : chooseMonth.index) + "-" + chooseDay).day();
      var date = chooseDay ? chooseDay == null ? void 0 : chooseDay.padStart(2, '0') : '';
      return {
        week: "" + weekIndex,
        year: chooseYear != null ? chooseYear : '',
        month: (_chooseMonth$index = chooseMonth == null ? void 0 : chooseMonth.index) != null ? _chooseMonth$index : '',
        date
      };
    },

    formatRange() {
      return this.getChoose.chooseRangeDay.map(choose => (0, _dayjs.default)(choose).format('YYYY-MM-DD'));
    },

    isSameYear() {
      return this.chooseYear === this.previewYear;
    },

    isSameMonth() {
      var _this$chooseMonth;

      return ((_this$chooseMonth = this.chooseMonth) == null ? void 0 : _this$chooseMonth.index) === this.previewMonth.index;
    },

    getPanelType() {
      if (this.isYearPanel) return 'year';
      if (this.type === 'month' || this.isMonthPanel) return 'month';
      if (this.type === 'date') return 'date';
      return '';
    },

    isUntouchable() {
      return !this.touchable || ['', 'year'].includes(this.getPanelType);
    }

  },
  watch: {
    value: {
      handler(newValue) {
        if (!this.checkValue() || this.invalidFormatDate(newValue) || !newValue) return;

        if (this.range) {
          if (!(0, _shared.isArray)(newValue)) return;
          this.rangeDone = newValue.length !== 1;
          this.rangeInit(newValue, this.type);
        } else if (this.multiple) {
          if (!(0, _shared.isArray)(newValue)) return;
          this.multipleInit(newValue, this.type);
        } else {
          this.dateInit(newValue);
        }
      },

      immediate: true
    },

    getPanelType() {
      this.resetState();
    }

  },
  methods: {
    clickEl(type) {
      if (type === 'year') this.isYearPanel = true;else if (type === 'month') this.isMonthPanel = true;else {
        this.isYearPanel = false;
        this.isMonthPanel = false;
      }
    },

    updateRange(date, type) {
      var rangeDate = type === 'month' ? 'chooseRangeMonth' : 'chooseRangeDay';
      this[rangeDate] = this.rangeDone ? [date, date] : [this[rangeDate][0], date];
      this.rangeDone = !this.rangeDone;

      if (this.rangeDone) {
        var _this$getListeners$on, _this$getListeners, _this$getListeners$on2, _this$getListeners2;

        var isChangeOrder = (0, _dayjs.default)(this[rangeDate][0]).isAfter(this[rangeDate][1]);

        var _date = isChangeOrder ? [this[rangeDate][1], this[rangeDate][0]] : [...this[rangeDate]];

        (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, _date);
        (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners()).onChange) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, _date);
      }
    },

    updateMultiple(date, type) {
      var _this$getListeners$on3, _this$getListeners3, _this$getListeners$on4, _this$getListeners4;

      var multipleDates = type === 'month' ? this.chooseMonths : this.chooseDays;
      var formatType = type === 'month' ? 'YYYY-MM' : 'YYYY-MM-DD';
      var formatDates = multipleDates.map(date => (0, _dayjs.default)(date).format(formatType));
      var index = formatDates.findIndex(choose => choose === date);
      if (index === -1) formatDates.push(date);else formatDates.splice(index, 1);
      (_this$getListeners$on3 = (_this$getListeners3 = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on3.call(_this$getListeners3, formatDates);
      (_this$getListeners$on4 = (_this$getListeners4 = this.getListeners()).onChange) == null ? void 0 : _this$getListeners$on4.call(_this$getListeners4, formatDates);
    },

    getReverse(dateType, date) {
      var {
        chooseYear,
        chooseMonth,
        isSameYear,
        previewYear,
        isSameMonth,
        chooseDay,
        previewMonth
      } = this;
      if (!chooseYear || !chooseMonth) return false;
      if (!isSameYear) return chooseYear > previewYear;
      if (dateType === 'month') return date.index < chooseMonth.index;
      return isSameMonth ? date < (0, _shared.toNumber)(chooseDay) : chooseMonth.index > previewMonth.index;
    },

    getChooseDay(day) {
      var {
        readonly,
        range,
        multiple,
        getListeners,
        getReverse,
        previewYear,
        previewMonth,
        updateRange,
        updateMultiple
      } = this;
      if (day < 0 || readonly) return;
      this.reverse = getReverse('day', day);
      var date = previewYear + "-" + previewMonth.index + "-" + day;
      var formatDate = (0, _dayjs.default)(date).format('YYYY-MM-DD');
      if (range) updateRange(formatDate, 'day');else if (multiple) updateMultiple(formatDate, 'day');else {
        var _getListeners$onInput, _getListeners, _getListeners$onChang, _getListeners2;

        (_getListeners$onInput = (_getListeners = getListeners()).onInput) == null ? void 0 : _getListeners$onInput.call(_getListeners, formatDate);
        (_getListeners$onChang = (_getListeners2 = getListeners()).onChange) == null ? void 0 : _getListeners$onChang.call(_getListeners2, formatDate);
      }
    },

    getChooseMonth(month) {
      var {
        type,
        readonly,
        range,
        multiple,
        getListeners,
        getReverse,
        previewYear,
        updateRange,
        updateMultiple
      } = this;
      this.reverse = getReverse('month', month);

      if (type === 'month' && !readonly) {
        var date = previewYear + "-" + month.index;
        if (range) updateRange(date, 'month');else if (multiple) updateMultiple(date, 'month');else {
          var _getListeners$onInput2, _getListeners3, _getListeners$onChang2, _getListeners4;

          (_getListeners$onInput2 = (_getListeners3 = getListeners()).onInput) == null ? void 0 : _getListeners$onInput2.call(_getListeners3, date);
          (_getListeners$onChang2 = (_getListeners4 = getListeners()).onChange) == null ? void 0 : _getListeners$onChang2.call(_getListeners4, date);
        }
      } else {
        this.previewMonth = month;
      }

      this.isMonthPanel = false;
    },

    getChooseYear(year) {
      this.previewYear = "" + year;
      this.isYearPanel = false;
      this.isMonthPanel = true;
    },

    checkPreview(type, checkType) {
      var changeValue = checkType === 'prev' ? -1 : 1;

      if (type === 'year') {
        this.previewYear = "" + ((0, _shared.toNumber)(this.previewYear) + changeValue);
      } else {
        var checkIndex = (0, _shared.toNumber)(this.previewMonth.index) + changeValue;

        if (checkIndex < 1) {
          this.previewYear = "" + ((0, _shared.toNumber)(this.previewYear) - 1);
          checkIndex = 12;
        }

        if (checkIndex > 12) {
          this.previewYear = "" + ((0, _shared.toNumber)(this.previewYear) + 1);
          checkIndex = 1;
        }

        this.previewMonth = _props.MONTH_LIST.find(month => (0, _shared.toNumber)(month.index) === checkIndex);
      }
    },

    checkValue() {
      var {
        multiple,
        range,
        value
      } = this;

      if ((multiple || range) && !(0, _shared.isArray)(value)) {
        console.error('[Varlet] DatePicker: type of prop "value" should be an Array');
        return false;
      }

      if (!multiple && !range && (0, _shared.isArray)(value)) {
        console.error('[Varlet] DatePicker: type of prop "value" should be a String');
        return false;
      }

      return true;
    },

    invalidFormatDate(date) {
      if ((0, _shared.isArray)(date)) return false;

      if (date === 'Invalid Date') {
        console.error('[Varlet] DatePicker: "value" is an Invalid Date');
        return true;
      }

      return false;
    },

    rangeInit(value, type) {
      var rangeDate = type === 'month' ? 'chooseRangeMonth' : 'chooseRangeDay';
      var formatType = type === 'month' ? 'YYYY-MM' : 'YYYY-MM-D';
      var formatDateList = value.map(choose => (0, _dayjs.default)(choose).format(formatType)).slice(0, 2);
      var isValid = this[rangeDate].some(date => this.invalidFormatDate(date));
      if (isValid) return;
      this[rangeDate] = formatDateList;
      var isChangeOrder = (0, _dayjs.default)(this[rangeDate][0]).isAfter(this[rangeDate][1]);

      if (this[rangeDate].length === 2 && isChangeOrder) {
        this[rangeDate] = [this[rangeDate][1], this[rangeDate][0]];
      }
    },

    multipleInit(value, type) {
      var formatType = type === 'month' ? 'YYYY-MM' : 'YYYY-MM-D'; // 需要去重

      var formatDateList = Array.from(new Set(value.map(choose => (0, _dayjs.default)(choose).format(formatType))));

      if (type === 'month') {
        this.chooseMonths = formatDateList.filter(date => date !== 'Invalid Date');
      } else {
        this.chooseDays = formatDateList.filter(date => date !== 'Invalid Date');
      }
    },

    dateInit(value) {
      var formatDate = (0, _dayjs.default)(value).format('YYYY-MM-D');
      if (this.invalidFormatDate(formatDate)) return;
      var [yearValue, monthValue, dayValue] = formatDate.split('-');

      var monthDes = _props.MONTH_LIST.find(month => month.index === monthValue);

      this.chooseMonth = monthDes;
      this.chooseYear = yearValue;
      this.chooseDay = dayValue;
      this.previewMonth = monthDes;
      this.previewYear = yearValue;
    },

    handleTouchstart(event) {
      if (this.isUntouchable) return;
      var {
        clientX,
        clientY
      } = event.touches[0];
      startX = clientX;
      startY = clientY;
    },

    getDirection(x, y) {
      return x >= y && x > 20 ? 'x' : 'y';
    },

    handleTouchmove(event) {
      if (this.isUntouchable) return;
      var {
        clientX,
        clientY
      } = event.touches[0];
      var x = clientX - startX;
      var y = clientY - startY;
      touchDirection = this.getDirection(Math.abs(x), Math.abs(y));
      checkType = x > 0 ? 'prev' : 'next';
    },

    handleTouchend() {
      if (this.isUntouchable || touchDirection !== 'x') return;
      var componentRef = this.getPanelType === 'month' ? 'monthPanelEl' : 'dayPanelEl';
      (0, _elements.nextTickFrame)(() => {
        this.$refs[componentRef].forwardRef(checkType);
        this.resetState();
      });
    },

    resetState() {
      startY = 0;
      startX = 0;
      checkType = '';
      touchDirection = undefined;
    }

  }
});

exports.default = _default;