"use strict";

exports.__esModule = true;
exports.props = exports.WEEK_HEADER = exports.MONTH_LIST = void 0;

function typeValidator(type) {
  return ['date', 'month'].includes(type);
}

var MONTH_LIST = [{
  index: '01'
}, {
  index: '02'
}, {
  index: '03'
}, {
  index: '04'
}, {
  index: '05'
}, {
  index: '06'
}, {
  index: '07'
}, {
  index: '08'
}, {
  index: '09'
}, {
  index: '10'
}, {
  index: '11'
}, {
  index: '12'
}];
exports.MONTH_LIST = MONTH_LIST;
var WEEK_HEADER = [{
  index: '0'
}, {
  index: '1'
}, {
  index: '2'
}, {
  index: '3'
}, {
  index: '4'
}, {
  index: '5'
}, {
  index: '6'
}];
exports.WEEK_HEADER = WEEK_HEADER;
var props = {
  value: {
    type: [String, Array]
  },
  type: {
    type: String,
    default: 'date',
    validator: typeValidator
  },
  allowedDates: {
    type: Function
  },
  color: {
    type: String
  },
  headerColor: {
    type: String
  },
  shadow: {
    type: Boolean,
    default: false
  },
  firstDayOfWeek: {
    type: [String, Number],
    default: 0
  },
  min: {
    type: String
  },
  max: {
    type: String
  },
  showCurrent: {
    type: Boolean,
    default: true
  },
  readonly: {
    type: Boolean,
    default: false
  },
  multiple: {
    type: Boolean,
    default: false
  },
  range: {
    type: Boolean,
    default: false
  },
  touchable: {
    type: Boolean,
    default: true
  }
};
exports.props = props;