"use strict";

exports.__esModule = true;
exports.default = void 0;

var _button = _interopRequireDefault(require("../../button"));

var _icon = _interopRequireDefault(require("../../icon"));

var _create = require("../../utils/create");

var _shared = require("../../utils/shared");

var _locale = require("../../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-picker-header"
  }, [_c('var-button', {
    staticStyle: {
      "filter": "opacity(0.54)"
    },
    attrs: {
      "round": "",
      "text": "",
      "disabled": _vm.disabled.left
    },
    on: {
      "click": function ($event) {
        return _vm.checkDate('prev');
      }
    }
  }, [_c('var-icon', {
    attrs: {
      "name": "chevron-left"
    }
  })], 1), _vm._v(" "), _c('div', {
    staticClass: "var-picker-header__value",
    on: {
      "click": function ($event) {
        return _vm.$emit('check-panel');
      }
    }
  }, [_c('transition', {
    attrs: {
      "name": "var-date-picker" + (_vm.reverse ? '-reverse' : '') + "-translatex"
    }
  }, [_c('div', {
    key: _vm.showDate
  }, [_vm._v(_vm._s(_vm.showDate))])])], 1), _vm._v(" "), _c('var-button', {
    staticStyle: {
      "filter": "opacity(0.54)"
    },
    attrs: {
      "round": "",
      "text": "",
      "disabled": _vm.disabled.right
    },
    on: {
      "click": function ($event) {
        return _vm.checkDate('next');
      }
    }
  }, [_c('var-icon', {
    attrs: {
      "name": "chevron-right"
    }
  })], 1)], 1);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'PanelHeader',
  components: {
    VarButton: _button.default,
    VarIcon: _icon.default
  },
  props: {
    date: {
      type: Object,
      required: true
    },
    type: {
      type: String,
      default: 'date'
    },
    disabled: {
      type: Object,
      required: true
    }
  },
  data: () => ({
    reverse: false,
    forwardOrBackNum: 0
  }),
  computed: {
    pack() {
      return _locale.pack.value;
    },

    showDate() {
      var _pack$datePickerMonth;

      var {
        date: {
          previewMonth,
          previewYear
        },
        type,
        forwardOrBackNum,
        pack
      } = this;
      if (type === 'month') return (0, _shared.toNumber)(previewYear) + forwardOrBackNum;
      var monthName = (_pack$datePickerMonth = pack.datePickerMonthDict) == null ? void 0 : _pack$datePickerMonth[previewMonth.index].name;
      return pack.lang === 'zh-CN' ? previewYear + " " + monthName : monthName + " " + previewYear;
    }

  },
  watch: {
    date() {
      this.forwardOrBackNum = 0;
    }

  },
  methods: {
    checkDate(checkType) {
      if (checkType === 'prev' && this.disabled.left || checkType === 'next' && this.disabled.right) return;
      this.$emit('check-date', checkType);
      this.reverse = checkType === 'prev';
      this.forwardOrBackNum += checkType === 'prev' ? -1 : 1;
    }

  }
});

exports.default = _default;