"use strict";

exports.__esModule = true;
exports.default = void 0;

var _create = require("../../utils/create");

var _dayjs = _interopRequireDefault(require("dayjs"));

var _shared = require("../../utils/shared");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('ul', {
    staticClass: "var-year-picker__panel"
  }, _vm._l(_vm.yearList, function (year) {
    return _c('li', {
      key: year,
      class: [year === _vm.toNumber(_vm.preview) ? 'var-year-picker__panel--active' : null],
      style: {
        color: year === _vm.toNumber(_vm.preview) ? _vm.componentProps.color : ''
      },
      on: {
        "click": function ($event) {
          return _vm.chooseYear(year);
        }
      }
    }, [_vm._v("\n    " + _vm._s(year) + "\n  ")]);
  }), 0);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'YearPickerPanel',
  props: {
    preview: {
      type: String
    },
    componentProps: {
      type: Object,
      required: true
    }
  },
  computed: {
    yearList() {
      var list = [];
      var {
        preview,
        componentProps: {
          max,
          min
        }
      } = this;
      if (!preview) return list;
      var yearRange = [(0, _shared.toNumber)(preview) + 100, (0, _shared.toNumber)(preview) - 100];

      if (max) {
        var formatMax = (0, _dayjs.default)(max).format('YYYY-MM-D');
        var year = (0, _shared.toNumber)(formatMax.split('-')[0]);
        if (year < yearRange[0] && year > yearRange[1]) yearRange = [year, yearRange[1]];
        if (year <= yearRange[1]) return [year];
      }

      if (min) {
        var formatMin = (0, _dayjs.default)(min).format('YYYY-MM-D');

        var _year = (0, _shared.toNumber)(formatMin.split('-')[0]);

        if (_year < yearRange[0] && _year > yearRange[1]) yearRange = [yearRange[0], _year];
        if (_year >= yearRange[0]) return [_year];
      }

      for (var i = yearRange[0]; i >= yearRange[1]; i--) {
        list.push(i);
      }

      return list;
    }

  },

  mounted() {
    var activeEl = document.querySelector('.var-year-picker__panel--active');
    activeEl == null ? void 0 : activeEl.scrollIntoView({
      block: 'center'
    });
  },

  methods: {
    toNumber: _shared.toNumber,

    chooseYear(year) {
      this.$emit('choose-year', year);
    }

  }
});

exports.default = _default;