"use strict";

exports.__esModule = true;
exports.default = void 0;

var _popup = _interopRequireDefault(require("../popup"));

var _button = _interopRequireDefault(require("../button"));

var _props = require("./props");

var _create = require("../utils/create");

var _shared = require("../utils/shared");

var _locale = require("../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('var-popup', {
    staticClass: "var-dialog__popup",
    attrs: {
      "var-dialog-cover": "",
      "show": _vm.popupShow,
      "overlay": _vm.overlay,
      "overlay-class": _vm.overlayClass,
      "overlay-style": _vm.overlayStyle,
      "lock-scroll": _vm.lockScroll,
      "close-on-click-overlay": _vm.popupCloseOnClickOverlay,
      "teleport": _vm.teleport
    },
    on: {
      "open": function ($event) {
        return _vm.$emit('open');
      },
      "close": function ($event) {
        return _vm.$emit('close');
      },
      "closed": function ($event) {
        return _vm.$emit('closed');
      },
      "opened": function ($event) {
        return _vm.$emit('opened');
      },
      "route-change": function ($event) {
        return _vm.$emit('route-change');
      },
      "click-overlay": _vm.handleClickOverlay
    }
  }, [_c('div', _vm._b({
    staticClass: "var--box var-dialog",
    class: _vm.dialogClass,
    style: _vm.dialogStyle
  }, 'div', _vm.$attrs, false), [_c('div', {
    staticClass: "var-dialog__title"
  }, [_vm._t("title", function () {
    return [_vm._v(_vm._s(_vm.dt(_vm.title, _vm.pack.dialogTitle)))];
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-dialog__message",
    style: {
      textAlign: _vm.messageAlign
    }
  }, [_vm._t("default", function () {
    return [_vm._v("\n        " + _vm._s(_vm.message) + "\n      ")];
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-dialog__actions"
  }, [_vm.cancelButton ? _c('var-button', {
    staticClass: "var-dialog__button var-dialog__cancel-button",
    attrs: {
      "var-dialog-cover": "",
      "text": "",
      "text-color": _vm.cancelButtonTextColor,
      "color": _vm.cancelButtonColor
    },
    on: {
      "click": _vm.cancel
    }
  }, [_vm._v("\n        " + _vm._s(_vm.dt(_vm.cancelButtonText, _vm.pack.dialogCancelButtonText)) + "\n      ")]) : _vm._e(), _vm._v(" "), _vm.confirmButton ? _c('var-button', {
    staticClass: "var-dialog__button var-dialog__confirm-button",
    attrs: {
      "var-dialog-cover": "",
      "text": "",
      "text-color": _vm.confirmButtonTextColor,
      "color": _vm.confirmButtonColor
    },
    on: {
      "click": _vm.confirm
    }
  }, [_vm._v("\n        " + _vm._s(_vm.dt(_vm.confirmButtonText, _vm.pack.dialogConfirmButtonText)) + "\n      ")]) : _vm._e()], 1)])]);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarDialog',
  components: {
    VarPopup: _popup.default,
    VarButton: _button.default
  },
  inheritAttrs: false,
  props: _props.props,
  data: () => ({
    popupShow: false,
    popupCloseOnClickOverlay: false
  }),
  computed: {
    pack() {
      return _locale.pack.value;
    }

  },
  watch: {
    show: {
      handler(newValue) {
        this.popupShow = newValue;
      },

      immediate: true
    },
    closeOnClickOverlay: {
      handler(newValue) {
        if (this.getListeners().onBeforeClose != null) {
          this.popupCloseOnClickOverlay = false;
          return;
        }

        this.popupCloseOnClickOverlay = newValue;
      },

      immediate: true
    }
  },
  methods: {
    dt: _shared.dt,

    done() {
      this.$emit('update:show', false);
    },

    normalizeBeforeClose() {
      return this.getListeners().onBeforeClose || this.beforeClose;
    },

    handleClickOverlay() {
      var {
        closeOnClickOverlay,
        normalizeBeforeClose
      } = this;
      var onBeforeClose = normalizeBeforeClose();
      this.$emit('click-overlay');

      if (!closeOnClickOverlay) {
        return;
      }

      if (onBeforeClose != null) {
        onBeforeClose('close', this.done);
        return;
      }

      this.$emit('update:show', false);
    },

    confirm() {
      var onBeforeClose = this.normalizeBeforeClose();
      this.$emit('confirm');

      if (onBeforeClose != null) {
        onBeforeClose('confirm', this.done);
        return;
      }

      this.$emit('update:show', false);
    },

    cancel() {
      var onBeforeClose = this.normalizeBeforeClose();
      this.$emit('cancel');

      if (onBeforeClose != null) {
        onBeforeClose('cancel', this.done);
        return;
      }

      this.$emit('update:show', false);
    }

  }
});

exports.default = _default;