"use strict";

exports.__esModule = true;
exports.default = void 0;

var _create = require("../utils/create");

var _elements = require("../utils/elements");

var _shared = require("../utils/shared");

var _props = require("./props");

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-divider var--box",
    class: [_vm.vertical ? 'var-divider--vertical' : null, _vm.withText ? 'var-divider--with-text' : null, _vm.isInset ? 'var-divider--inset' : null, _vm.dashed ? 'var-divider--dashed' : null],
    style: _vm.style
  }, [_vm._t("default", function () {
    return [_vm.description ? _c('span', {
      staticClass: "var-divider__text"
    }, [_vm._v(_vm._s(_vm.description))]) : _vm._e()];
  })], 2);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarDivider',
  props: _props.props,
  data: () => ({
    withText: false
  }),
  computed: {
    isInset() {
      return (0, _shared.isBool)(this.inset) ? this.inset : true;
    },

    style() {
      var {
        inset,
        vertical,
        margin
      } = this;
      var baseStyle = {
        margin
      };
      if ((0, _shared.isBool)(inset) || inset === 0) return _extends({}, baseStyle); // -18px -> -18

      var _inset = (0, _shared.toNumber)(inset); // -18px -> 18px


      var absInsetWithUnit = Math.abs(_inset) + (inset + '').replace(_inset + '', '');
      return vertical ? _extends({}, baseStyle, {
        height: "calc(80% - " + (0, _elements.toSizeUnit)(absInsetWithUnit) + ")"
      }) : _extends({}, baseStyle, {
        width: "calc(100% - " + (0, _elements.toSizeUnit)(absInsetWithUnit) + ")",
        left: _inset > 0 ? (0, _elements.toSizeUnit)(absInsetWithUnit) : (0, _elements.toSizeUnit)(0)
      });
    }

  },

  mounted() {
    this.checkHasText();
  },

  updated() {
    this.checkHasText();
  },

  methods: {
    checkHasText() {
      this.withText = Boolean(this.hasSlots('default')) || Boolean(this.description);
    }

  }
});

exports.default = _default;