"use strict";

exports.__esModule = true;
exports.default = exports._ImagePreviewComponent = void 0;

var _ImagePreview = _interopRequireDefault(require("./ImagePreview.js"));

var _vue = _interopRequireDefault(require("vue"));

var _shared = require("../utils/shared");

var _components = require("../utils/components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var singletonInstance;

function ImagePreview(options) {
  if (!(0, _shared.inBrowser)()) {
    return;
  }

  ImagePreview.close();
  var imagePreviewOptions = (0, _shared.isString)(options) ? {
    images: [options]
  } : (0, _shared.isArray)(options) ? {
    images: options
  } : options;
  var {
    instance,
    unmount
  } = (0, _components.mountComponent)(_ImagePreview.default, 'body', {
    propsData: _extends({}, imagePreviewOptions)
  });
  instance.show = true;
  singletonInstance = instance;
  instance.$on('open', () => imagePreviewOptions.onOpen == null ? void 0 : imagePreviewOptions.onOpen());
  instance.$on('opened', () => imagePreviewOptions.onOpened == null ? void 0 : imagePreviewOptions.onOpened());
  instance.$on('close', () => imagePreviewOptions.onClose == null ? void 0 : imagePreviewOptions.onClose());
  instance.$on('closed', () => {
    imagePreviewOptions.onClosed == null ? void 0 : imagePreviewOptions.onClosed();
    unmount();
    singletonInstance === imagePreviewOptions && (singletonInstance = null);
  });
  instance.$on('change', index => {
    imagePreviewOptions.onChange == null ? void 0 : imagePreviewOptions.onChange(index);
  });
  instance.$on('route-change', () => {
    unmount();
    singletonInstance === instance && (singletonInstance = null);
  });
  instance.$on('update:show', value => {
    instance.show = value;
  });
  instance.show = true;
}

ImagePreview.close = () => {
  if (singletonInstance != null) {
    var prevSingletonInstance = singletonInstance;
    singletonInstance = null;

    _vue.default.nextTick(() => {
      prevSingletonInstance.show = false;
    });
  }
};

_ImagePreview.default.install = function (app) {
  app.component(_ImagePreview.default.name, _ImagePreview.default);
};

ImagePreview.install = function (app) {
  app.component(_ImagePreview.default.name, _ImagePreview.default);
};

ImagePreview.Component = _ImagePreview.default;
var _ImagePreviewComponent = _ImagePreview.default;
exports._ImagePreviewComponent = _ImagePreviewComponent;
var _default = ImagePreview;
exports.default = _default;