"use strict";

exports.__esModule = true;
exports.default = void 0;

var _sticky = _interopRequireDefault(require("../sticky"));

var _create = require("../utils/create");

var _props = require("./props");

var _relation = require("../utils/mixins/relation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c(_vm.sticky ? 'var-sticky' : 'transition', {
    ref: "anchorEl",
    tag: "component",
    attrs: {
      "offset-top": _vm.sticky ? _vm.stickyOffsetTop : null,
      "z-index": _vm.sticky ? _vm.zIndex : null,
      "disabled": _vm.disabled && !_vm.cssMode,
      "css-mode": _vm.cssMode
    }
  }, [_c('div', _vm._b({
    staticClass: "var-index-anchor"
  }, 'div', _vm.$attrs, false), [_vm._t("default", function () {
    return [_vm._v(_vm._s(_vm.name))];
  })], 2)]);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarIndexAnchor',
  mixins: [(0, _relation.createChildrenMixin)('indexBar', {
    indexKey: 'localIndex',
    parentKey: 'indexBar',
    childrenKey: 'indexAnchors'
  })],
  components: {
    VarSticky: _sticky.default
  },
  inheritAttrs: false,
  props: _props.props,
  data: () => ({
    ownTop: 0,
    disabled: false
  }),
  computed: {
    name() {
      return this.index;
    },

    active() {
      return this.indexBar.active;
    },

    sticky() {
      return this.indexBar.sticky;
    },

    cssMode() {
      return this.indexBar.cssMode;
    },

    stickyOffsetTop() {
      return this.indexBar.stickyOffsetTop;
    },

    zIndex() {
      return this.indexBar.zIndex;
    }

  },
  methods: {
    setOwnTop() {
      var {
        $refs: {
          anchorEl
        }
      } = this;
      if (!anchorEl) return;
      this.ownTop = anchorEl.$el ? anchorEl.$el.offsetTop : anchorEl.offsetTop;
    },

    setDisabled(value) {
      this.disabled = value;
    }

  }
});

exports.default = _default;