"use strict";

exports.__esModule = true;
exports.default = void 0;

var _loading = _interopRequireDefault(require("../loading"));

var _ripple = _interopRequireDefault(require("../ripple"));

var _create = require("../utils/create");

var _elements = require("../utils/elements");

var _props = require("./props");

var _shared = require("../utils/shared");

var _locale = require("../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    ref: "listEl",
    staticClass: "var-list var--box"
  }, [_vm._t("default"), _vm._v(" "), _vm.loading ? _vm._t("loading", function () {
    return [_c('div', {
      staticClass: "var-list__loading"
    }, [_c('div', {
      staticClass: "var-list__loading-text"
    }, [_vm._v(_vm._s(_vm.dt(_vm.loadingText, _vm.pack.listLoadingText)))]), _vm._v(" "), _c('var-loading', {
      attrs: {
        "size": "mini",
        "radius": 10
      }
    })], 1)];
  }) : _vm._e(), _vm._v(" "), _vm.finished ? _vm._t("finished", function () {
    return [_c('div', {
      staticClass: "var-list__finished"
    }, [_vm._v(_vm._s(_vm.dt(_vm.finishedText, _vm.pack.listFinishedText)))])];
  }) : _vm._e(), _vm._v(" "), _vm.error ? _vm._t("error", function () {
    return [_c('div', {
      directives: [{
        name: "ripple",
        rawName: "v-ripple"
      }],
      staticClass: "var-list__error",
      on: {
        "click": _vm.load
      }
    }, [_vm._v("\n      " + _vm._s(_vm.dt(_vm.errorText, _vm.pack.listErrorText)) + "\n    ")])];
  }) : _vm._e(), _vm._v(" "), _c('div', {
    ref: "detectorEl",
    staticClass: "var-list__detector"
  })], 2);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarList',
  directives: {
    Ripple: _ripple.default
  },
  components: {
    VarLoading: _loading.default
  },
  props: _props.props,
  data: () => ({
    scroller: ''
  }),
  computed: {
    pack() {
      return _locale.pack.value;
    }

  },

  mounted() {
    this.scroller = (0, _elements.getParentScroller)(this.$refs.listEl);
    this.immediateCheck && this.check();
    this.scroller.addEventListener('scroll', this.check);
  },

  beforeDestroy() {
    this.scroller.removeEventListener('scroll', this.check);
  },

  methods: {
    // expose
    check() {
      var _this = this;

      return _asyncToGenerator(function* () {
        yield (0, _create.nextTick)();

        if (!_this.loading && !_this.finished && !_this.error && _this.isReachBottom()) {
          _this.load();
        }
      })();
    },

    isNumber: _shared.isNumber,
    dt: _shared.dt,

    load() {
      var _this$getListeners$on, _this$getListeners, _this$getListeners$on2, _this$getListeners2, _this$getListeners$on3, _this$getListeners3;

      (_this$getListeners$on = (_this$getListeners = this.getListeners())['onUpdate:error']) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, false);
      (_this$getListeners$on2 = (_this$getListeners2 = this.getListeners())['onUpdate:loading']) == null ? void 0 : _this$getListeners$on2.call(_this$getListeners2, true);
      (_this$getListeners$on3 = (_this$getListeners3 = this.getListeners()).onLoad) == null ? void 0 : _this$getListeners$on3.call(_this$getListeners3);
    },

    isReachBottom() {
      var containerBottom = this.scroller === window ? window.innerHeight : this.scroller.getBoundingClientRect().bottom;
      var {
        bottom
      } = this.$refs.detectorEl.getBoundingClientRect(); // The fractional part of the detectorBottom when bottoming out overflows
      // https://github.com/varletjs/varlet/issues/310
      // alert(this.$refs.detectorEl)

      return Math.floor(bottom) - (0, _elements.toPxNum)(this.offset) <= containerBottom;
    }

  }
});

exports.default = _default;