"use strict";

exports.__esModule = true;
exports.props = void 0;
exports.sizeValidator = sizeValidator;
exports.typeValidator = typeValidator;

function typeValidator(type) {
  return ['circle', 'wave', 'cube', 'rect', 'disappear'].includes(type);
}

function sizeValidator(size) {
  return ['normal', 'mini', 'small', 'large'].includes(size);
}

var props = {
  // loading类型
  type: {
    type: String,
    default: 'circle',
    validator: typeValidator
  },
  radius: {
    type: [String, Number]
  },
  // loading尺寸
  size: {
    type: String,
    default: 'normal',
    validator: sizeValidator
  },
  // loading颜色
  color: {
    type: String,
    default: 'currentColor'
  },
  description: {
    type: String
  },
  loading: {
    type: Boolean,
    default: false
  }
};
exports.props = props;