"use strict";

exports.__esModule = true;
exports.default = void 0;

var _checkbox = _interopRequireDefault(require("../checkbox"));

var _ripple = _interopRequireDefault(require("../ripple"));

var _create = require("../utils/create");

var _props = require("./props");

var _relation = require("../utils/mixins/relation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    directives: [{
      name: "ripple",
      rawName: "v-ripple"
    }],
    staticClass: "var-option var--box",
    class: [_vm.optionSelected ? 'var-option--selected-color' : null],
    style: {
      width: _vm.wrapWidth,
      color: _vm.optionSelected ? _vm.focusColor : undefined
    },
    on: {
      "click": _vm.handleClick
    }
  }, [_c('div', {
    staticClass: "var-option__cover",
    class: [_vm.optionSelected ? 'var-option--selected-background' : null],
    style: {
      background: _vm.optionSelected ? _vm.focusColor : undefined
    }
  }), _vm._v(" "), _vm.multiple ? _c('var-checkbox', {
    ref: "checkbox",
    attrs: {
      "checked-color": _vm.focusColor
    },
    on: {
      "click": function ($event) {
        $event.stopPropagation();
      },
      "change": _vm.handleSelect
    },
    model: {
      value: _vm.optionSelected,
      callback: function ($v) {
        _vm.optionSelected = $v;
      },
      expression: "optionSelected"
    }
  }) : _vm._e(), _vm._v(" "), _c('div', {
    staticClass: "var-option__text var--ellipsis"
  }, [_vm._t("default", function () {
    return [_vm._v("\n      " + _vm._s(_vm.label) + "\n    ")];
  })], 2)], 1);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarOption',
  directives: {
    Ripple: _ripple.default
  },
  components: {
    VarCheckbox: _checkbox.default
  },
  mixins: [(0, _relation.createChildrenMixin)('select', {
    childrenKey: 'options'
  })],
  props: _props.props,
  data: () => ({
    optionSelected: false
  }),
  computed: {
    selected() {
      return this.optionSelected;
    },

    wrapWidth() {
      return this.select.wrapWidth;
    },

    multiple() {
      return this.select.multiple;
    },

    focusColor() {
      return this.select.focusColor;
    }

  },
  watch: {
    label: {
      handler() {
        this.checkProps();
      },

      immediate: true
    },
    value: {
      handler() {
        this.checkProps();
      },

      immediate: true
    }
  },
  methods: {
    checkProps() {
      if (this.label == null && this.value == null) {
        throw Error("Props label and value can't both be undefined\n");
      }
    },

    handleClick() {
      var {
        onSelect
      } = this.select;
      this.optionSelected = !this.optionSelected;
      var {
        label,
        value
      } = this;
      onSelect == null ? void 0 : onSelect({
        label,
        value
      });
    },

    handleSelect() {
      var {
        onSelect
      } = this.select.getListeners();
      var {
        label,
        value
      } = this;
      onSelect == null ? void 0 : onSelect({
        label,
        value
      });
    },

    sync(checked) {
      this.optionSelected = checked;
    }

  }
});

exports.default = _default;