"use strict";

exports.__esModule = true;
exports.default = void 0;

var _button = _interopRequireDefault(require("../button"));

var _popup = _interopRequireDefault(require("../popup"));

var _create = require("../utils/create");

var _props = require("./props");

var _shared = require("../utils/shared");

var _elements = require("../utils/elements");

var _locale = require("../locale");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var MOMENTUM_RECORD_TIME = 300;
var MOMENTUM_ALLOW_DISTANCE = 15;
var sid = 0;

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _vm.dynamic ? _c('var-popup', {
    attrs: {
      "var-picker-cover": "",
      "position": "bottom",
      "show": _vm.show,
      "teleport": _vm.teleport,
      "class": 'var-picker__popup',
      "close-on-click-overlay": _vm.closeOnClickOverlay
    },
    on: {
      "open": function ($event) {
        return _vm.$emit('open');
      },
      "opened": function ($event) {
        return _vm.$emit('opened');
      },
      "close": function ($event) {
        return _vm.$emit('close');
      },
      "closed": function ($event) {
        return _vm.$emit('closed');
      },
      "route-change": function ($event) {
        return _vm.$emit('route-change');
      },
      "click-overlay": function ($event) {
        return _vm.$emit('click-overlay');
      },
      "update:show": function (value) {
        return _vm.$emit('update:show', value);
      }
    }
  }, [_c('div', _vm._b({
    staticClass: "var-picker"
  }, 'div', _vm.$attrs, false), [_c('div', {
    staticClass: "var-picker__toolbar"
  }, [_vm._t("cancel", function () {
    return [_c('var-button', {
      staticClass: "var-picker__cancel-button",
      attrs: {
        "var-picker-cover": "",
        "text": "",
        "text-color": _vm.cancelButtonTextColor
      },
      on: {
        "click": _vm.cancel
      }
    }, [_vm._v("\n          " + _vm._s(_vm.dt(_vm.cancelButtonText, _vm.pack.pickerCancelButtonText)) + "\n        ")])];
  }), _vm._v(" "), _vm._t("title", function () {
    return [_c('div', {
      staticClass: "var-picker__title"
    }, [_vm._v(_vm._s(_vm.dt(_vm.title, _vm.pack.pickerTitle)))])];
  }), _vm._v(" "), _vm._t("confirm", function () {
    return [_c('var-button', {
      staticClass: "var-picker__confirm-button",
      attrs: {
        "text": "",
        "var-picker-cover": "",
        "text-color": _vm.confirmButtonTextColor
      },
      on: {
        "click": _vm.confirm
      }
    }, [_vm._v("\n          " + _vm._s(_vm.dt(_vm.confirmButtonText, _vm.pack.pickerConfirmButtonText)) + "\n        ")])];
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-picker__columns",
    style: {
      height: _vm.columnHeight + "px"
    }
  }, [_vm._l(_vm.scrollColumns, function (c) {
    return _c('div', {
      key: c.id,
      staticClass: "var-picker__column",
      on: {
        "touchstart": function ($event) {
          return _vm.handleTouchstart($event, c);
        },
        "touchmove": function ($event) {
          $event.preventDefault();
          return _vm.handleTouchmove($event, c);
        },
        "touchend": function ($event) {
          return _vm.handleTouchend($event, c);
        }
      }
    }, [_c('div', {
      ref: "scrollEl",
      refInFor: true,
      staticClass: "var-picker__scroller",
      style: {
        transform: "translateY(" + c.translate + "px)",
        transitionDuration: c.duration + "ms",
        transitionProperty: c.duration ? 'transform' : 'none'
      },
      on: {
        "transitionend": function ($event) {
          return _vm.handleTransitionend(c);
        }
      }
    }, _vm._l(c.column.texts, function (t) {
      return _c('div', {
        key: t,
        staticClass: "var-picker__option",
        style: {
          height: _vm.localOptionHeight + "px"
        }
      }, [_c('div', {
        staticClass: "var-picker__text"
      }, [_vm._v(_vm._s(_vm.textFormatter(t, c.columnIndex)))])]);
    }), 0)]);
  }), _vm._v(" "), _c('div', {
    staticClass: "var-picker__picked",
    style: {
      top: _vm.center + "px",
      height: _vm.localOptionHeight + "px"
    }
  }), _vm._v(" "), _c('div', {
    staticClass: "var-picker__mask",
    style: {
      backgroundSize: "100% " + (_vm.columnHeight - _vm.localOptionHeight) / 2 + "px"
    }
  })], 2)])]) : _c('transition', {
    attrs: {
      "var-picker-cover": ""
    }
  }, [_c('div', _vm._b({
    staticClass: "var-picker"
  }, 'div', _vm.$attrs, false), [_c('div', {
    staticClass: "var-picker__toolbar"
  }, [_vm._t("cancel", function () {
    return [_c('var-button', {
      staticClass: "var-picker__cancel-button",
      attrs: {
        "var-picker-cover": "",
        "text": "",
        "text-color": _vm.cancelButtonTextColor
      },
      on: {
        "click": _vm.cancel
      }
    }, [_vm._v("\n          " + _vm._s(_vm.dt(_vm.cancelButtonText, _vm.pack.pickerCancelButtonText)) + "\n        ")])];
  }), _vm._v(" "), _vm._t("title", function () {
    return [_c('div', {
      staticClass: "var-picker__title"
    }, [_vm._v(_vm._s(_vm.dt(_vm.title, _vm.pack.pickerTitle)))])];
  }), _vm._v(" "), _vm._t("confirm", function () {
    return [_c('var-button', {
      staticClass: "var-picker__confirm-button",
      attrs: {
        "text": "",
        "var-picker-cover": "",
        "text-color": _vm.confirmButtonTextColor
      },
      on: {
        "click": _vm.confirm
      }
    }, [_vm._v("\n          " + _vm._s(_vm.dt(_vm.confirmButtonText, _vm.pack.pickerConfirmButtonText)) + "\n        ")])];
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-picker__columns",
    style: {
      height: _vm.columnHeight + "px"
    }
  }, [_vm._l(_vm.scrollColumns, function (c) {
    return _c('div', {
      key: c.id,
      staticClass: "var-picker__column",
      on: {
        "touchstart": function ($event) {
          return _vm.handleTouchstart($event, c);
        },
        "touchmove": function ($event) {
          $event.preventDefault();
          return _vm.handleTouchmove($event, c);
        },
        "touchend": function ($event) {
          return _vm.handleTouchend($event, c);
        }
      }
    }, [_c('div', {
      ref: "scrollEl",
      refInFor: true,
      staticClass: "var-picker__scroller",
      style: {
        transform: "translateY(" + c.translate + "px)",
        transitionDuration: c.duration + "ms",
        transitionProperty: c.duration ? 'transform' : 'none'
      },
      on: {
        "transitionend": function ($event) {
          return _vm.handleTransitionend(c);
        }
      }
    }, _vm._l(c.column.texts, function (t) {
      return _c('div', {
        key: t,
        staticClass: "var-picker__option",
        style: {
          height: _vm.localOptionHeight + "px"
        }
      }, [_c('div', {
        staticClass: "var-picker__text"
      }, [_vm._v(_vm._s(_vm.textFormatter(t, c.columnIndex)))])]);
    }), 0)]);
  }), _vm._v(" "), _c('div', {
    staticClass: "var-picker__picked",
    style: {
      top: _vm.center + "px",
      height: _vm.localOptionHeight + "px"
    }
  }), _vm._v(" "), _c('div', {
    staticClass: "var-picker__mask",
    style: {
      backgroundSize: "100% " + (_vm.columnHeight - _vm.localOptionHeight) / 2 + "px"
    }
  })], 2)])]);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarPicker',
  components: {
    VarButton: _button.default,
    VarPopup: _popup.default
  },
  inheritAttrs: false,
  props: _props.props,
  data: () => ({
    scrollColumns: [],
    prevIndexes: []
  }),

  mounted() {
    this.setScrollEls();
  },

  updated() {
    this.setScrollEls();
  },

  computed: {
    pack() {
      return _locale.pack.value;
    },

    localOptionHeight() {
      return (0, _elements.toPxNum)(this.optionHeight);
    },

    localOptionCount() {
      return (0, _elements.toPxNum)(this.optionCount);
    },

    center() {
      return this.localOptionCount * this.localOptionHeight / 2 - this.localOptionHeight / 2;
    },

    columnHeight() {
      return this.localOptionCount * this.localOptionHeight;
    }

  },
  watch: {
    columns: {
      handler(newValue) {
        this.scrollColumns = this.cascade ? this.normalizeCascadeColumns(newValue) : this.normalizeNormalColumns(newValue);
        var {
          indexes
        } = this.getPicked();
        this.prevIndexes = [...indexes];
      },

      immediate: true
    }
  },
  methods: {
    // expose
    confirm() {
      this.stopScroll();
      var {
        texts,
        indexes
      } = this.getPicked();
      this.prevIndexes = [...indexes];
      this.$emit('confirm', texts, indexes);
    },

    // expose
    cancel() {
      this.stopScroll();
      var {
        texts,
        indexes
      } = this.getPicked();
      this.prevIndexes = [...indexes];
      this.$emit('cancel', texts, indexes);
    },

    dt: _shared.dt,

    setScrollEls() {
      if (!this.$refs.scrollEl) {
        return;
      }

      this.scrollColumns.forEach((scrollColumn, index) => {
        scrollColumn.scrollEl = this.$refs.scrollEl[index];
      });
    },

    handlePopupUpdateShow(value) {
      this.$emit('update:show', value);
    },

    limitTranslate(scrollColumn) {
      var START_LIMIT = this.localOptionHeight + this.center;
      var END_LIMIT = this.center - scrollColumn.column.texts.length * this.localOptionHeight;

      if (scrollColumn.translate >= START_LIMIT) {
        scrollColumn.translate = START_LIMIT;
      }

      if (scrollColumn.translate <= END_LIMIT) {
        scrollColumn.translate = END_LIMIT;
      }
    },

    boundaryIndex(scrollColumn, index) {
      var {
        length
      } = scrollColumn.column.texts;
      index = index >= length ? length - 1 : index;
      index = index <= 0 ? 0 : index;
      return index;
    },

    getIndex(scrollColumn) {
      var index = Math.round((this.center - scrollColumn.translate) / this.localOptionHeight);
      return this.boundaryIndex(scrollColumn, index);
    },

    getPicked() {
      var texts = this.scrollColumns.map(scrollColumn => scrollColumn.column.texts[scrollColumn.index]);
      var indexes = this.scrollColumns.map(scrollColumn => scrollColumn.index);
      return {
        texts,
        indexes
      };
    },

    scrollTo(scrollColumn, index, duration, noEmit) {
      if (noEmit === void 0) {
        noEmit = false;
      }

      var translate = this.center - this.boundaryIndex(scrollColumn, index) * this.localOptionHeight;

      if (translate === scrollColumn.translate) {
        scrollColumn.scrolling = false;
        !noEmit && this.change(scrollColumn);
      }

      scrollColumn.translate = translate;
      scrollColumn.duration = duration;
    },

    momentum(scrollColumn, distance, duration) {
      scrollColumn.translate += Math.abs(distance / duration) / 0.003 * (distance < 0 ? -1 : 1);
    },

    handleTouchstart(event, scrollColumn) {
      scrollColumn.touching = true;
      scrollColumn.scrolling = false;
      scrollColumn.duration = 0;
      scrollColumn.translate = (0, _elements.getTranslate)(scrollColumn.scrollEl);
    },

    handleTouchmove(event, scrollColumn) {
      if (!scrollColumn.touching) {
        return;
      }

      var {
        clientY
      } = event.touches[0];
      var moveY = scrollColumn.prevY !== undefined ? clientY - scrollColumn.prevY : 0;
      scrollColumn.prevY = clientY;
      scrollColumn.translate += moveY;
      this.limitTranslate(scrollColumn);
      var now = performance.now();

      if (now - scrollColumn.momentumTime > MOMENTUM_RECORD_TIME) {
        scrollColumn.momentumTime = now;
        scrollColumn.momentumPrevY = scrollColumn.translate;
      }
    },

    handleTouchend(event, scrollColumn) {
      scrollColumn.touching = false;
      scrollColumn.scrolling = true;
      scrollColumn.prevY = undefined;
      var distance = scrollColumn.translate - scrollColumn.momentumPrevY;
      var duration = performance.now() - scrollColumn.momentumTime;
      var shouldMomentum = Math.abs(distance) >= MOMENTUM_ALLOW_DISTANCE && duration <= MOMENTUM_RECORD_TIME;
      shouldMomentum && this.momentum(scrollColumn, distance, duration);
      scrollColumn.index = this.getIndex(scrollColumn);
      this.scrollTo(scrollColumn, scrollColumn.index, shouldMomentum ? 1000 : 200);
    },

    handleTransitionend(scrollColumn) {
      scrollColumn.scrolling = false;
      this.change(scrollColumn);
    },

    normalizeNormalColumns(normalColumns) {
      return normalColumns.map((column, columnIndex) => {
        var _normalColumn$initial;

        var normalColumn = (0, _shared.isArray)(column) ? {
          texts: column
        } : column;
        var scrollColumn = {
          id: sid++,
          prevY: undefined,
          momentumPrevY: undefined,
          touching: false,
          translate: this.center,
          index: (_normalColumn$initial = normalColumn.initialIndex) != null ? _normalColumn$initial : 0,
          columnIndex,
          duration: 0,
          momentumTime: 0,
          column: normalColumn,
          scrollEl: null,
          scrolling: false
        };
        this.scrollTo(scrollColumn, scrollColumn.index, 200);
        return scrollColumn;
      });
    },

    normalizeCascadeColumns(cascadeColumns) {
      var scrollColumns = [];
      this.createChildren(scrollColumns, cascadeColumns, 0);
      return scrollColumns;
    },

    createChildren(scrollColumns, children, columnIndex) {
      if ((0, _shared.isArray)(children) && children.length) {
        var scrollColumn = {
          id: sid++,
          prevY: undefined,
          momentumPrevY: undefined,
          touching: false,
          translate: this.center,
          index: 0,
          columnIndex,
          duration: 0,
          momentumTime: 0,
          column: {
            texts: children.map(cascadeColumn => cascadeColumn[this.textKey])
          },
          columns: children,
          scrollEl: null,
          scrolling: false
        };
        scrollColumns.push(scrollColumn);
        this.createChildren(scrollColumns, scrollColumn.columns[scrollColumn.index].children, columnIndex + 1);
      }
    },

    rebuildChildren(scrollColumn) {
      this.scrollColumns.splice(this.scrollColumns.indexOf(scrollColumn) + 1);
      this.createChildren(this.scrollColumns, scrollColumn.columns[scrollColumn.index].children, scrollColumn.columnIndex + 1);
    },

    change(scrollColumn) {
      var {
        cascade
      } = this;
      cascade && this.rebuildChildren(scrollColumn);
      var hasScrolling = this.scrollColumns.some(scrollColumn => scrollColumn.scrolling);

      if (hasScrolling) {
        return;
      }

      var {
        texts,
        indexes
      } = this.getPicked();
      var samePicked = indexes.every((index, idx) => index === this.prevIndexes[idx]);

      if (samePicked) {
        return;
      }

      this.prevIndexes = [...indexes];
      this.$emit('change', texts, indexes);
    },

    stopScroll() {
      if (this.cascade) {
        var currentScrollColumn = this.scrollColumns.find(scrollColumn => scrollColumn.scrolling);

        if (currentScrollColumn) {
          currentScrollColumn.translate = (0, _elements.getTranslate)(currentScrollColumn.scrollEl);
          currentScrollColumn.index = this.getIndex(currentScrollColumn);
          this.scrollTo(currentScrollColumn, currentScrollColumn.index, 0, true);
          currentScrollColumn.scrolling = false;
          this.rebuildChildren(currentScrollColumn);
        }
      } else {
        this.scrollColumns.forEach(scrollColumn => {
          scrollColumn.translate = (0, _elements.getTranslate)(scrollColumn.scrollEl);
          scrollColumn.index = this.getIndex(scrollColumn);
          this.scrollTo(scrollColumn, scrollColumn.index, 0);
        });
      }
    }

  }
});

exports.default = _default;