"use strict";

exports.__esModule = true;
exports.default = exports._PickerComponent = void 0;

var _Picker = _interopRequireDefault(require("./Picker.js"));

var _vue = _interopRequireDefault(require("vue"));

var _shared = require("../utils/shared");

var _components = require("../utils/components");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var singletonInstance;

function Picker(options) {
  return new Promise(resolve => {
    Picker.close();
    var pickerOptions = (0, _shared.isArray)(options) ? {
      columns: options
    } : options;
    var {
      instance,
      unmount
    } = (0, _components.mountComponent)(_Picker.default, 'body', {
      propsData: _extends({}, pickerOptions, {
        dynamic: true
      })
    });
    instance.show = true;
    singletonInstance = instance;
    instance.$on('open', () => pickerOptions.onOpen == null ? void 0 : pickerOptions.onOpen());
    instance.$on('opened', () => pickerOptions.onOpened == null ? void 0 : pickerOptions.onOpened());
    instance.$on('close', () => {
      pickerOptions.onClose == null ? void 0 : pickerOptions.onClose();
      resolve({
        state: 'close'
      });
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('closed', () => {
      pickerOptions.onClosed == null ? void 0 : pickerOptions.onClosed();
      unmount();
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('change', (texts, indexes) => {
      pickerOptions.onChange == null ? void 0 : pickerOptions.onChange(texts, indexes);
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('confirm', (texts, indexes) => {
      pickerOptions.onConfirm == null ? void 0 : pickerOptions.onConfirm(texts, indexes);
      resolve({
        state: 'confirm',
        texts,
        indexes
      });
      instance.show = false;
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('cancel', (texts, indexes) => {
      pickerOptions.onCancel == null ? void 0 : pickerOptions.onCancel(texts, indexes);
      resolve({
        state: 'cancel',
        texts,
        indexes
      });
      instance.show = false;
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('route-change', () => {
      unmount();
      singletonInstance === instance && (singletonInstance = null);
    });
    instance.$on('update:show', value => {
      instance.show = value;
    });
    instance.show = true;
  });
}

_Picker.default.install = function (app) {
  app.component(_Picker.default.name, _Picker.default);
};

Picker.Component = _Picker.default;

Picker.install = function (app) {
  app.component(_Picker.default.name, _Picker.default);
};

Picker.close = () => {
  if (singletonInstance != null) {
    var prevSingletonInstance = singletonInstance;
    singletonInstance = null;

    _vue.default.nextTick().then(() => {
      prevSingletonInstance.show = false;
    });
  }
};

var _PickerComponent = _Picker.default;
exports._PickerComponent = _PickerComponent;
var _default = Picker;
exports.default = _default;