"use strict";

exports.__esModule = true;
exports.default = void 0;

var _create = require("../utils/create");

var _props = require("./props");

var _lock = require("../context/lock");

var _teleport = _interopRequireDefault(require("../teleport"));

var _components = require("../utils/components");

var _zIndex = require("../utils/mixins/zIndex");

var _teleport2 = require("../utils/mixins/teleport");

var _shared = require("../utils/shared");





function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var _default = (0, _create.defineComponent)({
  name: 'VarPopup',
  inheritAttrs: false,
  mixins: [(0, _zIndex.createZIndexMixin)('show', 3), _teleport2.createTeleportMixin, (0, _lock.createLockMixin)('show', 'lockScroll')],
  props: _props.props,

  created() {
    // internal for Dialog
    (0, _components.addRouteListener)(this, () => {
      var _this$getListeners;

      return (_this$getListeners = this.getListeners()) == null ? void 0 : _this$getListeners.onRouteChange == null ? void 0 : _this$getListeners.onRouteChange();
    });
  },

  watch: {
    show(newValue) {
      var {
        onOpen,
        onClose
      } = this.getListeners();
      newValue ? onOpen == null ? void 0 : onOpen() : onClose == null ? void 0 : onClose();
    }

  },
  methods: {
    hidePopup() {
      var _getListeners, _getListeners$onUpdat, _getListeners2;

      var {
        closeOnClickOverlay,
        getListeners
      } = this;
      (_getListeners = getListeners()) == null ? void 0 : _getListeners.onClickOverlay == null ? void 0 : _getListeners.onClickOverlay();
      if (!closeOnClickOverlay) return;
      (_getListeners$onUpdat = (_getListeners2 = getListeners())['onUpdate:show']) == null ? void 0 : _getListeners$onUpdat.call(_getListeners2, false);
    },

    renderOverlay() {
      var _this = this;

      var h = this.$createElement;
      return h("div", {
        "class": ['var-popup__overlay', this.overlayClass],
        "style": _extends({
          zIndex: this.zIndex - 1
        }, this.overlayStyle),
        "on": _extends({}, {
          "click": function ($event) {
            for (var _len = arguments.length, attrs = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
              attrs[_key - 1] = arguments[_key];
            }

            _this.hidePopup($event, ...attrs);
          }
        })
      });
    },

    renderContent() {
      var h = this.$createElement;
      return h("div", {
        "class": ['var-popup__content', 'var-elevation--3', "var-popup--" + this.position, this.$attrs.class],
        "style": {
          zIndex: this.zIndex
        },
        "attrs": _extends({}, this.$attrs)
      }, [this.slots('default')]);
    },

    renderPopup() {
      var _this2 = this;

      var h = this.$createElement;
      return h("transition", {
        "attrs": {
          "name": "var-fade"
        },
        "on": _extends({}, {
          "afterEnter": function ($event) {
            var _this2$getListeners$o;

            for (var _len2 = arguments.length, attrs = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
              attrs[_key2 - 1] = arguments[_key2];
            }

            ((_this2$getListeners$o = _this2.getListeners().onOpened) != null ? _this2$getListeners$o : _shared.NOOP)($event, ...attrs);
          },
          "afterLeave": function ($event) {
            var _this2$getListeners$o2;

            for (var _len3 = arguments.length, attrs = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
              attrs[_key3 - 1] = arguments[_key3];
            }

            ((_this2$getListeners$o2 = _this2.getListeners().onClosed) != null ? _this2$getListeners$o2 : _shared.NOOP)($event, ...attrs);
          }
        })
      }, [h("div", {
        "class": "var--box var-popup",
        "style": {
          zIndex: this.zIndex - 2
        },
        "directives": [{
          name: "show",
          value: this.show
        }]
      }, [this.overlay && this.renderOverlay(), h("transition", {
        "attrs": {
          "name": this.transition || "var-pop-" + this.position
        }
      }, [this.show && this.renderContent()])])]);
    }

  },

  render() {
    var h = arguments[0];
    return this.teleport ? h(_teleport.default, {
      "attrs": {
        "to": this.teleport,
        "disabled": this.teleportDisabled
      }
    }, [this.renderPopup()]) : this.renderPopup();
  }

});

exports.default = _default;