"use strict";

exports.__esModule = true;
exports.default = void 0;

var _create = require("../utils/create");

var _props = require("./props");

var _shared = require("../utils/shared");

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-progress"
  }, [_vm.mode === 'linear' ? _c('div', {
    staticClass: "var-progress-linear"
  }, [_c('div', _vm._b({
    staticClass: "var-progress-linear__block",
    style: {
      height: _vm.lineWidth + "px"
    }
  }, 'div', _vm.$attrs, false), [_vm.track ? _c('div', {
    staticClass: "var-progress-linear__background",
    style: {
      background: _vm.trackColor
    }
  }) : _vm._e(), _vm._v(" "), _c('div', {
    class: "var-progress-linear__certain" + (_vm.ripple ? ' var-progress-linear__ripple' : ''),
    style: {
      background: _vm.color,
      width: _vm.linearProps.width
    }
  })]), _vm._v(" "), _vm.label ? _c('div', _vm._b({
    staticClass: "var-progress-linear__label"
  }, 'div', _vm.$attrs, false), [_vm._t("default", function () {
    return [_vm._v("\n        " + _vm._s(_vm.linearProps.roundValue) + "\n      ")];
  })], 2) : _vm._e()]) : _vm._e(), _vm._v(" "), _vm.mode === 'circle' ? _c('div', {
    staticClass: "var-progress-circle",
    style: {
      width: _vm.size + "px",
      height: _vm.size + "px"
    }
  }, [_c('svg', {
    staticClass: "var-progress-circle__svg",
    style: {
      transform: "rotate(" + (_vm.rotate - 90) + "deg)"
    },
    attrs: {
      "viewBox": _vm.circleProps.viewBox
    }
  }, [_vm.track ? _c('circle', {
    staticClass: "var-progress-circle__background",
    style: {
      strokeDasharray: _vm.circleProps.perimeter,
      stroke: _vm.trackColor
    },
    attrs: {
      "cx": _vm.size / 2,
      "cy": _vm.size / 2,
      "r": _vm.circleProps.radius,
      "fill": "transparent",
      "stroke-width": _vm.lineWidth
    }
  }) : _vm._e(), _vm._v(" "), _c('circle', {
    staticClass: "var-progress-circle__certain",
    style: {
      strokeDasharray: _vm.circleProps.strokeDasharray,
      stroke: _vm.color
    },
    attrs: {
      "cx": _vm.size / 2,
      "cy": _vm.size / 2,
      "r": _vm.circleProps.radius,
      "fill": "transparent",
      "stroke-width": _vm.lineWidth
    }
  })]), _vm._v(" "), _vm.label ? _c('div', _vm._b({
    staticClass: "var-progress-circle__label"
  }, 'div', _vm.$attrs, false), [_vm._t("default", function () {
    return [_vm._v("\n        " + _vm._s(_vm.circleProps.roundValue) + "\n      ")];
  })], 2) : _vm._e()]) : _vm._e()]);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarProgress',
  inheritAttrs: false,
  props: _props.props,
  computed: {
    linearProps() {
      var value = (0, _shared.toNumber)(this.value);
      var width = (value > 100 ? 100 : value) + "%";
      var roundValue = (value > 100 ? 100 : Math.round(value)) + "%";
      return {
        width,
        roundValue
      };
    },

    circleProps() {
      var {
        size,
        lineWidth,
        value
      } = this;
      var viewBox = "0 0 " + size + " " + size;
      var roundValue = (0, _shared.toNumber)(value) > 100 ? 100 : Math.round((0, _shared.toNumber)(value));
      var radius = (size - (0, _shared.toNumber)(lineWidth)) / 2;
      var perimeter = 2 * Math.PI * radius;
      var strokeDasharray = roundValue / 100 * perimeter + ", " + perimeter;
      return {
        viewBox,
        roundValue: roundValue + "%",
        radius,
        perimeter,
        strokeDasharray
      };
    }

  }
});

exports.default = _default;