"use strict";

exports.__esModule = true;
exports.default = void 0;

var _formDetails = _interopRequireDefault(require("../form-details"));

var _props = require("./props");

var _create = require("../utils/create");

var _validation = require("../utils/mixins/validation");

var _relation = require("../utils/mixins/relation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-radio-group__wrap"
  }, [_c('div', {
    staticClass: "var-radio-group",
    class: ["var-radio-group--" + _vm.direction]
  }, [_vm._t("default")], 2), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarRadioGroup',
  mixins: [_validation.ValidationMixin, (0, _relation.createParentMixin)('radioGroup', {
    childrenKey: 'radios'
  }), (0, _relation.createChildrenMixin)('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  components: {
    VarFormDetails: _formDetails.default
  },
  props: _props.props,
  computed: {
    radioGroupErrorMessage() {
      return this.errorMessage;
    }

  },
  watch: {
    value() {
      this.syncRadios();
    },

    radios() {
      this.syncRadios();
    }

  },
  methods: {
    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    // expose
    reset() {
      var _this$getListeners$on, _this$getListeners;

      (_this$getListeners$on = (_this$getListeners = this.getListeners()).onInput) == null ? void 0 : _this$getListeners$on.call(_this$getListeners, undefined);
      this.resetValidation();
    },

    validateWithTrigger(trigger) {
      this.$nextTick(() => {
        var {
          validateTrigger,
          rules,
          value
        } = this;

        this._validateWithTrigger(validateTrigger, trigger, rules, value);
      });
    },

    syncRadios() {
      this.radios.forEach(_ref => {
        var {
          sync
        } = _ref;
        return sync(this.value);
      });
    },

    onToggle(changedValue) {
      var {
        onInput,
        onChange
      } = this.getListeners();
      onInput == null ? void 0 : onInput(changedValue);
      onChange == null ? void 0 : onChange(changedValue);
      this.validateWithTrigger('onChange');
    }

  }
});

exports.default = _default;