"use strict";

exports.__esModule = true;
exports.default = void 0;

var _icon = _interopRequireDefault(require("../icon"));

var _menu = _interopRequireDefault(require("../menu"));

var _chip = _interopRequireDefault(require("../chip"));

var _formDetails = _interopRequireDefault(require("../form-details"));

var _create = require("../utils/create");

var _shared = require("../utils/shared");

var _props = require("./props");

var _elements = require("../utils/elements");

var _validation = require("../utils/mixins/validation");

var _relation = require("../utils/mixins/relation");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-select var--box",
    class: [_vm.formDisabled || _vm.disabled ? 'var-select--disabled' : null],
    on: {
      "click": _vm.handleClick
    }
  }, [_c('div', {
    staticClass: "var-select__controller",
    class: [_vm.isFocus ? 'var-select--focus' : null, _vm.errorMessage ? 'var-select--error' : null, _vm.formDisabled || _vm.disabled ? 'var-select--disabled' : null],
    style: {
      color: !_vm.errorMessage ? _vm.isFocus ? _vm.focusColor : _vm.blurColor : undefined
    }
  }, [_c('div', {
    staticClass: "var-select__icon",
    class: [!_vm.hint ? 'var-select--non-hint' : null]
  }, [_vm._t("prepend-icon")], 2), _vm._v(" "), _c('var-menu', {
    staticClass: "var-select__menu",
    attrs: {
      "var-select-cover": "",
      "offset-y": _vm.localOffsetY,
      "show": _vm.isFocus
    },
    on: {
      "update:show": function ($event) {
        _vm.isFocus = $event;
      },
      "close": _vm.handleBlur
    },
    scopedSlots: _vm._u([{
      key: "menu",
      fn: function () {
        return [_c('div', {
          staticClass: "var-select__scroller"
        }, [_vm._t("default")], 2)];
      },
      proxy: true
    }], null, true)
  }, [_c('div', {
    ref: "wrapEl",
    staticClass: "var-select__wrap",
    class: [!_vm.hint ? 'var-select--non-hint' : null],
    on: {
      "click": _vm.handleFocus
    }
  }, [_c('div', {
    staticClass: "var-select__select",
    class: [_vm.errorMessage ? 'var-select--error' : null, _vm.formDisabled || _vm.disabled ? 'var-select--disabled' : null],
    style: {
      textAlign: _vm.textAlign,
      color: _vm.textColor
    }
  }, [_vm.multiple ? _c('div', [_vm.chip ? _c('div', {
    staticClass: "var-select__chips"
  }, _vm._l(_vm.labels, function (l) {
    return _c('var-chip', {
      key: l,
      staticClass: "var-select__chip",
      attrs: {
        "var-select-cover": "",
        "closable": "",
        "size": "small",
        "type": _vm.errorMessage ? 'danger' : undefined
      },
      on: {
        "click": function ($event) {
          $event.stopPropagation();
        },
        "close": function () {
          return _vm.handleClose(l);
        }
      }
    }, [_vm._v("\n                " + _vm._s(l) + "\n              ")]);
  }), 1) : _c('div', {
    staticClass: "var-select__values"
  }, [_vm._v("\n              " + _vm._s(_vm.labels.join(_vm.separator)) + "\n            ")])]) : _c('span', [_vm._v(_vm._s(_vm.label))]), _vm._v(" "), _c('var-icon', {
    staticClass: "var-select__arrow",
    class: [_vm.isFocus ? 'var-select--arrow-rotate' : null],
    attrs: {
      "var-select-cover": "",
      "name": "menu-down",
      "transition": 300
    }
  })], 1), _vm._v(" "), _c('label', {
    staticClass: "var-select__placeholder var--ellipsis",
    class: [_vm.isFocus ? 'var-select--focus' : null, _vm.errorMessage ? 'var-select--error' : null, _vm.formDisabled || _vm.disabled ? 'var-select--disabled' : null, _vm.computePlaceholderState(), !_vm.hint ? 'var-select--placeholder-non-hint' : null],
    style: {
      color: !_vm.errorMessage ? _vm.isFocus ? _vm.focusColor : _vm.blurColor : undefined
    }
  }, [_vm._v("\n          " + _vm._s(_vm.placeholder) + "\n        ")])])]), _vm._v(" "), _c('div', {
    staticClass: "var-select__icon",
    class: [!_vm.hint ? 'var-select--non-hint' : null]
  }, [_vm._t("append-icon", function () {
    return [_vm.clearable ? _c('var-icon', {
      staticClass: "var-select__clear-icon",
      attrs: {
        "name": "close-circle",
        "size": "14px"
      },
      on: {
        "click": _vm.handleClear
      }
    }) : _vm._e()];
  })], 2)], 1), _vm._v(" "), _vm.line ? _c('div', {
    staticClass: "var-select__line",
    class: [_vm.formDisabled || _vm.disabled ? 'var-select--line-disabled' : null, _vm.errorMessage ? 'var-select--line-error' : null],
    style: {
      background: !_vm.errorMessage ? _vm.blurColor : undefined
    }
  }, [_c('div', {
    staticClass: "var-select__dot",
    class: [_vm.isFocus ? 'var-select--spread' : null, _vm.formDisabled || _vm.disabled ? 'var-select--line-disabled' : null, _vm.errorMessage ? 'var-select--line-error' : null],
    style: {
      background: !_vm.errorMessage ? _vm.focusColor : undefined
    }
  })]) : _vm._e(), _vm._v(" "), _c('var-form-details', {
    attrs: {
      "error-message": _vm.errorMessage
    }
  })], 1);
};

var staticRenderFns = [];

var _default = (0, _create.defineComponent)({
  render,
  staticRenderFns,
  name: 'VarSelect',
  components: {
    VarIcon: _icon.default,
    VarMenu: _menu.default,
    VarChip: _chip.default,
    VarFormDetails: _formDetails.default
  },
  mixins: [_validation.ValidationMixin, (0, _relation.createParentMixin)('select', {
    childrenKey: 'options'
  }), (0, _relation.createChildrenMixin)('form', {
    parentKey: 'form',
    childrenKey: 'formItems'
  })],
  props: _props.props,
  data: () => ({
    isFocus: false,
    label: '',
    labels: [],
    wrapWidth: '0px',
    localOffsetY: 0
  }),
  computed: {
    formReadonly() {
      var _this$form;

      return (_this$form = this.form) == null ? void 0 : _this$form.readonly;
    },

    formDisabled() {
      var _this$form2;

      return (_this$form2 = this.form) == null ? void 0 : _this$form2.disabled;
    }

  },
  watch: {
    value() {
      this.syncOptions();
    },

    options() {
      this.syncOptions();
    },

    multiple(multiple) {
      if (multiple && !(0, _shared.isArray)(this.value)) {
        throw Error('The value must be an array when multiple is true');
      }
    }

  },
  methods: {
    // expose
    focus() {
      this.wrapWidth = this.getWrapWidth();
      this.localOffsetY = this.getOffsetY() + (0, _elements.toPxNum)(this.offsetY);
      this.isFocus = true;
    },

    // expose
    blur() {
      this.isFocus = false;
    },

    // expose
    validate() {
      return this._validate(this.rules, this.value);
    },

    // expose
    reset() {
      var {
        onInput
      } = this.getListeners();
      onInput == null ? void 0 : onInput(this.multiple ? [] : undefined);
      this.resetValidation();
    },

    computeLabel() {
      var {
        multiple,
        value
      } = this;

      if (multiple) {
        var rawModelValue = value;
        this.labels = rawModelValue.map(this.findLabel);
      }

      if (!multiple && !(0, _shared.isEmpty)(value)) {
        this.label = this.findLabel(value);
      }

      if (!multiple && (0, _shared.isEmpty)(value)) {
        this.label = '';
      }
    },

    findValueOrLabel(_ref) {
      var {
        value,
        label
      } = _ref;

      if (value != null) {
        return value;
      }

      return label;
    },

    findLabel(value) {
      var {
        options
      } = this;

      if (!options.length) {
        return;
      }

      var option = options.find(option => option.value === value);

      if (!option) {
        option = options.find(option => option.label === value);
      }

      return option.label;
    },

    computePlaceholderState() {
      var {
        hint,
        value,
        isFocus
      } = this;

      if (!hint && !(0, _shared.isEmpty)(value)) {
        return 'var-select--placeholder-hidden';
      }

      if (hint && (!(0, _shared.isEmpty)(value) || isFocus)) {
        return 'var-select--placeholder-hint';
      }
    },

    getWrapWidth() {
      var {
        wrapEl
      } = this.$refs;
      return wrapEl && window.getComputedStyle(wrapEl).width || '0px';
    },

    getOffsetY() {
      var {
        wrapEl
      } = this.$refs;
      var paddingTop = wrapEl && window.getComputedStyle(wrapEl).paddingTop || '0px';
      return (0, _elements.toPxNum)(paddingTop) * 1.5;
    },

    handleFocus() {
      var {
        disabled,
        readonly,
        formReadonly,
        formDisabled,
        getWrapWidth,
        getOffsetY
      } = this;
      var {
        onFocus
      } = this.getListeners();

      if (formDisabled || formReadonly || disabled || readonly) {
        return;
      }

      this.wrapWidth = getWrapWidth();
      this.localOffsetY = getOffsetY() + (0, _elements.toPxNum)(this.offsetY);
      this.isFocus = true;
      onFocus == null ? void 0 : onFocus();
      this.validateWithTrigger('onFocus');
    },

    handleBlur() {
      var {
        onBlur
      } = this.getListeners();
      var {
        disabled,
        readonly,
        formReadonly,
        formDisabled
      } = this;

      if (formDisabled || formReadonly || disabled || readonly) {
        return;
      }

      onBlur == null ? void 0 : onBlur();
      this.validateWithTrigger('onBlur');
    },

    onSelect(option) {
      var {
        onChange,
        onInput
      } = this.getListeners();
      var {
        disabled,
        readonly,
        multiple,
        options
      } = this;

      if (this.formDisabled || this.formReadonly || disabled || readonly) {
        return;
      }

      var selectedValue = multiple ? options.filter(_ref2 => {
        var {
          selected
        } = _ref2;
        return selected;
      }).map(this.findValueOrLabel) : this.findValueOrLabel(option);
      onInput == null ? void 0 : onInput(selectedValue);
      onChange == null ? void 0 : onChange(selectedValue);
      this.validateWithTrigger('onChange');
      !multiple && (this.isFocus = false);
    },

    handleClear() {
      var {
        onClear,
        onInput
      } = this.getListeners();
      var {
        disabled,
        readonly,
        multiple,
        clearable,
        formDisabled,
        formReadonly
      } = this;

      if (formDisabled || formReadonly || disabled || readonly || !clearable) {
        return;
      }

      var changedModelValue = multiple ? [] : undefined;
      onInput == null ? void 0 : onInput(changedModelValue);
      onClear == null ? void 0 : onClear(changedModelValue);
      this.validateWithTrigger('onClear');
    },

    handleClick(e) {
      var {
        disabled,
        formDisabled
      } = this;
      var {
        onClick
      } = this.getListeners();

      if (formDisabled || disabled) {
        return;
      }

      onClick == null ? void 0 : onClick(e);
      this.validateWithTrigger('onClick');
    },

    validateWithTrigger(trigger) {
      var _this = this;

      return _asyncToGenerator(function* () {
        yield _this.$nextTick();
        var {
          validateTrigger,
          rules,
          value
        } = _this;

        _this._validateWithTrigger(validateTrigger, trigger, rules, value);
      })();
    },

    handleClose(text) {
      var {
        onClose,
        onInput
      } = this.getListeners();
      var {
        disabled,
        readonly,
        value,
        formDisabled,
        formReadonly,
        options
      } = this;

      if (formDisabled || formReadonly || disabled || readonly) {
        return;
      }

      var rawModelValue = value;
      var option = options.find(_ref3 => {
        var {
          label
        } = _ref3;
        return label === text;
      });
      var currentModelValue = rawModelValue.filter(value => {
        var _option$value;

        return value !== ((_option$value = option.value) != null ? _option$value : option.label);
      });
      onInput == null ? void 0 : onInput(currentModelValue);
      onClose == null ? void 0 : onClose(currentModelValue);
      this.validateWithTrigger('onClose');
    },

    syncOptions() {
      var {
        multiple,
        value,
        findValueOrLabel,
        computeLabel,
        options
      } = this;

      if (multiple) {
        var rawModelValue = value;
        options.forEach(option => option.sync(rawModelValue.includes(findValueOrLabel(option))));
      } else {
        options.forEach(option => option.sync(value === findValueOrLabel(option)));
      }

      computeLabel();
    }

  }
});

exports.default = _default;