"use strict";

exports.__esModule = true;
exports.default = void 0;

var _loading = _interopRequireDefault(require("../loading"));

var _icon = _interopRequireDefault(require("../icon"));

var _zIndex = require("../utils/mixins/zIndex");

var _lock = require("../context/lock");

var _props = require("./props");

var _index = require("./index");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var render = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticClass: "var-snackbar",
    style: {
      pointerEvents: _vm.isForbidClick ? 'auto' : 'none',
      zIndex: _vm.zIndex
    }
  }, [_c('div', {
    class: _vm.snackbarClass,
    style: {
      zIndex: _vm.zIndex
    }
  }, [_c('div', {
    staticClass: "var-snackbar__content",
    class: [_vm.contentClass]
  }, [_vm._t("default", function () {
    return [_vm._v(_vm._s(_vm.content))];
  })], 2), _vm._v(" "), _c('div', {
    staticClass: "var-snackbar__action"
  }, [_vm.iconName ? _c('var-icon', {
    attrs: {
      "name": _vm.iconName
    }
  }) : _vm._e(), _vm._v(" "), _vm.type === 'loading' ? _c('var-loading', {
    attrs: {
      "type": _vm.loadingType,
      "size": _vm.loadingSize
    }
  }) : _vm._e(), _vm._v(" "), _vm._t("action")], 2)])]);
};

var staticRenderFns = [];
var _default = {
  render,
  staticRenderFns,
  name: 'VarSnackbarCore',
  components: {
    VarLoading: _loading.default,
    VarIcon: _icon.default
  },
  mixins: [(0, _zIndex.createZIndexMixin)('show', 1), (0, _lock.createLockMixin)('show', 'lockScroll')],
  props: _props.props,
  data: () => ({
    timer: null,
    ICON_TYPE_DICT: {
      success: 'checkbox-marked-circle',
      warning: 'warning',
      info: 'information',
      error: 'error',
      loading: ''
    }
  }),
  computed: {
    snackbarClass() {
      var {
        position,
        vertical,
        type
      } = this;
      var baseClass = "var-snackbar__wrapper var-snackbar__wrapper-" + position + " var-elevation--4";
      var verticalClass = vertical ? ' var-snackbar__vertical' : '';
      var typeClass = type && _index.SNACKBAR_TYPE.includes(type) ? " var-snackbar__wrapper-" + type : '';
      return "" + baseClass + verticalClass + typeClass;
    },

    isForbidClick() {
      return this.type === 'loading' || this.forbidClick;
    },

    iconName() {
      if (!this.type) return '';
      return this.ICON_TYPE_DICT[this.type];
    }

  },
  watch: {
    show(show) {
      if (show) {
        this.$emit('open');
        this.updateAfterDuration();
      } else if (show === false) {
        clearTimeout(this.timer);
        this.$emit('close');
      }
    },

    customUpdate() {
      clearTimeout(this.timer);
      this.updateAfterDuration();
    }

  },

  mounted() {
    if (this.show) {
      this.$emit('open');
      this.updateAfterDuration();
    }
  },

  methods: {
    updateAfterDuration() {
      this.timer = setTimeout(() => {
        this.$emit('update:show', false);
      }, this.duration);
    }

  }
};
exports.default = _default;