"use strict";

exports.__esModule = true;
exports.sizeValidator = exports.props = exports.internalSizeValidator = void 0;

var _shared = require("../utils/shared");

var internalSizeValidator = size => ['mini', 'small', 'normal', 'large'].includes(size);

exports.internalSizeValidator = internalSizeValidator;

var sizeValidator = size => {
  return internalSizeValidator(size) || (0, _shared.isArray)(size) || (0, _shared.isNumber)(size) || (0, _shared.isString)(size);
};

exports.sizeValidator = sizeValidator;

var justifyValidator = justify => {
  return ['start', 'end', 'center', 'space-around', 'space-between'].includes(justify);
};

var props = {
  align: {
    type: String
  },
  size: {
    type: [String, Number, Array],
    default: 'normal',
    validator: sizeValidator
  },
  wrap: {
    type: Boolean,
    default: true
  },
  direction: {
    type: String,
    default: 'row'
  },
  justify: {
    type: String,
    default: 'start',
    validator: justifyValidator
  },
  inline: {
    type: Boolean,
    default: false
  }
};
exports.props = props;