"use strict";

exports.__esModule = true;
exports.default = exports._StyleProviderComponent = void 0;

var _StyleProvider = _interopRequireDefault(require("./StyleProvider.js"));

var _elements = require("../utils/elements");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mountedVarKeys = [];

function StyleProvider(styleVars) {
  if (styleVars === void 0) {
    styleVars = {};
  }

  mountedVarKeys.forEach(key => document.documentElement.style.removeProperty(key));
  mountedVarKeys.length = 0;
  var styles = (0, _elements.formatStyleVars)(styleVars);
  Object.entries(styles).forEach(_ref => {
    var [key, value] = _ref;
    document.documentElement.style.setProperty(key, value);
    mountedVarKeys.push(key);
  });
}

StyleProvider.Component = _StyleProvider.default;

_StyleProvider.default.install = function (app) {
  app.component(_StyleProvider.default.name, _StyleProvider.default);
};

StyleProvider.install = function (app) {
  app.component(_StyleProvider.default.name, _StyleProvider.default);
};

var _StyleProviderComponent = _StyleProvider.default;
exports._StyleProviderComponent = _StyleProviderComponent;
var _default = StyleProvider;
exports.default = _default;