"use strict";

exports.__esModule = true;
exports.props = void 0;

var _components = require("../utils/components");

var _props = require("../sticky/props");

function directionValidator(direction) {
  return ['horizontal', 'vertical'].includes(direction);
}

var props = {
  active: {
    type: [String, Number],
    default: 0
  },
  layoutDirection: {
    type: String,
    default: 'horizontal',
    validator: directionValidator
  },
  itemDirection: {
    type: String,
    default: 'horizontal',
    validator: directionValidator
  },
  fixedBottom: {
    type: Boolean,
    default: false
  },
  activeColor: {
    type: String
  },
  inactiveColor: {
    type: String
  },
  disabledColor: {
    type: String
  },
  color: {
    type: String
  },
  indicatorColor: {
    type: String
  },
  indicatorSize: {
    type: [String, Number]
  },
  elevation: {
    type: Boolean,
    default: false
  },
  sticky: {
    type: Boolean,
    default: false
  },
  offsetTop: (0, _components.pickProps)(_props.props, 'offsetTop')
};
exports.props = props;