"use strict";

exports.__esModule = true;
exports.default = void 0;

var _vue = _interopRequireDefault(require("vue"));

var _props = require("./props");

var _create = require("../utils/create");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _default = (0, _create.defineComponent)({
  name: 'VarTeleport',
  props: _props.props,
  data: () => ({
    el: null,
    instance: null
  }),
  watch: {
    disabled() {
      this.transfer();
    },

    to() {
      this.transfer();
    }

  },
  methods: {
    create() {
      var h = this.$createElement;
      this.instance = new (_vue.default.extend({
        render: () => h("div", {
          "class": "var-teleport__container"
        }, [this.slots()])
      }))();
      this.instance.$parent = this;
      this.el = this.instance.$mount().$el;
    },

    transfer() {
      var container = this.disabled ? this.$refs.teleport : document.querySelector(this.to);
      var parentNode = this.el.parentNode;

      if (parentNode === container) {
        return;
      }

      parentNode == null ? void 0 : parentNode.removeChild(this.el);
      container.appendChild(this.el);
    }

  },

  updated() {
    this.instance.$forceUpdate();
  },

  mounted() {
    this.create();
    this.transfer();
  },

  deactivated() {
    var _this$el$parentNode;

    (_this$el$parentNode = this.el.parentNode) == null ? void 0 : _this$el$parentNode.removeChild(this.el);
  },

  activated() {
    this.transfer();
  },

  beforeDestroy() {
    var _this$el$parentNode2;

    this.instance.$destroy();
    (_this$el$parentNode2 = this.el.parentNode) == null ? void 0 : _this$el$parentNode2.removeChild(this.el);
  },

  render() {
    var h = arguments[0];
    return h("div", {
      "ref": "teleport",
      "class": "var-teleport"
    });
  }

});

exports.default = _default;