"use strict";

exports.__esModule = true;
exports.props = exports.minSec = exports.hoursAmpm = exports.hours24 = void 0;
var hoursAmpm = ['12', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11'];
exports.hoursAmpm = hoursAmpm;
var hours24 = ['00', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23'];
exports.hours24 = hours24;
var minSec = ['00', '05', '10', '15', '20', '25', '30', '35', '40', '45', '50', '55'];
exports.minSec = minSec;

function formatValidator(type) {
  return ['ampm', '24hr'].includes(type);
}

var props = {
  value: {
    type: String
  },
  shadow: {
    type: Boolean,
    default: false
  },
  color: {
    type: String
  },
  headerColor: {
    type: String
  },
  format: {
    type: String,
    default: 'ampm',
    validator: formatValidator
  },
  allowedTime: {
    type: Object
  },
  min: {
    type: String
  },
  max: {
    type: String
  },
  useSeconds: {
    type: Boolean,
    default: false
  },
  readonly: {
    type: Boolean,
    default: false
  }
};
exports.props = props;