"use strict";

exports.__esModule = true;
exports.defineComponent = defineComponent;
exports.mergeSlots = mergeSlots;
exports.nextTick = nextTick;

var _vue = _interopRequireDefault(require("vue"));

var _slots = require("./mixins/slots");

var _listeners = require("./mixins/listeners");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function nextTick() {
  return new Promise(_vue.default.nextTick);
}

function mergeSlots(context) {
  var _ref, _context$scopedSlots;

  var scopedSlots = (_ref = (_context$scopedSlots = context.scopedSlots) != null ? _context$scopedSlots : context.data.scopedSlots) != null ? _ref : {};
  var slots = context.slots();
  Object.keys(slots).forEach(key => {
    if (!scopedSlots[key]) {
      scopedSlots[key] = () => slots[key];
    }
  });
  return scopedSlots;
}

function defineComponent(sfc) {
  if (sfc.mixins) {
    sfc.mixins.push(_slots.SlotsMixin);
    sfc.mixins.push(_listeners.ListenersMixin);
  } else {
    sfc.mixins = [_slots.SlotsMixin, _listeners.ListenersMixin];
  }

  return sfc;
}