"use strict";

exports.__esModule = true;
exports.createZIndexMixin = createZIndexMixin;

var _context = _interopRequireDefault(require("../../context"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createZIndexMixin(state, count) {
  if (count === void 0) {
    count = 1;
  }

  return {
    data: () => ({
      zIndex: _context.default.zIndex
    }),
    watch: {
      [state]: {
        handler(newValue) {
          if (newValue) {
            _context.default.zIndex += count;
            this.zIndex = _context.default.zIndex;
          }
        },

        immediate: true
      }
    }
  };
}